"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.isIntegrationPoint=exports.adjustTokenSVGTagName=exports.adjustTokenXMLAttrs=exports.adjustTokenSVGAttrs=exports.adjustTokenMathMLAttrs=exports.causesExit=exports.SVG_TAG_NAMES_ADJUSTMENT_MAP=void 0;const html_js_1=require("./html.js"),MIME_TYPES={TEXT_HTML:"text/html",APPLICATION_XML:"application/xhtml+xml"},DEFINITION_URL_ATTR="definitionurl",ADJUSTED_DEFINITION_URL_ATTR="definitionURL",SVG_ATTRS_ADJUSTMENT_MAP=new Map(["attributeName","attributeType","baseFrequency","baseProfile","calcMode","clipPathUnits","diffuseConstant","edgeMode","filterUnits","glyphRef","gradientTransform","gradientUnits","kernelMatrix","kernelUnitLength","keyPoints","keySplines","keyTimes","lengthAdjust","limitingConeAngle","markerHeight","markerUnits","markerWidth","maskContentUnits","maskUnits","numOctaves","pathLength","patternContentUnits","patternTransform","patternUnits","pointsAtX","pointsAtY","pointsAtZ","preserveAlpha","preserveAspectRatio","primitiveUnits","refX","refY","repeatCount","repeatDur","requiredExtensions","requiredFeatures","specularConstant","specularExponent","spreadMethod","startOffset","stdDeviation","stitchTiles","surfaceScale","systemLanguage","tableValues","targetX","targetY","textLength","viewBox","viewTarget","xChannelSelector","yChannelSelector","zoomAndPan"].map(t=>[t.toLowerCase(),t])),XML_ATTRS_ADJUSTMENT_MAP=new Map([["xlink:actuate",{prefix:"xlink",name:"actuate",namespace:html_js_1.NS.XLINK}],["xlink:arcrole",{prefix:"xlink",name:"arcrole",namespace:html_js_1.NS.XLINK}],["xlink:href",{prefix:"xlink",name:"href",namespace:html_js_1.NS.XLINK}],["xlink:role",{prefix:"xlink",name:"role",namespace:html_js_1.NS.XLINK}],["xlink:show",{prefix:"xlink",name:"show",namespace:html_js_1.NS.XLINK}],["xlink:title",{prefix:"xlink",name:"title",namespace:html_js_1.NS.XLINK}],["xlink:type",{prefix:"xlink",name:"type",namespace:html_js_1.NS.XLINK}],["xml:base",{prefix:"xml",name:"base",namespace:html_js_1.NS.XML}],["xml:lang",{prefix:"xml",name:"lang",namespace:html_js_1.NS.XML}],["xml:space",{prefix:"xml",name:"space",namespace:html_js_1.NS.XML}],["xmlns",{prefix:"",name:"xmlns",namespace:html_js_1.NS.XMLNS}],["xmlns:xlink",{prefix:"xmlns",name:"xlink",namespace:html_js_1.NS.XMLNS}]]),EXITS_FOREIGN_CONTENT=(exports.SVG_TAG_NAMES_ADJUSTMENT_MAP=new Map(["altGlyph","altGlyphDef","altGlyphItem","animateColor","animateMotion","animateTransform","clipPath","feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence","foreignObject","glyphRef","linearGradient","radialGradient","textPath"].map(t=>[t.toLowerCase(),t])),new Set([html_js_1.TAG_ID.B,html_js_1.TAG_ID.BIG,html_js_1.TAG_ID.BLOCKQUOTE,html_js_1.TAG_ID.BODY,html_js_1.TAG_ID.BR,html_js_1.TAG_ID.CENTER,html_js_1.TAG_ID.CODE,html_js_1.TAG_ID.DD,html_js_1.TAG_ID.DIV,html_js_1.TAG_ID.DL,html_js_1.TAG_ID.DT,html_js_1.TAG_ID.EM,html_js_1.TAG_ID.EMBED,html_js_1.TAG_ID.H1,html_js_1.TAG_ID.H2,html_js_1.TAG_ID.H3,html_js_1.TAG_ID.H4,html_js_1.TAG_ID.H5,html_js_1.TAG_ID.H6,html_js_1.TAG_ID.HEAD,html_js_1.TAG_ID.HR,html_js_1.TAG_ID.I,html_js_1.TAG_ID.IMG,html_js_1.TAG_ID.LI,html_js_1.TAG_ID.LISTING,html_js_1.TAG_ID.MENU,html_js_1.TAG_ID.META,html_js_1.TAG_ID.NOBR,html_js_1.TAG_ID.OL,html_js_1.TAG_ID.P,html_js_1.TAG_ID.PRE,html_js_1.TAG_ID.RUBY,html_js_1.TAG_ID.S,html_js_1.TAG_ID.SMALL,html_js_1.TAG_ID.SPAN,html_js_1.TAG_ID.STRONG,html_js_1.TAG_ID.STRIKE,html_js_1.TAG_ID.SUB,html_js_1.TAG_ID.SUP,html_js_1.TAG_ID.TABLE,html_js_1.TAG_ID.TT,html_js_1.TAG_ID.U,html_js_1.TAG_ID.UL,html_js_1.TAG_ID.VAR]));function causesExit(t){var e=t.tagID;return e===html_js_1.TAG_ID.FONT&&t.attrs.some(({name:t})=>t===html_js_1.ATTRS.COLOR||t===html_js_1.ATTRS.SIZE||t===html_js_1.ATTRS.FACE)||EXITS_FOREIGN_CONTENT.has(e)}function adjustTokenMathMLAttrs(e){for(let t=0;t<e.attrs.length;t++)if(e.attrs[t].name===DEFINITION_URL_ATTR){e.attrs[t].name=ADJUSTED_DEFINITION_URL_ATTR;break}}function adjustTokenSVGAttrs(e){for(let t=0;t<e.attrs.length;t++){var _=SVG_ATTRS_ADJUSTMENT_MAP.get(e.attrs[t].name);null!=_&&(e.attrs[t].name=_)}}function adjustTokenXMLAttrs(e){for(let t=0;t<e.attrs.length;t++){var _=XML_ATTRS_ADJUSTMENT_MAP.get(e.attrs[t].name);_&&(e.attrs[t].prefix=_.prefix,e.attrs[t].name=_.name,e.attrs[t].namespace=_.namespace)}}function adjustTokenSVGTagName(t){var e=exports.SVG_TAG_NAMES_ADJUSTMENT_MAP.get(t.tagName);null!=e&&(t.tagName=e,t.tagID=(0,html_js_1.getTagID)(t.tagName))}function isMathMLTextIntegrationPoint(t,e){return e===html_js_1.NS.MATHML&&(t===html_js_1.TAG_ID.MI||t===html_js_1.TAG_ID.MO||t===html_js_1.TAG_ID.MN||t===html_js_1.TAG_ID.MS||t===html_js_1.TAG_ID.MTEXT)}function isHtmlIntegrationPoint(t,e,_){if(e===html_js_1.NS.MATHML&&t===html_js_1.TAG_ID.ANNOTATION_XML)for(let t=0;t<_.length;t++){var s;if(_[t].name===html_js_1.ATTRS.ENCODING)return(s=_[t].value.toLowerCase())===MIME_TYPES.TEXT_HTML||s===MIME_TYPES.APPLICATION_XML}return e===html_js_1.NS.SVG&&(t===html_js_1.TAG_ID.FOREIGN_OBJECT||t===html_js_1.TAG_ID.DESC||t===html_js_1.TAG_ID.TITLE)}function isIntegrationPoint(t,e,_,s){return(!s||s===html_js_1.NS.HTML)&&isHtmlIntegrationPoint(t,e,_)||(!s||s===html_js_1.NS.MATHML)&&isMathMLTextIntegrationPoint(t,e)}exports.causesExit=causesExit,exports.adjustTokenMathMLAttrs=adjustTokenMathMLAttrs,exports.adjustTokenSVGAttrs=adjustTokenSVGAttrs,exports.adjustTokenXMLAttrs=adjustTokenXMLAttrs,exports.adjustTokenSVGTagName=adjustTokenSVGTagName,exports.isIntegrationPoint=isIntegrationPoint;