"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Parser=void 0;const index_js_1=require("../tokenizer/index.js"),open_element_stack_js_1=require("./open-element-stack.js"),formatting_element_list_js_1=require("./formatting-element-list.js"),default_js_1=require("../tree-adapters/default.js"),doctype=require("../common/doctype.js"),foreignContent=require("../common/foreign-content.js"),error_codes_js_1=require("../common/error-codes.js"),unicode=require("../common/unicode.js"),html_js_1=require("../common/html.js"),token_js_1=require("../common/token.js"),HIDDEN_INPUT_TYPE="hidden",AA_OUTER_LOOP_ITER=8,AA_INNER_LOOP_ITER=3;var InsertionMode;!function(e){e[e.INITIAL=0]="INITIAL",e[e.BEFORE_HTML=1]="BEFORE_HTML",e[e.BEFORE_HEAD=2]="BEFORE_HEAD",e[e.IN_HEAD=3]="IN_HEAD",e[e.IN_HEAD_NO_SCRIPT=4]="IN_HEAD_NO_SCRIPT",e[e.AFTER_HEAD=5]="AFTER_HEAD",e[e.IN_BODY=6]="IN_BODY",e[e.TEXT=7]="TEXT",e[e.IN_TABLE=8]="IN_TABLE",e[e.IN_TABLE_TEXT=9]="IN_TABLE_TEXT",e[e.IN_CAPTION=10]="IN_CAPTION",e[e.IN_COLUMN_GROUP=11]="IN_COLUMN_GROUP",e[e.IN_TABLE_BODY=12]="IN_TABLE_BODY",e[e.IN_ROW=13]="IN_ROW",e[e.IN_CELL=14]="IN_CELL",e[e.IN_SELECT=15]="IN_SELECT",e[e.IN_SELECT_IN_TABLE=16]="IN_SELECT_IN_TABLE",e[e.IN_TEMPLATE=17]="IN_TEMPLATE",e[e.AFTER_BODY=18]="AFTER_BODY",e[e.IN_FRAMESET=19]="IN_FRAMESET",e[e.AFTER_FRAMESET=20]="AFTER_FRAMESET",e[e.AFTER_AFTER_BODY=21]="AFTER_AFTER_BODY",e[e.AFTER_AFTER_FRAMESET=22]="AFTER_AFTER_FRAMESET"}(InsertionMode=InsertionMode||{});const BASE_LOC={startLine:-1,startCol:-1,startOffset:-1,endLine:-1,endCol:-1,endOffset:-1},TABLE_STRUCTURE_TAGS=new Set([html_js_1.TAG_ID.TABLE,html_js_1.TAG_ID.TBODY,html_js_1.TAG_ID.TFOOT,html_js_1.TAG_ID.THEAD,html_js_1.TAG_ID.TR]),defaultParserOptions={scriptingEnabled:!0,sourceCodeLocationInfo:!1,treeAdapter:default_js_1.defaultTreeAdapter,onParseError:null};class Parser{constructor(e,t,n=null,s=null){this.fragmentContext=n,this.scriptHandler=s,this.currentToken=null,this.stopped=!1,this.insertionMode=InsertionMode.INITIAL,this.originalInsertionMode=InsertionMode.INITIAL,this.headElement=null,this.formElement=null,this.currentNotInHTML=!1,this.tmplInsertionModeStack=[],this.pendingCharacterTokens=[],this.hasNonWhitespacePendingCharacterToken=!1,this.framesetOk=!0,this.skipNextNewLine=!1,this.fosterParentingEnabled=!1,this.options=Object.assign(Object.assign({},defaultParserOptions),e),this.treeAdapter=this.options.treeAdapter,this.onParseError=this.options.onParseError,this.onParseError&&(this.options.sourceCodeLocationInfo=!0),this.document=null!=t?t:this.treeAdapter.createDocument(),this.tokenizer=new index_js_1.Tokenizer(this.options,this),this.activeFormattingElements=new formatting_element_list_js_1.FormattingElementList(this.treeAdapter),this.fragmentContextID=n?(0,html_js_1.getTagID)(this.treeAdapter.getTagName(n)):html_js_1.TAG_ID.UNKNOWN,this._setContextModes(null!=n?n:this.document,this.fragmentContextID),this.openElements=new open_element_stack_js_1.OpenElementStack(this.document,this.treeAdapter,this)}static parse(e,t){t=new this(t);return t.tokenizer.write(e,!0),t.document}static getFragmentParser(e,t){var t=Object.assign(Object.assign({},defaultParserOptions),t),n=(null!=e||(e=t.treeAdapter.createElement(html_js_1.TAG_NAMES.TEMPLATE,html_js_1.NS.HTML,[])),t.treeAdapter.createElement("documentmock",html_js_1.NS.HTML,[])),t=new this(t,n,e);return t.fragmentContextID===html_js_1.TAG_ID.TEMPLATE&&t.tmplInsertionModeStack.unshift(InsertionMode.IN_TEMPLATE),t._initTokenizerForFragmentParsing(),t._insertFakeRootElement(),t._resetInsertionMode(),t._findFormInFragmentContext(),t}getFragment(){var e=this.treeAdapter.getFirstChild(this.document),t=this.treeAdapter.createDocumentFragment();return this._adoptNodes(e,t),t}_err(e,t,n){this.onParseError&&(t={code:t,startLine:(e=null!=(t=e.location)?t:BASE_LOC).startLine,startCol:e.startCol,startOffset:e.startOffset,endLine:n?e.startLine:e.endLine,endCol:n?e.startCol:e.endCol,endOffset:n?e.startOffset:e.endOffset},this.onParseError(t))}onItemPush(e,t,n){var s,a;null!=(a=(s=this.treeAdapter).onItemPush)&&a.call(s,e),n&&0<this.openElements.stackTop&&this._setContextModes(e,t)}onItemPop(e,t){var n,s;if(this.options.sourceCodeLocationInfo&&this._setEndLocation(e,this.currentToken),null!=(s=(n=this.treeAdapter).onItemPop)&&s.call(n,e,this.openElements.current),t){let e,t;0===this.openElements.stackTop&&this.fragmentContext?(e=this.fragmentContext,t=this.fragmentContextID):{current:e,currentTagId:t}=this.openElements,this._setContextModes(e,t)}}_setContextModes(e,t){var n=e===this.document||this.treeAdapter.getNamespaceURI(e)===html_js_1.NS.HTML;this.currentNotInHTML=!n,this.tokenizer.inForeignNode=!n&&!this._isIntegrationPoint(t,e)}_switchToTextParsing(e,t){this._insertElement(e,html_js_1.NS.HTML),this.tokenizer.state=t,this.originalInsertionMode=this.insertionMode,this.insertionMode=InsertionMode.TEXT}switchToPlaintextParsing(){this.insertionMode=InsertionMode.TEXT,this.originalInsertionMode=InsertionMode.IN_BODY,this.tokenizer.state=index_js_1.TokenizerMode.PLAINTEXT}_getAdjustedCurrentElement(){return 0===this.openElements.stackTop&&this.fragmentContext?this.fragmentContext:this.openElements.current}_findFormInFragmentContext(){let e=this.fragmentContext;for(;e;){if(this.treeAdapter.getTagName(e)===html_js_1.TAG_NAMES.FORM){this.formElement=e;break}e=this.treeAdapter.getParentNode(e)}}_initTokenizerForFragmentParsing(){if(this.fragmentContext&&this.treeAdapter.getNamespaceURI(this.fragmentContext)===html_js_1.NS.HTML)switch(this.fragmentContextID){case html_js_1.TAG_ID.TITLE:case html_js_1.TAG_ID.TEXTAREA:this.tokenizer.state=index_js_1.TokenizerMode.RCDATA;break;case html_js_1.TAG_ID.STYLE:case html_js_1.TAG_ID.XMP:case html_js_1.TAG_ID.IFRAME:case html_js_1.TAG_ID.NOEMBED:case html_js_1.TAG_ID.NOFRAMES:case html_js_1.TAG_ID.NOSCRIPT:this.tokenizer.state=index_js_1.TokenizerMode.RAWTEXT;break;case html_js_1.TAG_ID.SCRIPT:this.tokenizer.state=index_js_1.TokenizerMode.SCRIPT_DATA;break;case html_js_1.TAG_ID.PLAINTEXT:this.tokenizer.state=index_js_1.TokenizerMode.PLAINTEXT}}_setDocumentType(e){var t=e.name||"",n=e.publicId||"",s=e.systemId||"";this.treeAdapter.setDocumentType(this.document,t,n,s),e.location&&(t=this.treeAdapter.getChildNodes(this.document).find(e=>this.treeAdapter.isDocumentTypeNode(e)))&&this.treeAdapter.setNodeSourceCodeLocation(t,e.location)}_attachElementToTree(e,t){this.options.sourceCodeLocationInfo&&(t=t&&Object.assign(Object.assign({},t),{startTag:t}),this.treeAdapter.setNodeSourceCodeLocation(e,t)),this._shouldFosterParentOnInsertion()?this._fosterParentElement(e):(t=this.openElements.currentTmplContentOrNode,this.treeAdapter.appendChild(t,e))}_appendElement(e,t){t=this.treeAdapter.createElement(e.tagName,t,e.attrs);this._attachElementToTree(t,e.location)}_insertElement(e,t){t=this.treeAdapter.createElement(e.tagName,t,e.attrs);this._attachElementToTree(t,e.location),this.openElements.push(t,e.tagID)}_insertFakeElement(e,t){e=this.treeAdapter.createElement(e,html_js_1.NS.HTML,[]);this._attachElementToTree(e,null),this.openElements.push(e,t)}_insertTemplate(e){var t=this.treeAdapter.createElement(e.tagName,html_js_1.NS.HTML,e.attrs),n=this.treeAdapter.createDocumentFragment();this.treeAdapter.setTemplateContent(t,n),this._attachElementToTree(t,e.location),this.openElements.push(t,e.tagID),this.options.sourceCodeLocationInfo&&this.treeAdapter.setNodeSourceCodeLocation(n,null)}_insertFakeRootElement(){var e=this.treeAdapter.createElement(html_js_1.TAG_NAMES.HTML,html_js_1.NS.HTML,[]);this.options.sourceCodeLocationInfo&&this.treeAdapter.setNodeSourceCodeLocation(e,null),this.treeAdapter.appendChild(this.openElements.current,e),this.openElements.push(e,html_js_1.TAG_ID.HTML)}_appendCommentNode(e,t){var n=this.treeAdapter.createCommentNode(e.data);this.treeAdapter.appendChild(t,n),this.options.sourceCodeLocationInfo&&this.treeAdapter.setNodeSourceCodeLocation(n,e.location)}_insertCharacters(e){let t,n;var s,a,o,_;this._shouldFosterParentOnInsertion()?({parent:t,beforeElement:n}=this._findFosterParentingLocation(),n?this.treeAdapter.insertTextBefore(t,e.chars,n):this.treeAdapter.insertText(t,e.chars)):(t=this.openElements.currentTmplContentOrNode,this.treeAdapter.insertText(t,e.chars)),e.location&&(s=this.treeAdapter.getChildNodes(t),a=n?s.lastIndexOf(n):s.length,s=s[a-1],this.treeAdapter.getNodeSourceCodeLocation(s)?({endLine:a,endCol:o,endOffset:_}=e.location,this.treeAdapter.updateNodeSourceCodeLocation(s,{endLine:a,endCol:o,endOffset:_})):this.options.sourceCodeLocationInfo&&this.treeAdapter.setNodeSourceCodeLocation(s,e.location))}_adoptNodes(t,n){for(let e=this.treeAdapter.getFirstChild(t);e;e=this.treeAdapter.getFirstChild(t))this.treeAdapter.detachNode(e),this.treeAdapter.appendChild(n,e)}_setEndLocation(e,t){var n,s;this.treeAdapter.getNodeSourceCodeLocation(e)&&t.location&&(n=t.location,s=this.treeAdapter.getTagName(e),s=t.type===token_js_1.TokenType.END_TAG&&s===t.tagName?{endTag:Object.assign({},n),endLine:n.endLine,endCol:n.endCol,endOffset:n.endOffset}:{endLine:n.startLine,endCol:n.startCol,endOffset:n.startOffset},this.treeAdapter.updateNodeSourceCodeLocation(e,s))}shouldProcessStartTagTokenInForeignContent(e){if(!this.currentNotInHTML)return!1;let t,n;return 0===this.openElements.stackTop&&this.fragmentContext?(t=this.fragmentContext,n=this.fragmentContextID):{current:t,currentTagId:n}=this.openElements,(e.tagID!==html_js_1.TAG_ID.SVG||this.treeAdapter.getTagName(t)!==html_js_1.TAG_NAMES.ANNOTATION_XML||this.treeAdapter.getNamespaceURI(t)!==html_js_1.NS.MATHML)&&(this.tokenizer.inForeignNode||(e.tagID===html_js_1.TAG_ID.MGLYPH||e.tagID===html_js_1.TAG_ID.MALIGNMARK)&&!this._isIntegrationPoint(n,t,html_js_1.NS.HTML))}_processToken(e){switch(e.type){case token_js_1.TokenType.CHARACTER:this.onCharacter(e);break;case token_js_1.TokenType.NULL_CHARACTER:this.onNullCharacter(e);break;case token_js_1.TokenType.COMMENT:this.onComment(e);break;case token_js_1.TokenType.DOCTYPE:this.onDoctype(e);break;case token_js_1.TokenType.START_TAG:this._processStartTag(e);break;case token_js_1.TokenType.END_TAG:this.onEndTag(e);break;case token_js_1.TokenType.EOF:this.onEof(e);break;case token_js_1.TokenType.WHITESPACE_CHARACTER:this.onWhitespaceCharacter(e)}}_isIntegrationPoint(e,t,n){var s=this.treeAdapter.getNamespaceURI(t),t=this.treeAdapter.getAttrList(t);return foreignContent.isIntegrationPoint(e,s,t,n)}_reconstructActiveFormattingElements(){var t=this.activeFormattingElements.entries.length;if(t){var n=this.activeFormattingElements.entries.findIndex(e=>e.type===formatting_element_list_js_1.EntryType.Marker||this.openElements.contains(e.element));for(let e=n<0?t-1:n-1;0<=e;e--){var s=this.activeFormattingElements.entries[e];this._insertElement(s.token,this.treeAdapter.getNamespaceURI(s.element)),s.element=this.openElements.current}}}_closeTableCell(){this.openElements.generateImpliedEndTags(),this.openElements.popUntilTableCellPopped(),this.activeFormattingElements.clearToLastMarker(),this.insertionMode=InsertionMode.IN_ROW}_closePElement(){this.openElements.generateImpliedEndTagsWithExclusion(html_js_1.TAG_ID.P),this.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.P)}_resetInsertionMode(){for(let e=this.openElements.stackTop;0<=e;e--)switch(0===e&&this.fragmentContext?this.fragmentContextID:this.openElements.tagIDs[e]){case html_js_1.TAG_ID.TR:return void(this.insertionMode=InsertionMode.IN_ROW);case html_js_1.TAG_ID.TBODY:case html_js_1.TAG_ID.THEAD:case html_js_1.TAG_ID.TFOOT:return void(this.insertionMode=InsertionMode.IN_TABLE_BODY);case html_js_1.TAG_ID.CAPTION:return void(this.insertionMode=InsertionMode.IN_CAPTION);case html_js_1.TAG_ID.COLGROUP:return void(this.insertionMode=InsertionMode.IN_COLUMN_GROUP);case html_js_1.TAG_ID.TABLE:return void(this.insertionMode=InsertionMode.IN_TABLE);case html_js_1.TAG_ID.BODY:return void(this.insertionMode=InsertionMode.IN_BODY);case html_js_1.TAG_ID.FRAMESET:return void(this.insertionMode=InsertionMode.IN_FRAMESET);case html_js_1.TAG_ID.SELECT:return void this._resetInsertionModeForSelect(e);case html_js_1.TAG_ID.TEMPLATE:return void(this.insertionMode=this.tmplInsertionModeStack[0]);case html_js_1.TAG_ID.HTML:return void(this.insertionMode=this.headElement?InsertionMode.AFTER_HEAD:InsertionMode.BEFORE_HEAD);case html_js_1.TAG_ID.TD:case html_js_1.TAG_ID.TH:if(0<e)return void(this.insertionMode=InsertionMode.IN_CELL);break;case html_js_1.TAG_ID.HEAD:if(0<e)return void(this.insertionMode=InsertionMode.IN_HEAD)}this.insertionMode=InsertionMode.IN_BODY}_resetInsertionModeForSelect(t){if(0<t)for(let e=t-1;0<e;e--){var n=this.openElements.tagIDs[e];if(n===html_js_1.TAG_ID.TEMPLATE)break;if(n===html_js_1.TAG_ID.TABLE)return void(this.insertionMode=InsertionMode.IN_SELECT_IN_TABLE)}this.insertionMode=InsertionMode.IN_SELECT}_isElementCausesFosterParenting(e){return TABLE_STRUCTURE_TAGS.has(e)}_shouldFosterParentOnInsertion(){return this.fosterParentingEnabled&&this._isElementCausesFosterParenting(this.openElements.currentTagId)}_findFosterParentingLocation(){for(let e=this.openElements.stackTop;0<=e;e--){var t=this.openElements.items[e];switch(this.openElements.tagIDs[e]){case html_js_1.TAG_ID.TEMPLATE:if(this.treeAdapter.getNamespaceURI(t)===html_js_1.NS.HTML)return{parent:this.treeAdapter.getTemplateContent(t),beforeElement:null};break;case html_js_1.TAG_ID.TABLE:var n=this.treeAdapter.getParentNode(t);return n?{parent:n,beforeElement:t}:{parent:this.openElements.items[e-1],beforeElement:null}}}return{parent:this.openElements.items[0],beforeElement:null}}_fosterParentElement(e){var t=this._findFosterParentingLocation();t.beforeElement?this.treeAdapter.insertBefore(t.parent,e,t.beforeElement):this.treeAdapter.appendChild(t.parent,e)}_isSpecialElement(e,t){e=this.treeAdapter.getNamespaceURI(e);return html_js_1.SPECIAL_ELEMENTS[e].has(t)}onCharacter(e){if(this.skipNextNewLine=!1,this.tokenizer.inForeignNode)characterInForeignContent(this,e);else switch(this.insertionMode){case InsertionMode.INITIAL:tokenInInitialMode(this,e);break;case InsertionMode.BEFORE_HTML:tokenBeforeHtml(this,e);break;case InsertionMode.BEFORE_HEAD:tokenBeforeHead(this,e);break;case InsertionMode.IN_HEAD:tokenInHead(this,e);break;case InsertionMode.IN_HEAD_NO_SCRIPT:tokenInHeadNoScript(this,e);break;case InsertionMode.AFTER_HEAD:tokenAfterHead(this,e);break;case InsertionMode.IN_BODY:case InsertionMode.IN_CAPTION:case InsertionMode.IN_CELL:case InsertionMode.IN_TEMPLATE:characterInBody(this,e);break;case InsertionMode.TEXT:case InsertionMode.IN_SELECT:case InsertionMode.IN_SELECT_IN_TABLE:this._insertCharacters(e);break;case InsertionMode.IN_TABLE:case InsertionMode.IN_TABLE_BODY:case InsertionMode.IN_ROW:characterInTable(this,e);break;case InsertionMode.IN_TABLE_TEXT:characterInTableText(this,e);break;case InsertionMode.IN_COLUMN_GROUP:tokenInColumnGroup(this,e);break;case InsertionMode.AFTER_BODY:tokenAfterBody(this,e);break;case InsertionMode.AFTER_AFTER_BODY:tokenAfterAfterBody(this,e)}}onNullCharacter(e){if(this.skipNextNewLine=!1,this.tokenizer.inForeignNode)nullCharacterInForeignContent(this,e);else switch(this.insertionMode){case InsertionMode.INITIAL:tokenInInitialMode(this,e);break;case InsertionMode.BEFORE_HTML:tokenBeforeHtml(this,e);break;case InsertionMode.BEFORE_HEAD:tokenBeforeHead(this,e);break;case InsertionMode.IN_HEAD:tokenInHead(this,e);break;case InsertionMode.IN_HEAD_NO_SCRIPT:tokenInHeadNoScript(this,e);break;case InsertionMode.AFTER_HEAD:tokenAfterHead(this,e);break;case InsertionMode.TEXT:this._insertCharacters(e);break;case InsertionMode.IN_TABLE:case InsertionMode.IN_TABLE_BODY:case InsertionMode.IN_ROW:characterInTable(this,e);break;case InsertionMode.IN_COLUMN_GROUP:tokenInColumnGroup(this,e);break;case InsertionMode.AFTER_BODY:tokenAfterBody(this,e);break;case InsertionMode.AFTER_AFTER_BODY:tokenAfterAfterBody(this,e)}}onComment(e){if(this.skipNextNewLine=!1,this.currentNotInHTML)appendComment(this,e);else switch(this.insertionMode){case InsertionMode.INITIAL:case InsertionMode.BEFORE_HTML:case InsertionMode.BEFORE_HEAD:case InsertionMode.IN_HEAD:case InsertionMode.IN_HEAD_NO_SCRIPT:case InsertionMode.AFTER_HEAD:case InsertionMode.IN_BODY:case InsertionMode.IN_TABLE:case InsertionMode.IN_CAPTION:case InsertionMode.IN_COLUMN_GROUP:case InsertionMode.IN_TABLE_BODY:case InsertionMode.IN_ROW:case InsertionMode.IN_CELL:case InsertionMode.IN_SELECT:case InsertionMode.IN_SELECT_IN_TABLE:case InsertionMode.IN_TEMPLATE:case InsertionMode.IN_FRAMESET:case InsertionMode.AFTER_FRAMESET:appendComment(this,e);break;case InsertionMode.IN_TABLE_TEXT:tokenInTableText(this,e);break;case InsertionMode.AFTER_BODY:appendCommentToRootHtmlElement(this,e);break;case InsertionMode.AFTER_AFTER_BODY:case InsertionMode.AFTER_AFTER_FRAMESET:appendCommentToDocument(this,e)}}onDoctype(e){switch(this.skipNextNewLine=!1,this.insertionMode){case InsertionMode.INITIAL:doctypeInInitialMode(this,e);break;case InsertionMode.BEFORE_HEAD:case InsertionMode.IN_HEAD:case InsertionMode.IN_HEAD_NO_SCRIPT:case InsertionMode.AFTER_HEAD:this._err(e,error_codes_js_1.ERR.misplacedDoctype);break;case InsertionMode.IN_TABLE_TEXT:tokenInTableText(this,e)}}onStartTag(e){this.skipNextNewLine=!1,this.currentToken=e,this._processStartTag(e),e.selfClosing&&!e.ackSelfClosing&&this._err(e,error_codes_js_1.ERR.nonVoidHtmlElementStartTagWithTrailingSolidus)}_processStartTag(e){this.shouldProcessStartTagTokenInForeignContent(e)?startTagInForeignContent(this,e):this._startTagOutsideForeignContent(e)}_startTagOutsideForeignContent(e){switch(this.insertionMode){case InsertionMode.INITIAL:tokenInInitialMode(this,e);break;case InsertionMode.BEFORE_HTML:startTagBeforeHtml(this,e);break;case InsertionMode.BEFORE_HEAD:startTagBeforeHead(this,e);break;case InsertionMode.IN_HEAD:startTagInHead(this,e);break;case InsertionMode.IN_HEAD_NO_SCRIPT:startTagInHeadNoScript(this,e);break;case InsertionMode.AFTER_HEAD:startTagAfterHead(this,e);break;case InsertionMode.IN_BODY:startTagInBody(this,e);break;case InsertionMode.IN_TABLE:startTagInTable(this,e);break;case InsertionMode.IN_TABLE_TEXT:tokenInTableText(this,e);break;case InsertionMode.IN_CAPTION:startTagInCaption(this,e);break;case InsertionMode.IN_COLUMN_GROUP:startTagInColumnGroup(this,e);break;case InsertionMode.IN_TABLE_BODY:startTagInTableBody(this,e);break;case InsertionMode.IN_ROW:startTagInRow(this,e);break;case InsertionMode.IN_CELL:startTagInCell(this,e);break;case InsertionMode.IN_SELECT:startTagInSelect(this,e);break;case InsertionMode.IN_SELECT_IN_TABLE:startTagInSelectInTable(this,e);break;case InsertionMode.IN_TEMPLATE:startTagInTemplate(this,e);break;case InsertionMode.AFTER_BODY:startTagAfterBody(this,e);break;case InsertionMode.IN_FRAMESET:startTagInFrameset(this,e);break;case InsertionMode.AFTER_FRAMESET:startTagAfterFrameset(this,e);break;case InsertionMode.AFTER_AFTER_BODY:startTagAfterAfterBody(this,e);break;case InsertionMode.AFTER_AFTER_FRAMESET:startTagAfterAfterFrameset(this,e)}}onEndTag(e){this.skipNextNewLine=!1,this.currentToken=e,this.currentNotInHTML?endTagInForeignContent(this,e):this._endTagOutsideForeignContent(e)}_endTagOutsideForeignContent(e){switch(this.insertionMode){case InsertionMode.INITIAL:tokenInInitialMode(this,e);break;case InsertionMode.BEFORE_HTML:endTagBeforeHtml(this,e);break;case InsertionMode.BEFORE_HEAD:endTagBeforeHead(this,e);break;case InsertionMode.IN_HEAD:endTagInHead(this,e);break;case InsertionMode.IN_HEAD_NO_SCRIPT:endTagInHeadNoScript(this,e);break;case InsertionMode.AFTER_HEAD:endTagAfterHead(this,e);break;case InsertionMode.IN_BODY:endTagInBody(this,e);break;case InsertionMode.TEXT:endTagInText(this,e);break;case InsertionMode.IN_TABLE:endTagInTable(this,e);break;case InsertionMode.IN_TABLE_TEXT:tokenInTableText(this,e);break;case InsertionMode.IN_CAPTION:endTagInCaption(this,e);break;case InsertionMode.IN_COLUMN_GROUP:endTagInColumnGroup(this,e);break;case InsertionMode.IN_TABLE_BODY:endTagInTableBody(this,e);break;case InsertionMode.IN_ROW:endTagInRow(this,e);break;case InsertionMode.IN_CELL:endTagInCell(this,e);break;case InsertionMode.IN_SELECT:endTagInSelect(this,e);break;case InsertionMode.IN_SELECT_IN_TABLE:endTagInSelectInTable(this,e);break;case InsertionMode.IN_TEMPLATE:endTagInTemplate(this,e);break;case InsertionMode.AFTER_BODY:endTagAfterBody(this,e);break;case InsertionMode.IN_FRAMESET:endTagInFrameset(this,e);break;case InsertionMode.AFTER_FRAMESET:endTagAfterFrameset(this,e);break;case InsertionMode.AFTER_AFTER_BODY:tokenAfterAfterBody(this,e)}}onEof(e){switch(this.insertionMode){case InsertionMode.INITIAL:tokenInInitialMode(this,e);break;case InsertionMode.BEFORE_HTML:tokenBeforeHtml(this,e);break;case InsertionMode.BEFORE_HEAD:tokenBeforeHead(this,e);break;case InsertionMode.IN_HEAD:tokenInHead(this,e);break;case InsertionMode.IN_HEAD_NO_SCRIPT:tokenInHeadNoScript(this,e);break;case InsertionMode.AFTER_HEAD:tokenAfterHead(this,e);break;case InsertionMode.IN_BODY:case InsertionMode.IN_TABLE:case InsertionMode.IN_CAPTION:case InsertionMode.IN_COLUMN_GROUP:case InsertionMode.IN_TABLE_BODY:case InsertionMode.IN_ROW:case InsertionMode.IN_CELL:case InsertionMode.IN_SELECT:case InsertionMode.IN_SELECT_IN_TABLE:eofInBody(this,e);break;case InsertionMode.TEXT:eofInText(this,e);break;case InsertionMode.IN_TABLE_TEXT:tokenInTableText(this,e);break;case InsertionMode.IN_TEMPLATE:eofInTemplate(this,e);break;case InsertionMode.AFTER_BODY:case InsertionMode.IN_FRAMESET:case InsertionMode.AFTER_FRAMESET:case InsertionMode.AFTER_AFTER_BODY:case InsertionMode.AFTER_AFTER_FRAMESET:stopParsing(this,e)}}onWhitespaceCharacter(e){if(this.skipNextNewLine&&(this.skipNextNewLine=!1,e.chars.charCodeAt(0)===unicode.CODE_POINTS.LINE_FEED)){if(1===e.chars.length)return;e.chars=e.chars.substr(1)}if(this.tokenizer.inForeignNode)this._insertCharacters(e);else switch(this.insertionMode){case InsertionMode.IN_HEAD:case InsertionMode.IN_HEAD_NO_SCRIPT:case InsertionMode.AFTER_HEAD:case InsertionMode.TEXT:case InsertionMode.IN_COLUMN_GROUP:case InsertionMode.IN_SELECT:case InsertionMode.IN_SELECT_IN_TABLE:case InsertionMode.IN_FRAMESET:case InsertionMode.AFTER_FRAMESET:this._insertCharacters(e);break;case InsertionMode.IN_BODY:case InsertionMode.IN_CAPTION:case InsertionMode.IN_CELL:case InsertionMode.IN_TEMPLATE:case InsertionMode.AFTER_BODY:case InsertionMode.AFTER_AFTER_BODY:case InsertionMode.AFTER_AFTER_FRAMESET:whitespaceCharacterInBody(this,e);break;case InsertionMode.IN_TABLE:case InsertionMode.IN_TABLE_BODY:case InsertionMode.IN_ROW:characterInTable(this,e);break;case InsertionMode.IN_TABLE_TEXT:whitespaceCharacterInTableText(this,e)}}}function aaObtainFormattingElementEntry(e,t){let n=e.activeFormattingElements.getElementEntryInScopeWithTagName(t.tagName);return n?e.openElements.contains(n.element)?e.openElements.hasInScope(t.tagID)||(n=null):(e.activeFormattingElements.removeEntry(n),n=null):genericEndTagInBody(e,t),n}function aaObtainFurthestBlock(e,t){let n=null,s=e.openElements.stackTop;for(;0<=s;s--){var a=e.openElements.items[s];if(a===t.element)break;e._isSpecialElement(a,e.openElements.tagIDs[s])&&(n=a)}return n||(e.openElements.shortenToLength(s<0?0:s),e.activeFormattingElements.removeEntry(t)),n}function aaInnerLoop(n,s,a){let o=s;for(let e=0,t=n.openElements.getCommonAncestor(s);t!==a;e++,t=_){var _=n.openElements.getCommonAncestor(t),r=n.activeFormattingElements.getElementEntry(t),T=r&&e>=AA_INNER_LOOP_ITER;!r||T?(T&&n.activeFormattingElements.removeEntry(r),n.openElements.remove(t)):(t=aaRecreateElementFromEntry(n,r),o===s&&(n.activeFormattingElements.bookmark=r),n.treeAdapter.detachNode(o),n.treeAdapter.appendChild(t,o),o=t)}return o}function aaRecreateElementFromEntry(e,t){var n=e.treeAdapter.getNamespaceURI(t.element),n=e.treeAdapter.createElement(t.token.tagName,n,t.token.attrs);return e.openElements.replace(t.element,n),t.element=n}function aaInsertLastNodeInCommonAncestor(e,t,n){var s,a=e.treeAdapter.getTagName(t),a=(0,html_js_1.getTagID)(a);e._isElementCausesFosterParenting(a)?e._fosterParentElement(n):(s=e.treeAdapter.getNamespaceURI(t),a===html_js_1.TAG_ID.TEMPLATE&&s===html_js_1.NS.HTML&&(t=e.treeAdapter.getTemplateContent(t)),e.treeAdapter.appendChild(t,n))}function aaReplaceFormattingElement(e,t,n){var s=e.treeAdapter.getNamespaceURI(n.element),a=n["token"],s=e.treeAdapter.createElement(a.tagName,s,a.attrs);e._adoptNodes(t,s),e.treeAdapter.appendChild(t,s),e.activeFormattingElements.insertElementAfterBookmark(s,a),e.activeFormattingElements.removeEntry(n),e.openElements.remove(n.element),e.openElements.insertAfter(t,s,a.tagID)}function callAdoptionAgency(t,n){for(let e=0;e<AA_OUTER_LOOP_ITER;e++){var s=aaObtainFormattingElementEntry(t,n);if(!s)break;var a=aaObtainFurthestBlock(t,s);if(!a)break;t.activeFormattingElements.bookmark=s;var o=aaInnerLoop(t,a,s.element),_=t.openElements.getCommonAncestor(s.element);t.treeAdapter.detachNode(o),_&&aaInsertLastNodeInCommonAncestor(t,_,o),aaReplaceFormattingElement(t,a,s)}}function appendComment(e,t){e._appendCommentNode(t,e.openElements.currentTmplContentOrNode)}function appendCommentToRootHtmlElement(e,t){e._appendCommentNode(t,e.openElements.items[0])}function appendCommentToDocument(e,t){e._appendCommentNode(t,e.document)}function stopParsing(t,n){if(t.stopped=!0,n.location){var e,s,a=t.fragmentContext?0:2;for(let e=t.openElements.stackTop;e>=a;e--)t._setEndLocation(t.openElements.items[e],n);!t.fragmentContext&&0<=t.openElements.stackTop&&(s=t.openElements.items[0],e=t.treeAdapter.getNodeSourceCodeLocation(s))&&!e.endTag&&(t._setEndLocation(s,n),1<=t.openElements.stackTop)&&(e=t.openElements.items[1],s=t.treeAdapter.getNodeSourceCodeLocation(e))&&!s.endTag&&t._setEndLocation(e,n)}}function doctypeInInitialMode(e,t){e._setDocumentType(t);var n=t.forceQuirks?html_js_1.DOCUMENT_MODE.QUIRKS:doctype.getDocumentMode(t);doctype.isConforming(t)||e._err(t,error_codes_js_1.ERR.nonConformingDoctype),e.treeAdapter.setDocumentMode(e.document,n),e.insertionMode=InsertionMode.BEFORE_HTML}function tokenInInitialMode(e,t){e._err(t,error_codes_js_1.ERR.missingDoctype,!0),e.treeAdapter.setDocumentMode(e.document,html_js_1.DOCUMENT_MODE.QUIRKS),e.insertionMode=InsertionMode.BEFORE_HTML,e._processToken(t)}function startTagBeforeHtml(e,t){t.tagID===html_js_1.TAG_ID.HTML?(e._insertElement(t,html_js_1.NS.HTML),e.insertionMode=InsertionMode.BEFORE_HEAD):tokenBeforeHtml(e,t)}function endTagBeforeHtml(e,t){var n=t.tagID;n!==html_js_1.TAG_ID.HTML&&n!==html_js_1.TAG_ID.HEAD&&n!==html_js_1.TAG_ID.BODY&&n!==html_js_1.TAG_ID.BR||tokenBeforeHtml(e,t)}function tokenBeforeHtml(e,t){e._insertFakeRootElement(),e.insertionMode=InsertionMode.BEFORE_HEAD,e._processToken(t)}function startTagBeforeHead(e,t){switch(t.tagID){case html_js_1.TAG_ID.HTML:startTagInBody(e,t);break;case html_js_1.TAG_ID.HEAD:e._insertElement(t,html_js_1.NS.HTML),e.headElement=e.openElements.current,e.insertionMode=InsertionMode.IN_HEAD;break;default:tokenBeforeHead(e,t)}}function endTagBeforeHead(e,t){var n=t.tagID;n===html_js_1.TAG_ID.HEAD||n===html_js_1.TAG_ID.BODY||n===html_js_1.TAG_ID.HTML||n===html_js_1.TAG_ID.BR?tokenBeforeHead(e,t):e._err(t,error_codes_js_1.ERR.endTagWithoutMatchingOpenElement)}function tokenBeforeHead(e,t){e._insertFakeElement(html_js_1.TAG_NAMES.HEAD,html_js_1.TAG_ID.HEAD),e.headElement=e.openElements.current,e.insertionMode=InsertionMode.IN_HEAD,e._processToken(t)}function startTagInHead(e,t){switch(t.tagID){case html_js_1.TAG_ID.HTML:startTagInBody(e,t);break;case html_js_1.TAG_ID.BASE:case html_js_1.TAG_ID.BASEFONT:case html_js_1.TAG_ID.BGSOUND:case html_js_1.TAG_ID.LINK:case html_js_1.TAG_ID.META:e._appendElement(t,html_js_1.NS.HTML),t.ackSelfClosing=!0;break;case html_js_1.TAG_ID.TITLE:e._switchToTextParsing(t,index_js_1.TokenizerMode.RCDATA);break;case html_js_1.TAG_ID.NOSCRIPT:e.options.scriptingEnabled?e._switchToTextParsing(t,index_js_1.TokenizerMode.RAWTEXT):(e._insertElement(t,html_js_1.NS.HTML),e.insertionMode=InsertionMode.IN_HEAD_NO_SCRIPT);break;case html_js_1.TAG_ID.NOFRAMES:case html_js_1.TAG_ID.STYLE:e._switchToTextParsing(t,index_js_1.TokenizerMode.RAWTEXT);break;case html_js_1.TAG_ID.SCRIPT:e._switchToTextParsing(t,index_js_1.TokenizerMode.SCRIPT_DATA);break;case html_js_1.TAG_ID.TEMPLATE:e._insertTemplate(t),e.activeFormattingElements.insertMarker(),e.framesetOk=!1,e.insertionMode=InsertionMode.IN_TEMPLATE,e.tmplInsertionModeStack.unshift(InsertionMode.IN_TEMPLATE);break;case html_js_1.TAG_ID.HEAD:e._err(t,error_codes_js_1.ERR.misplacedStartTagForHeadElement);break;default:tokenInHead(e,t)}}function endTagInHead(e,t){switch(t.tagID){case html_js_1.TAG_ID.HEAD:e.openElements.pop(),e.insertionMode=InsertionMode.AFTER_HEAD;break;case html_js_1.TAG_ID.BODY:case html_js_1.TAG_ID.BR:case html_js_1.TAG_ID.HTML:tokenInHead(e,t);break;case html_js_1.TAG_ID.TEMPLATE:templateEndTagInHead(e,t);break;default:e._err(t,error_codes_js_1.ERR.endTagWithoutMatchingOpenElement)}}function templateEndTagInHead(e,t){0<e.openElements.tmplCount?(e.openElements.generateImpliedEndTagsThoroughly(),e.openElements.currentTagId!==html_js_1.TAG_ID.TEMPLATE&&e._err(t,error_codes_js_1.ERR.closingOfElementWithOpenChildElements),e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.TEMPLATE),e.activeFormattingElements.clearToLastMarker(),e.tmplInsertionModeStack.shift(),e._resetInsertionMode()):e._err(t,error_codes_js_1.ERR.endTagWithoutMatchingOpenElement)}function tokenInHead(e,t){e.openElements.pop(),e.insertionMode=InsertionMode.AFTER_HEAD,e._processToken(t)}function startTagInHeadNoScript(e,t){switch(t.tagID){case html_js_1.TAG_ID.HTML:startTagInBody(e,t);break;case html_js_1.TAG_ID.BASEFONT:case html_js_1.TAG_ID.BGSOUND:case html_js_1.TAG_ID.HEAD:case html_js_1.TAG_ID.LINK:case html_js_1.TAG_ID.META:case html_js_1.TAG_ID.NOFRAMES:case html_js_1.TAG_ID.STYLE:startTagInHead(e,t);break;case html_js_1.TAG_ID.NOSCRIPT:e._err(t,error_codes_js_1.ERR.nestedNoscriptInHead);break;default:tokenInHeadNoScript(e,t)}}function endTagInHeadNoScript(e,t){switch(t.tagID){case html_js_1.TAG_ID.NOSCRIPT:e.openElements.pop(),e.insertionMode=InsertionMode.IN_HEAD;break;case html_js_1.TAG_ID.BR:tokenInHeadNoScript(e,t);break;default:e._err(t,error_codes_js_1.ERR.endTagWithoutMatchingOpenElement)}}function tokenInHeadNoScript(e,t){var n=t.type===token_js_1.TokenType.EOF?error_codes_js_1.ERR.openElementsLeftAfterEof:error_codes_js_1.ERR.disallowedContentInNoscriptInHead;e._err(t,n),e.openElements.pop(),e.insertionMode=InsertionMode.IN_HEAD,e._processToken(t)}function startTagAfterHead(e,t){switch(t.tagID){case html_js_1.TAG_ID.HTML:startTagInBody(e,t);break;case html_js_1.TAG_ID.BODY:e._insertElement(t,html_js_1.NS.HTML),e.framesetOk=!1,e.insertionMode=InsertionMode.IN_BODY;break;case html_js_1.TAG_ID.FRAMESET:e._insertElement(t,html_js_1.NS.HTML),e.insertionMode=InsertionMode.IN_FRAMESET;break;case html_js_1.TAG_ID.BASE:case html_js_1.TAG_ID.BASEFONT:case html_js_1.TAG_ID.BGSOUND:case html_js_1.TAG_ID.LINK:case html_js_1.TAG_ID.META:case html_js_1.TAG_ID.NOFRAMES:case html_js_1.TAG_ID.SCRIPT:case html_js_1.TAG_ID.STYLE:case html_js_1.TAG_ID.TEMPLATE:case html_js_1.TAG_ID.TITLE:e._err(t,error_codes_js_1.ERR.abandonedHeadElementChild),e.openElements.push(e.headElement,html_js_1.TAG_ID.HEAD),startTagInHead(e,t),e.openElements.remove(e.headElement);break;case html_js_1.TAG_ID.HEAD:e._err(t,error_codes_js_1.ERR.misplacedStartTagForHeadElement);break;default:tokenAfterHead(e,t)}}function endTagAfterHead(e,t){switch(t.tagID){case html_js_1.TAG_ID.BODY:case html_js_1.TAG_ID.HTML:case html_js_1.TAG_ID.BR:tokenAfterHead(e,t);break;case html_js_1.TAG_ID.TEMPLATE:templateEndTagInHead(e,t);break;default:e._err(t,error_codes_js_1.ERR.endTagWithoutMatchingOpenElement)}}function tokenAfterHead(e,t){e._insertFakeElement(html_js_1.TAG_NAMES.BODY,html_js_1.TAG_ID.BODY),e.insertionMode=InsertionMode.IN_BODY,modeInBody(e,t)}function modeInBody(e,t){switch(t.type){case token_js_1.TokenType.CHARACTER:characterInBody(e,t);break;case token_js_1.TokenType.WHITESPACE_CHARACTER:whitespaceCharacterInBody(e,t);break;case token_js_1.TokenType.COMMENT:appendComment(e,t);break;case token_js_1.TokenType.START_TAG:startTagInBody(e,t);break;case token_js_1.TokenType.END_TAG:endTagInBody(e,t);break;case token_js_1.TokenType.EOF:eofInBody(e,t)}}function whitespaceCharacterInBody(e,t){e._reconstructActiveFormattingElements(),e._insertCharacters(t)}function characterInBody(e,t){e._reconstructActiveFormattingElements(),e._insertCharacters(t),e.framesetOk=!1}function htmlStartTagInBody(e,t){0===e.openElements.tmplCount&&e.treeAdapter.adoptAttributes(e.openElements.items[0],t.attrs)}function bodyStartTagInBody(e,t){var n=e.openElements.tryPeekProperlyNestedBodyElement();n&&0===e.openElements.tmplCount&&(e.framesetOk=!1,e.treeAdapter.adoptAttributes(n,t.attrs))}function framesetStartTagInBody(e,t){var n=e.openElements.tryPeekProperlyNestedBodyElement();e.framesetOk&&n&&(e.treeAdapter.detachNode(n),e.openElements.popAllUpToHtmlElement(),e._insertElement(t,html_js_1.NS.HTML),e.insertionMode=InsertionMode.IN_FRAMESET)}function addressStartTagInBody(e,t){e.openElements.hasInButtonScope(html_js_1.TAG_ID.P)&&e._closePElement(),e._insertElement(t,html_js_1.NS.HTML)}function numberedHeaderStartTagInBody(e,t){e.openElements.hasInButtonScope(html_js_1.TAG_ID.P)&&e._closePElement(),(0,html_js_1.isNumberedHeader)(e.openElements.currentTagId)&&e.openElements.pop(),e._insertElement(t,html_js_1.NS.HTML)}function preStartTagInBody(e,t){e.openElements.hasInButtonScope(html_js_1.TAG_ID.P)&&e._closePElement(),e._insertElement(t,html_js_1.NS.HTML),e.skipNextNewLine=!0,e.framesetOk=!1}function formStartTagInBody(e,t){var n=0<e.openElements.tmplCount;e.formElement&&!n||(e.openElements.hasInButtonScope(html_js_1.TAG_ID.P)&&e._closePElement(),e._insertElement(t,html_js_1.NS.HTML),n)||(e.formElement=e.openElements.current)}function listItemStartTagInBody(t,e){t.framesetOk=!1;var n=e.tagID;for(let e=t.openElements.stackTop;0<=e;e--){var s=t.openElements.tagIDs[e];if(n===html_js_1.TAG_ID.LI&&s===html_js_1.TAG_ID.LI||(n===html_js_1.TAG_ID.DD||n===html_js_1.TAG_ID.DT)&&(s===html_js_1.TAG_ID.DD||s===html_js_1.TAG_ID.DT)){t.openElements.generateImpliedEndTagsWithExclusion(s),t.openElements.popUntilTagNamePopped(s);break}if(s!==html_js_1.TAG_ID.ADDRESS&&s!==html_js_1.TAG_ID.DIV&&s!==html_js_1.TAG_ID.P&&t._isSpecialElement(t.openElements.items[e],s))break}t.openElements.hasInButtonScope(html_js_1.TAG_ID.P)&&t._closePElement(),t._insertElement(e,html_js_1.NS.HTML)}function plaintextStartTagInBody(e,t){e.openElements.hasInButtonScope(html_js_1.TAG_ID.P)&&e._closePElement(),e._insertElement(t,html_js_1.NS.HTML),e.tokenizer.state=index_js_1.TokenizerMode.PLAINTEXT}function buttonStartTagInBody(e,t){e.openElements.hasInScope(html_js_1.TAG_ID.BUTTON)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.BUTTON)),e._reconstructActiveFormattingElements(),e._insertElement(t,html_js_1.NS.HTML),e.framesetOk=!1}function aStartTagInBody(e,t){var n=e.activeFormattingElements.getElementEntryInScopeWithTagName(html_js_1.TAG_NAMES.A);n&&(callAdoptionAgency(e,t),e.openElements.remove(n.element),e.activeFormattingElements.removeEntry(n)),e._reconstructActiveFormattingElements(),e._insertElement(t,html_js_1.NS.HTML),e.activeFormattingElements.pushElement(e.openElements.current,t)}function bStartTagInBody(e,t){e._reconstructActiveFormattingElements(),e._insertElement(t,html_js_1.NS.HTML),e.activeFormattingElements.pushElement(e.openElements.current,t)}function nobrStartTagInBody(e,t){e._reconstructActiveFormattingElements(),e.openElements.hasInScope(html_js_1.TAG_ID.NOBR)&&(callAdoptionAgency(e,t),e._reconstructActiveFormattingElements()),e._insertElement(t,html_js_1.NS.HTML),e.activeFormattingElements.pushElement(e.openElements.current,t)}function appletStartTagInBody(e,t){e._reconstructActiveFormattingElements(),e._insertElement(t,html_js_1.NS.HTML),e.activeFormattingElements.insertMarker(),e.framesetOk=!1}function tableStartTagInBody(e,t){e.treeAdapter.getDocumentMode(e.document)!==html_js_1.DOCUMENT_MODE.QUIRKS&&e.openElements.hasInButtonScope(html_js_1.TAG_ID.P)&&e._closePElement(),e._insertElement(t,html_js_1.NS.HTML),e.framesetOk=!1,e.insertionMode=InsertionMode.IN_TABLE}function areaStartTagInBody(e,t){e._reconstructActiveFormattingElements(),e._appendElement(t,html_js_1.NS.HTML),e.framesetOk=!1,t.ackSelfClosing=!0}function isHiddenInput(e){e=(0,token_js_1.getTokenAttr)(e,html_js_1.ATTRS.TYPE);return null!=e&&e.toLowerCase()===HIDDEN_INPUT_TYPE}function inputStartTagInBody(e,t){e._reconstructActiveFormattingElements(),e._appendElement(t,html_js_1.NS.HTML),isHiddenInput(t)||(e.framesetOk=!1),t.ackSelfClosing=!0}function paramStartTagInBody(e,t){e._appendElement(t,html_js_1.NS.HTML),t.ackSelfClosing=!0}function hrStartTagInBody(e,t){e.openElements.hasInButtonScope(html_js_1.TAG_ID.P)&&e._closePElement(),e._appendElement(t,html_js_1.NS.HTML),e.framesetOk=!1,t.ackSelfClosing=!0}function imageStartTagInBody(e,t){t.tagName=html_js_1.TAG_NAMES.IMG,t.tagID=html_js_1.TAG_ID.IMG,areaStartTagInBody(e,t)}function textareaStartTagInBody(e,t){e._insertElement(t,html_js_1.NS.HTML),e.skipNextNewLine=!0,e.tokenizer.state=index_js_1.TokenizerMode.RCDATA,e.originalInsertionMode=e.insertionMode,e.framesetOk=!1,e.insertionMode=InsertionMode.TEXT}function xmpStartTagInBody(e,t){e.openElements.hasInButtonScope(html_js_1.TAG_ID.P)&&e._closePElement(),e._reconstructActiveFormattingElements(),e.framesetOk=!1,e._switchToTextParsing(t,index_js_1.TokenizerMode.RAWTEXT)}function iframeStartTagInBody(e,t){e.framesetOk=!1,e._switchToTextParsing(t,index_js_1.TokenizerMode.RAWTEXT)}function noembedStartTagInBody(e,t){e._switchToTextParsing(t,index_js_1.TokenizerMode.RAWTEXT)}function selectStartTagInBody(e,t){e._reconstructActiveFormattingElements(),e._insertElement(t,html_js_1.NS.HTML),e.framesetOk=!1,e.insertionMode=e.insertionMode===InsertionMode.IN_TABLE||e.insertionMode===InsertionMode.IN_CAPTION||e.insertionMode===InsertionMode.IN_TABLE_BODY||e.insertionMode===InsertionMode.IN_ROW||e.insertionMode===InsertionMode.IN_CELL?InsertionMode.IN_SELECT_IN_TABLE:InsertionMode.IN_SELECT}function optgroupStartTagInBody(e,t){e.openElements.currentTagId===html_js_1.TAG_ID.OPTION&&e.openElements.pop(),e._reconstructActiveFormattingElements(),e._insertElement(t,html_js_1.NS.HTML)}function rbStartTagInBody(e,t){e.openElements.hasInScope(html_js_1.TAG_ID.RUBY)&&e.openElements.generateImpliedEndTags(),e._insertElement(t,html_js_1.NS.HTML)}function rtStartTagInBody(e,t){e.openElements.hasInScope(html_js_1.TAG_ID.RUBY)&&e.openElements.generateImpliedEndTagsWithExclusion(html_js_1.TAG_ID.RTC),e._insertElement(t,html_js_1.NS.HTML)}function mathStartTagInBody(e,t){e._reconstructActiveFormattingElements(),t.selfClosing?e._appendElement(t,html_js_1.NS.MATHML):e._insertElement(t,html_js_1.NS.MATHML),t.ackSelfClosing=!0}function svgStartTagInBody(e,t){e._reconstructActiveFormattingElements(),t.selfClosing?e._appendElement(t,html_js_1.NS.SVG):e._insertElement(t,html_js_1.NS.SVG),t.ackSelfClosing=!0}function genericStartTagInBody(e,t){e._reconstructActiveFormattingElements(),e._insertElement(t,html_js_1.NS.HTML)}function startTagInBody(e,t){switch(t.tagID){case html_js_1.TAG_ID.I:case html_js_1.TAG_ID.S:case html_js_1.TAG_ID.B:case html_js_1.TAG_ID.U:case html_js_1.TAG_ID.EM:case html_js_1.TAG_ID.TT:case html_js_1.TAG_ID.BIG:case html_js_1.TAG_ID.CODE:case html_js_1.TAG_ID.FONT:case html_js_1.TAG_ID.SMALL:case html_js_1.TAG_ID.STRIKE:case html_js_1.TAG_ID.STRONG:bStartTagInBody(e,t);break;case html_js_1.TAG_ID.A:aStartTagInBody(e,t);break;case html_js_1.TAG_ID.H1:case html_js_1.TAG_ID.H2:case html_js_1.TAG_ID.H3:case html_js_1.TAG_ID.H4:case html_js_1.TAG_ID.H5:case html_js_1.TAG_ID.H6:numberedHeaderStartTagInBody(e,t);break;case html_js_1.TAG_ID.P:case html_js_1.TAG_ID.DL:case html_js_1.TAG_ID.OL:case html_js_1.TAG_ID.UL:case html_js_1.TAG_ID.DIV:case html_js_1.TAG_ID.DIR:case html_js_1.TAG_ID.NAV:case html_js_1.TAG_ID.MAIN:case html_js_1.TAG_ID.MENU:case html_js_1.TAG_ID.ASIDE:case html_js_1.TAG_ID.CENTER:case html_js_1.TAG_ID.FIGURE:case html_js_1.TAG_ID.FOOTER:case html_js_1.TAG_ID.HEADER:case html_js_1.TAG_ID.HGROUP:case html_js_1.TAG_ID.DIALOG:case html_js_1.TAG_ID.DETAILS:case html_js_1.TAG_ID.ADDRESS:case html_js_1.TAG_ID.ARTICLE:case html_js_1.TAG_ID.SECTION:case html_js_1.TAG_ID.SUMMARY:case html_js_1.TAG_ID.FIELDSET:case html_js_1.TAG_ID.BLOCKQUOTE:case html_js_1.TAG_ID.FIGCAPTION:addressStartTagInBody(e,t);break;case html_js_1.TAG_ID.LI:case html_js_1.TAG_ID.DD:case html_js_1.TAG_ID.DT:listItemStartTagInBody(e,t);break;case html_js_1.TAG_ID.BR:case html_js_1.TAG_ID.IMG:case html_js_1.TAG_ID.WBR:case html_js_1.TAG_ID.AREA:case html_js_1.TAG_ID.EMBED:case html_js_1.TAG_ID.WEB:case html_js_1.TAG_ID.XCOMPONENT:case html_js_1.TAG_ID.RATING:case html_js_1.TAG_ID.CANVAS:case html_js_1.TAG_ID.CAMERA:case html_js_1.TAG_ID.AUDIO:case html_js_1.TAG_ID.VIDEO:case html_js_1.TAG_ID.SWITCH:case html_js_1.TAG_ID.QRCODE:case html_js_1.TAG_ID.PICKER_VIEW:case html_js_1.TAG_ID.PICKER:case html_js_1.TAG_ID.PROGRESS:case html_js_1.TAG_ID.SEARCH:case html_js_1.TAG_ID.SLIDER:case html_js_1.TAG_ID.CHART:case html_js_1.TAG_ID.CALENDAR:case html_js_1.TAG_ID.DIVIDER:case html_js_1.TAG_ID.IMAGE_ANIMATOR:case html_js_1.TAG_ID.KEYGEN:areaStartTagInBody(e,t);break;case html_js_1.TAG_ID.HR:hrStartTagInBody(e,t);break;case html_js_1.TAG_ID.RB:case html_js_1.TAG_ID.RTC:rbStartTagInBody(e,t);break;case html_js_1.TAG_ID.RT:case html_js_1.TAG_ID.RP:rtStartTagInBody(e,t);break;case html_js_1.TAG_ID.PRE:case html_js_1.TAG_ID.LISTING:preStartTagInBody(e,t);break;case html_js_1.TAG_ID.XMP:xmpStartTagInBody(e,t);break;case html_js_1.TAG_ID.SVG:svgStartTagInBody(e,t);break;case html_js_1.TAG_ID.HTML:htmlStartTagInBody(e,t);break;case html_js_1.TAG_ID.BASE:case html_js_1.TAG_ID.LINK:case html_js_1.TAG_ID.META:case html_js_1.TAG_ID.STYLE:case html_js_1.TAG_ID.TITLE:case html_js_1.TAG_ID.SCRIPT:case html_js_1.TAG_ID.BGSOUND:case html_js_1.TAG_ID.BASEFONT:case html_js_1.TAG_ID.TEMPLATE:startTagInHead(e,t);break;case html_js_1.TAG_ID.BODY:bodyStartTagInBody(e,t);break;case html_js_1.TAG_ID.FORM:formStartTagInBody(e,t);break;case html_js_1.TAG_ID.NOBR:nobrStartTagInBody(e,t);break;case html_js_1.TAG_ID.MATH:mathStartTagInBody(e,t);break;case html_js_1.TAG_ID.TABLE:tableStartTagInBody(e,t);break;case html_js_1.TAG_ID.INPUT:inputStartTagInBody(e,t);break;case html_js_1.TAG_ID.PARAM:case html_js_1.TAG_ID.TRACK:case html_js_1.TAG_ID.SOURCE:paramStartTagInBody(e,t);break;case html_js_1.TAG_ID.IMAGE:imageStartTagInBody(e,t);break;case html_js_1.TAG_ID.BUTTON:buttonStartTagInBody(e,t);break;case html_js_1.TAG_ID.APPLET:case html_js_1.TAG_ID.OBJECT:case html_js_1.TAG_ID.MARQUEE:appletStartTagInBody(e,t);break;case html_js_1.TAG_ID.IFRAME:iframeStartTagInBody(e,t);break;case html_js_1.TAG_ID.SELECT:selectStartTagInBody(e,t);break;case html_js_1.TAG_ID.OPTION:case html_js_1.TAG_ID.OPTGROUP:optgroupStartTagInBody(e,t);break;case html_js_1.TAG_ID.NOEMBED:noembedStartTagInBody(e,t);break;case html_js_1.TAG_ID.FRAMESET:framesetStartTagInBody(e,t);break;case html_js_1.TAG_ID.TEXTAREA:textareaStartTagInBody(e,t);break;case html_js_1.TAG_ID.NOSCRIPT:(e.options.scriptingEnabled?noembedStartTagInBody:genericStartTagInBody)(e,t);break;case html_js_1.TAG_ID.PLAINTEXT:plaintextStartTagInBody(e,t);break;case html_js_1.TAG_ID.COL:case html_js_1.TAG_ID.TH:case html_js_1.TAG_ID.TD:case html_js_1.TAG_ID.TR:case html_js_1.TAG_ID.HEAD:case html_js_1.TAG_ID.FRAME:case html_js_1.TAG_ID.TBODY:case html_js_1.TAG_ID.TFOOT:case html_js_1.TAG_ID.THEAD:case html_js_1.TAG_ID.CAPTION:case html_js_1.TAG_ID.COLGROUP:break;default:genericStartTagInBody(e,t)}}function bodyEndTagInBody(e,t){var n;e.openElements.hasInScope(html_js_1.TAG_ID.BODY)&&(e.insertionMode=InsertionMode.AFTER_BODY,e.options.sourceCodeLocationInfo)&&(n=e.openElements.tryPeekProperlyNestedBodyElement())&&e._setEndLocation(n,t)}function htmlEndTagInBody(e,t){e.openElements.hasInScope(html_js_1.TAG_ID.BODY)&&(e.insertionMode=InsertionMode.AFTER_BODY,endTagAfterBody(e,t))}function addressEndTagInBody(e,t){t=t.tagID;e.openElements.hasInScope(t)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped(t))}function formEndTagInBody(e){var t=0<e.openElements.tmplCount,n=e["formElement"];t||(e.formElement=null),(n||t)&&e.openElements.hasInScope(html_js_1.TAG_ID.FORM)&&(e.openElements.generateImpliedEndTags(),t?e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.FORM):n&&e.openElements.remove(n))}function pEndTagInBody(e){e.openElements.hasInButtonScope(html_js_1.TAG_ID.P)||e._insertFakeElement(html_js_1.TAG_NAMES.P,html_js_1.TAG_ID.P),e._closePElement()}function liEndTagInBody(e){e.openElements.hasInListItemScope(html_js_1.TAG_ID.LI)&&(e.openElements.generateImpliedEndTagsWithExclusion(html_js_1.TAG_ID.LI),e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.LI))}function ddEndTagInBody(e,t){t=t.tagID;e.openElements.hasInScope(t)&&(e.openElements.generateImpliedEndTagsWithExclusion(t),e.openElements.popUntilTagNamePopped(t))}function numberedHeaderEndTagInBody(e){e.openElements.hasNumberedHeaderInScope()&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilNumberedHeaderPopped())}function appletEndTagInBody(e,t){t=t.tagID;e.openElements.hasInScope(t)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped(t),e.activeFormattingElements.clearToLastMarker())}function brEndTagInBody(e){e._reconstructActiveFormattingElements(),e._insertFakeElement(html_js_1.TAG_NAMES.BR,html_js_1.TAG_ID.BR),e.openElements.pop(),e.framesetOk=!1}function genericEndTagInBody(t,e){var n=e.tagName,s=e.tagID;for(let e=t.openElements.stackTop;0<e;e--){var a=t.openElements.items[e],o=t.openElements.tagIDs[e];if(s===o&&(s!==html_js_1.TAG_ID.UNKNOWN||t.treeAdapter.getTagName(a)===n)){t.openElements.generateImpliedEndTagsWithExclusion(s),t.openElements.stackTop>=e&&t.openElements.shortenToLength(e);break}if(t._isSpecialElement(a,o))break}}function endTagInBody(e,t){switch(t.tagID){case html_js_1.TAG_ID.A:case html_js_1.TAG_ID.B:case html_js_1.TAG_ID.I:case html_js_1.TAG_ID.S:case html_js_1.TAG_ID.U:case html_js_1.TAG_ID.EM:case html_js_1.TAG_ID.TT:case html_js_1.TAG_ID.BIG:case html_js_1.TAG_ID.CODE:case html_js_1.TAG_ID.FONT:case html_js_1.TAG_ID.NOBR:case html_js_1.TAG_ID.SMALL:case html_js_1.TAG_ID.STRIKE:case html_js_1.TAG_ID.STRONG:callAdoptionAgency(e,t);break;case html_js_1.TAG_ID.P:pEndTagInBody(e);break;case html_js_1.TAG_ID.DL:case html_js_1.TAG_ID.UL:case html_js_1.TAG_ID.OL:case html_js_1.TAG_ID.DIR:case html_js_1.TAG_ID.DIV:case html_js_1.TAG_ID.NAV:case html_js_1.TAG_ID.PRE:case html_js_1.TAG_ID.MAIN:case html_js_1.TAG_ID.MENU:case html_js_1.TAG_ID.ASIDE:case html_js_1.TAG_ID.BUTTON:case html_js_1.TAG_ID.CENTER:case html_js_1.TAG_ID.FIGURE:case html_js_1.TAG_ID.FOOTER:case html_js_1.TAG_ID.HEADER:case html_js_1.TAG_ID.HGROUP:case html_js_1.TAG_ID.DIALOG:case html_js_1.TAG_ID.ADDRESS:case html_js_1.TAG_ID.ARTICLE:case html_js_1.TAG_ID.DETAILS:case html_js_1.TAG_ID.SECTION:case html_js_1.TAG_ID.SUMMARY:case html_js_1.TAG_ID.LISTING:case html_js_1.TAG_ID.FIELDSET:case html_js_1.TAG_ID.BLOCKQUOTE:case html_js_1.TAG_ID.FIGCAPTION:addressEndTagInBody(e,t);break;case html_js_1.TAG_ID.LI:liEndTagInBody(e);break;case html_js_1.TAG_ID.DD:case html_js_1.TAG_ID.DT:ddEndTagInBody(e,t);break;case html_js_1.TAG_ID.H1:case html_js_1.TAG_ID.H2:case html_js_1.TAG_ID.H3:case html_js_1.TAG_ID.H4:case html_js_1.TAG_ID.H5:case html_js_1.TAG_ID.H6:numberedHeaderEndTagInBody(e);break;case html_js_1.TAG_ID.BR:brEndTagInBody(e);break;case html_js_1.TAG_ID.BODY:bodyEndTagInBody(e,t);break;case html_js_1.TAG_ID.HTML:htmlEndTagInBody(e,t);break;case html_js_1.TAG_ID.FORM:formEndTagInBody(e);break;case html_js_1.TAG_ID.APPLET:case html_js_1.TAG_ID.OBJECT:case html_js_1.TAG_ID.MARQUEE:appletEndTagInBody(e,t);break;case html_js_1.TAG_ID.TEMPLATE:templateEndTagInHead(e,t);break;default:genericEndTagInBody(e,t)}}function eofInBody(e,t){(0<e.tmplInsertionModeStack.length?eofInTemplate:stopParsing)(e,t)}function endTagInText(e,t){t.tagID===html_js_1.TAG_ID.SCRIPT&&null!=(t=e.scriptHandler)&&t.call(e,e.openElements.current),e.openElements.pop(),e.insertionMode=e.originalInsertionMode}function eofInText(e,t){e._err(t,error_codes_js_1.ERR.eofInElementThatCanContainOnlyText),e.openElements.pop(),e.insertionMode=e.originalInsertionMode,e.onEof(t)}function characterInTable(e,t){if(TABLE_STRUCTURE_TAGS.has(e.openElements.currentTagId))switch(e.pendingCharacterTokens.length=0,e.hasNonWhitespacePendingCharacterToken=!1,e.originalInsertionMode=e.insertionMode,e.insertionMode=InsertionMode.IN_TABLE_TEXT,t.type){case token_js_1.TokenType.CHARACTER:characterInTableText(e,t);break;case token_js_1.TokenType.WHITESPACE_CHARACTER:whitespaceCharacterInTableText(e,t)}else tokenInTable(e,t)}function captionStartTagInTable(e,t){e.openElements.clearBackToTableContext(),e.activeFormattingElements.insertMarker(),e._insertElement(t,html_js_1.NS.HTML),e.insertionMode=InsertionMode.IN_CAPTION}function colgroupStartTagInTable(e,t){e.openElements.clearBackToTableContext(),e._insertElement(t,html_js_1.NS.HTML),e.insertionMode=InsertionMode.IN_COLUMN_GROUP}function colStartTagInTable(e,t){e.openElements.clearBackToTableContext(),e._insertFakeElement(html_js_1.TAG_NAMES.COLGROUP,html_js_1.TAG_ID.COLGROUP),e.insertionMode=InsertionMode.IN_COLUMN_GROUP,startTagInColumnGroup(e,t)}function tbodyStartTagInTable(e,t){e.openElements.clearBackToTableContext(),e._insertElement(t,html_js_1.NS.HTML),e.insertionMode=InsertionMode.IN_TABLE_BODY}function tdStartTagInTable(e,t){e.openElements.clearBackToTableContext(),e._insertFakeElement(html_js_1.TAG_NAMES.TBODY,html_js_1.TAG_ID.TBODY),e.insertionMode=InsertionMode.IN_TABLE_BODY,startTagInTableBody(e,t)}function tableStartTagInTable(e,t){e.openElements.hasInTableScope(html_js_1.TAG_ID.TABLE)&&(e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.TABLE),e._resetInsertionMode(),e._processStartTag(t))}function inputStartTagInTable(e,t){isHiddenInput(t)?e._appendElement(t,html_js_1.NS.HTML):tokenInTable(e,t),t.ackSelfClosing=!0}function formStartTagInTable(e,t){e.formElement||0!==e.openElements.tmplCount||(e._insertElement(t,html_js_1.NS.HTML),e.formElement=e.openElements.current,e.openElements.pop())}function startTagInTable(e,t){switch(t.tagID){case html_js_1.TAG_ID.TD:case html_js_1.TAG_ID.TH:case html_js_1.TAG_ID.TR:tdStartTagInTable(e,t);break;case html_js_1.TAG_ID.STYLE:case html_js_1.TAG_ID.SCRIPT:case html_js_1.TAG_ID.TEMPLATE:startTagInHead(e,t);break;case html_js_1.TAG_ID.COL:colStartTagInTable(e,t);break;case html_js_1.TAG_ID.FORM:formStartTagInTable(e,t);break;case html_js_1.TAG_ID.TABLE:tableStartTagInTable(e,t);break;case html_js_1.TAG_ID.TBODY:case html_js_1.TAG_ID.TFOOT:case html_js_1.TAG_ID.THEAD:tbodyStartTagInTable(e,t);break;case html_js_1.TAG_ID.INPUT:inputStartTagInTable(e,t);break;case html_js_1.TAG_ID.CAPTION:captionStartTagInTable(e,t);break;case html_js_1.TAG_ID.COLGROUP:colgroupStartTagInTable(e,t);break;default:tokenInTable(e,t)}}function endTagInTable(e,t){switch(t.tagID){case html_js_1.TAG_ID.TABLE:e.openElements.hasInTableScope(html_js_1.TAG_ID.TABLE)&&(e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.TABLE),e._resetInsertionMode());break;case html_js_1.TAG_ID.TEMPLATE:templateEndTagInHead(e,t);break;case html_js_1.TAG_ID.BODY:case html_js_1.TAG_ID.CAPTION:case html_js_1.TAG_ID.COL:case html_js_1.TAG_ID.COLGROUP:case html_js_1.TAG_ID.HTML:case html_js_1.TAG_ID.TBODY:case html_js_1.TAG_ID.TD:case html_js_1.TAG_ID.TFOOT:case html_js_1.TAG_ID.TH:case html_js_1.TAG_ID.THEAD:case html_js_1.TAG_ID.TR:break;default:tokenInTable(e,t)}}function tokenInTable(e,t){var n=e.fosterParentingEnabled;e.fosterParentingEnabled=!0,modeInBody(e,t),e.fosterParentingEnabled=n}function whitespaceCharacterInTableText(e,t){e.pendingCharacterTokens.push(t)}function characterInTableText(e,t){e.pendingCharacterTokens.push(t),e.hasNonWhitespacePendingCharacterToken=!0}function tokenInTableText(e,t){let n=0;if(e.hasNonWhitespacePendingCharacterToken)for(;n<e.pendingCharacterTokens.length;n++)tokenInTable(e,e.pendingCharacterTokens[n]);else for(;n<e.pendingCharacterTokens.length;n++)e._insertCharacters(e.pendingCharacterTokens[n]);e.insertionMode=e.originalInsertionMode,e._processToken(t)}exports.Parser=Parser;const TABLE_VOID_ELEMENTS=new Set([html_js_1.TAG_ID.CAPTION,html_js_1.TAG_ID.COL,html_js_1.TAG_ID.COLGROUP,html_js_1.TAG_ID.TBODY,html_js_1.TAG_ID.TD,html_js_1.TAG_ID.TFOOT,html_js_1.TAG_ID.TH,html_js_1.TAG_ID.THEAD,html_js_1.TAG_ID.TR]);function startTagInCaption(e,t){var n=t.tagID;TABLE_VOID_ELEMENTS.has(n)?e.openElements.hasInTableScope(html_js_1.TAG_ID.CAPTION)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.CAPTION),e.activeFormattingElements.clearToLastMarker(),e.insertionMode=InsertionMode.IN_TABLE,startTagInTable(e,t)):startTagInBody(e,t)}function endTagInCaption(e,t){var n=t.tagID;switch(n){case html_js_1.TAG_ID.CAPTION:case html_js_1.TAG_ID.TABLE:e.openElements.hasInTableScope(html_js_1.TAG_ID.CAPTION)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.CAPTION),e.activeFormattingElements.clearToLastMarker(),e.insertionMode=InsertionMode.IN_TABLE,n===html_js_1.TAG_ID.TABLE)&&endTagInTable(e,t);break;case html_js_1.TAG_ID.BODY:case html_js_1.TAG_ID.COL:case html_js_1.TAG_ID.COLGROUP:case html_js_1.TAG_ID.HTML:case html_js_1.TAG_ID.TBODY:case html_js_1.TAG_ID.TD:case html_js_1.TAG_ID.TFOOT:case html_js_1.TAG_ID.TH:case html_js_1.TAG_ID.THEAD:case html_js_1.TAG_ID.TR:break;default:endTagInBody(e,t)}}function startTagInColumnGroup(e,t){switch(t.tagID){case html_js_1.TAG_ID.HTML:startTagInBody(e,t);break;case html_js_1.TAG_ID.COL:e._appendElement(t,html_js_1.NS.HTML),t.ackSelfClosing=!0;break;case html_js_1.TAG_ID.TEMPLATE:startTagInHead(e,t);break;default:tokenInColumnGroup(e,t)}}function endTagInColumnGroup(e,t){switch(t.tagID){case html_js_1.TAG_ID.COLGROUP:e.openElements.currentTagId===html_js_1.TAG_ID.COLGROUP&&(e.openElements.pop(),e.insertionMode=InsertionMode.IN_TABLE);break;case html_js_1.TAG_ID.TEMPLATE:templateEndTagInHead(e,t);break;case html_js_1.TAG_ID.COL:break;default:tokenInColumnGroup(e,t)}}function tokenInColumnGroup(e,t){e.openElements.currentTagId===html_js_1.TAG_ID.COLGROUP&&(e.openElements.pop(),e.insertionMode=InsertionMode.IN_TABLE,e._processToken(t))}function startTagInTableBody(e,t){switch(t.tagID){case html_js_1.TAG_ID.TR:e.openElements.clearBackToTableBodyContext(),e._insertElement(t,html_js_1.NS.HTML),e.insertionMode=InsertionMode.IN_ROW;break;case html_js_1.TAG_ID.TH:case html_js_1.TAG_ID.TD:e.openElements.clearBackToTableBodyContext(),e._insertFakeElement(html_js_1.TAG_NAMES.TR,html_js_1.TAG_ID.TR),e.insertionMode=InsertionMode.IN_ROW,startTagInRow(e,t);break;case html_js_1.TAG_ID.CAPTION:case html_js_1.TAG_ID.COL:case html_js_1.TAG_ID.COLGROUP:case html_js_1.TAG_ID.TBODY:case html_js_1.TAG_ID.TFOOT:case html_js_1.TAG_ID.THEAD:e.openElements.hasTableBodyContextInTableScope()&&(e.openElements.clearBackToTableBodyContext(),e.openElements.pop(),e.insertionMode=InsertionMode.IN_TABLE,startTagInTable(e,t));break;default:startTagInTable(e,t)}}function endTagInTableBody(e,t){var n=t.tagID;switch(t.tagID){case html_js_1.TAG_ID.TBODY:case html_js_1.TAG_ID.TFOOT:case html_js_1.TAG_ID.THEAD:e.openElements.hasInTableScope(n)&&(e.openElements.clearBackToTableBodyContext(),e.openElements.pop(),e.insertionMode=InsertionMode.IN_TABLE);break;case html_js_1.TAG_ID.TABLE:e.openElements.hasTableBodyContextInTableScope()&&(e.openElements.clearBackToTableBodyContext(),e.openElements.pop(),e.insertionMode=InsertionMode.IN_TABLE,endTagInTable(e,t));break;case html_js_1.TAG_ID.BODY:case html_js_1.TAG_ID.CAPTION:case html_js_1.TAG_ID.COL:case html_js_1.TAG_ID.COLGROUP:case html_js_1.TAG_ID.HTML:case html_js_1.TAG_ID.TD:case html_js_1.TAG_ID.TH:case html_js_1.TAG_ID.TR:break;default:endTagInTable(e,t)}}function startTagInRow(e,t){switch(t.tagID){case html_js_1.TAG_ID.TH:case html_js_1.TAG_ID.TD:e.openElements.clearBackToTableRowContext(),e._insertElement(t,html_js_1.NS.HTML),e.insertionMode=InsertionMode.IN_CELL,e.activeFormattingElements.insertMarker();break;case html_js_1.TAG_ID.CAPTION:case html_js_1.TAG_ID.COL:case html_js_1.TAG_ID.COLGROUP:case html_js_1.TAG_ID.TBODY:case html_js_1.TAG_ID.TFOOT:case html_js_1.TAG_ID.THEAD:case html_js_1.TAG_ID.TR:e.openElements.hasInTableScope(html_js_1.TAG_ID.TR)&&(e.openElements.clearBackToTableRowContext(),e.openElements.pop(),e.insertionMode=InsertionMode.IN_TABLE_BODY,startTagInTableBody(e,t));break;default:startTagInTable(e,t)}}function endTagInRow(e,t){switch(t.tagID){case html_js_1.TAG_ID.TR:e.openElements.hasInTableScope(html_js_1.TAG_ID.TR)&&(e.openElements.clearBackToTableRowContext(),e.openElements.pop(),e.insertionMode=InsertionMode.IN_TABLE_BODY);break;case html_js_1.TAG_ID.TABLE:e.openElements.hasInTableScope(html_js_1.TAG_ID.TR)&&(e.openElements.clearBackToTableRowContext(),e.openElements.pop(),e.insertionMode=InsertionMode.IN_TABLE_BODY,endTagInTableBody(e,t));break;case html_js_1.TAG_ID.TBODY:case html_js_1.TAG_ID.TFOOT:case html_js_1.TAG_ID.THEAD:(e.openElements.hasInTableScope(t.tagID)||e.openElements.hasInTableScope(html_js_1.TAG_ID.TR))&&(e.openElements.clearBackToTableRowContext(),e.openElements.pop(),e.insertionMode=InsertionMode.IN_TABLE_BODY,endTagInTableBody(e,t));break;case html_js_1.TAG_ID.BODY:case html_js_1.TAG_ID.CAPTION:case html_js_1.TAG_ID.COL:case html_js_1.TAG_ID.COLGROUP:case html_js_1.TAG_ID.HTML:case html_js_1.TAG_ID.TD:case html_js_1.TAG_ID.TH:break;default:endTagInTable(e,t)}}function startTagInCell(e,t){var n=t.tagID;TABLE_VOID_ELEMENTS.has(n)?(e.openElements.hasInTableScope(html_js_1.TAG_ID.TD)||e.openElements.hasInTableScope(html_js_1.TAG_ID.TH))&&(e._closeTableCell(),startTagInRow(e,t)):startTagInBody(e,t)}function endTagInCell(e,t){var n=t.tagID;switch(n){case html_js_1.TAG_ID.TD:case html_js_1.TAG_ID.TH:e.openElements.hasInTableScope(n)&&(e.openElements.generateImpliedEndTags(),e.openElements.popUntilTagNamePopped(n),e.activeFormattingElements.clearToLastMarker(),e.insertionMode=InsertionMode.IN_ROW);break;case html_js_1.TAG_ID.TABLE:case html_js_1.TAG_ID.TBODY:case html_js_1.TAG_ID.TFOOT:case html_js_1.TAG_ID.THEAD:case html_js_1.TAG_ID.TR:e.openElements.hasInTableScope(n)&&(e._closeTableCell(),endTagInRow(e,t));break;case html_js_1.TAG_ID.BODY:case html_js_1.TAG_ID.CAPTION:case html_js_1.TAG_ID.COL:case html_js_1.TAG_ID.COLGROUP:case html_js_1.TAG_ID.HTML:break;default:endTagInBody(e,t)}}function startTagInSelect(e,t){switch(t.tagID){case html_js_1.TAG_ID.HTML:startTagInBody(e,t);break;case html_js_1.TAG_ID.OPTION:e.openElements.currentTagId===html_js_1.TAG_ID.OPTION&&e.openElements.pop(),e._insertElement(t,html_js_1.NS.HTML);break;case html_js_1.TAG_ID.OPTGROUP:e.openElements.currentTagId===html_js_1.TAG_ID.OPTION&&e.openElements.pop(),e.openElements.currentTagId===html_js_1.TAG_ID.OPTGROUP&&e.openElements.pop(),e._insertElement(t,html_js_1.NS.HTML);break;case html_js_1.TAG_ID.INPUT:case html_js_1.TAG_ID.KEYGEN:case html_js_1.TAG_ID.TEXTAREA:case html_js_1.TAG_ID.SELECT:e.openElements.hasInSelectScope(html_js_1.TAG_ID.SELECT)&&(e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.SELECT),e._resetInsertionMode(),t.tagID!==html_js_1.TAG_ID.SELECT)&&e._processStartTag(t);break;case html_js_1.TAG_ID.SCRIPT:case html_js_1.TAG_ID.TEMPLATE:startTagInHead(e,t)}}function endTagInSelect(e,t){switch(t.tagID){case html_js_1.TAG_ID.OPTGROUP:0<e.openElements.stackTop&&e.openElements.currentTagId===html_js_1.TAG_ID.OPTION&&e.openElements.tagIDs[e.openElements.stackTop-1]===html_js_1.TAG_ID.OPTGROUP&&e.openElements.pop(),e.openElements.currentTagId===html_js_1.TAG_ID.OPTGROUP&&e.openElements.pop();break;case html_js_1.TAG_ID.OPTION:e.openElements.currentTagId===html_js_1.TAG_ID.OPTION&&e.openElements.pop();break;case html_js_1.TAG_ID.SELECT:e.openElements.hasInSelectScope(html_js_1.TAG_ID.SELECT)&&(e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.SELECT),e._resetInsertionMode());break;case html_js_1.TAG_ID.TEMPLATE:templateEndTagInHead(e,t)}}function startTagInSelectInTable(e,t){var n=t.tagID;n===html_js_1.TAG_ID.CAPTION||n===html_js_1.TAG_ID.TABLE||n===html_js_1.TAG_ID.TBODY||n===html_js_1.TAG_ID.TFOOT||n===html_js_1.TAG_ID.THEAD||n===html_js_1.TAG_ID.TR||n===html_js_1.TAG_ID.TD||n===html_js_1.TAG_ID.TH?(e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.SELECT),e._resetInsertionMode(),e._processStartTag(t)):startTagInSelect(e,t)}function endTagInSelectInTable(e,t){var n=t.tagID;n===html_js_1.TAG_ID.CAPTION||n===html_js_1.TAG_ID.TABLE||n===html_js_1.TAG_ID.TBODY||n===html_js_1.TAG_ID.TFOOT||n===html_js_1.TAG_ID.THEAD||n===html_js_1.TAG_ID.TR||n===html_js_1.TAG_ID.TD||n===html_js_1.TAG_ID.TH?e.openElements.hasInTableScope(n)&&(e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.SELECT),e._resetInsertionMode(),e.onEndTag(t)):endTagInSelect(e,t)}function startTagInTemplate(e,t){switch(t.tagID){case html_js_1.TAG_ID.BASE:case html_js_1.TAG_ID.BASEFONT:case html_js_1.TAG_ID.BGSOUND:case html_js_1.TAG_ID.LINK:case html_js_1.TAG_ID.META:case html_js_1.TAG_ID.NOFRAMES:case html_js_1.TAG_ID.SCRIPT:case html_js_1.TAG_ID.STYLE:case html_js_1.TAG_ID.TEMPLATE:case html_js_1.TAG_ID.TITLE:startTagInHead(e,t);break;case html_js_1.TAG_ID.CAPTION:case html_js_1.TAG_ID.COLGROUP:case html_js_1.TAG_ID.TBODY:case html_js_1.TAG_ID.TFOOT:case html_js_1.TAG_ID.THEAD:e.tmplInsertionModeStack[0]=InsertionMode.IN_TABLE,e.insertionMode=InsertionMode.IN_TABLE,startTagInTable(e,t);break;case html_js_1.TAG_ID.COL:e.tmplInsertionModeStack[0]=InsertionMode.IN_COLUMN_GROUP,e.insertionMode=InsertionMode.IN_COLUMN_GROUP,startTagInColumnGroup(e,t);break;case html_js_1.TAG_ID.TR:e.tmplInsertionModeStack[0]=InsertionMode.IN_TABLE_BODY,e.insertionMode=InsertionMode.IN_TABLE_BODY,startTagInTableBody(e,t);break;case html_js_1.TAG_ID.TD:case html_js_1.TAG_ID.TH:e.tmplInsertionModeStack[0]=InsertionMode.IN_ROW,e.insertionMode=InsertionMode.IN_ROW,startTagInRow(e,t);break;default:e.tmplInsertionModeStack[0]=InsertionMode.IN_BODY,e.insertionMode=InsertionMode.IN_BODY,startTagInBody(e,t)}}function endTagInTemplate(e,t){t.tagID===html_js_1.TAG_ID.TEMPLATE&&templateEndTagInHead(e,t)}function eofInTemplate(e,t){0<e.openElements.tmplCount?(e.openElements.popUntilTagNamePopped(html_js_1.TAG_ID.TEMPLATE),e.activeFormattingElements.clearToLastMarker(),e.tmplInsertionModeStack.shift(),e._resetInsertionMode(),e.onEof(t)):stopParsing(e,t)}function startTagAfterBody(e,t){(t.tagID===html_js_1.TAG_ID.HTML?startTagInBody:tokenAfterBody)(e,t)}function endTagAfterBody(e,t){var n,s;t.tagID===html_js_1.TAG_ID.HTML?(e.fragmentContext||(e.insertionMode=InsertionMode.AFTER_AFTER_BODY),e.options.sourceCodeLocationInfo&&e.openElements.tagIDs[0]===html_js_1.TAG_ID.HTML&&(e._setEndLocation(e.openElements.items[0],t),!(s=e.openElements.items[1])||null!=(n=e.treeAdapter.getNodeSourceCodeLocation(s))&&n.endTag||e._setEndLocation(s,t))):tokenAfterBody(e,t)}function tokenAfterBody(e,t){e.insertionMode=InsertionMode.IN_BODY,modeInBody(e,t)}function startTagInFrameset(e,t){switch(t.tagID){case html_js_1.TAG_ID.HTML:startTagInBody(e,t);break;case html_js_1.TAG_ID.FRAMESET:e._insertElement(t,html_js_1.NS.HTML);break;case html_js_1.TAG_ID.FRAME:e._appendElement(t,html_js_1.NS.HTML),t.ackSelfClosing=!0;break;case html_js_1.TAG_ID.NOFRAMES:startTagInHead(e,t)}}function endTagInFrameset(e,t){t.tagID!==html_js_1.TAG_ID.FRAMESET||e.openElements.isRootHtmlElementCurrent()||(e.openElements.pop(),e.fragmentContext)||e.openElements.currentTagId===html_js_1.TAG_ID.FRAMESET||(e.insertionMode=InsertionMode.AFTER_FRAMESET)}function startTagAfterFrameset(e,t){switch(t.tagID){case html_js_1.TAG_ID.HTML:startTagInBody(e,t);break;case html_js_1.TAG_ID.NOFRAMES:startTagInHead(e,t)}}function endTagAfterFrameset(e,t){t.tagID===html_js_1.TAG_ID.HTML&&(e.insertionMode=InsertionMode.AFTER_AFTER_FRAMESET)}function startTagAfterAfterBody(e,t){(t.tagID===html_js_1.TAG_ID.HTML?startTagInBody:tokenAfterAfterBody)(e,t)}function tokenAfterAfterBody(e,t){e.insertionMode=InsertionMode.IN_BODY,modeInBody(e,t)}function startTagAfterAfterFrameset(e,t){switch(t.tagID){case html_js_1.TAG_ID.HTML:startTagInBody(e,t);break;case html_js_1.TAG_ID.NOFRAMES:startTagInHead(e,t)}}function nullCharacterInForeignContent(e,t){t.chars=unicode.REPLACEMENT_CHARACTER,e._insertCharacters(t)}function characterInForeignContent(e,t){e._insertCharacters(t),e.framesetOk=!1}function popUntilHtmlOrIntegrationPoint(e){for(;e.treeAdapter.getNamespaceURI(e.openElements.current)!==html_js_1.NS.HTML&&!e._isIntegrationPoint(e.openElements.currentTagId,e.openElements.current);)e.openElements.pop()}function startTagInForeignContent(e,t){var n;foreignContent.causesExit(t)?(popUntilHtmlOrIntegrationPoint(e),e._startTagOutsideForeignContent(t)):(n=e._getAdjustedCurrentElement(),n=e.treeAdapter.getNamespaceURI(n),t.selfClosing?e._appendElement(t,n):e._insertElement(t,n),t.ackSelfClosing=!0)}function endTagInForeignContent(t,n){if(n.tagID===html_js_1.TAG_ID.P||n.tagID===html_js_1.TAG_ID.BR)popUntilHtmlOrIntegrationPoint(t),t._endTagOutsideForeignContent(n);else for(let e=t.openElements.stackTop;0<e;e--){var s=t.openElements.items[e];if(t.treeAdapter.getNamespaceURI(s)===html_js_1.NS.HTML){t._endTagOutsideForeignContent(n);break}s=t.treeAdapter.getTagName(s);if(s.toLowerCase()===n.tagName){n.tagName=s,t.openElements.shortenToLength(e);break}}}