"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Tokenizer=exports.TokenizerMode=void 0;const preprocessor_js_1=require("./preprocessor.js"),unicode_js_1=require("../common/unicode.js"),token_js_1=require("../common/token.js"),decode_js_1=require("entities/lib/decode.js"),error_codes_js_1=require("../common/error-codes.js"),html_js_1=require("../common/html.js"),C1_CONTROLS_REFERENCE_REPLACEMENTS=new Map([[128,8364],[130,8218],[131,402],[132,8222],[133,8230],[134,8224],[135,8225],[136,710],[137,8240],[138,352],[139,8249],[140,338],[142,381],[145,8216],[146,8217],[147,8220],[148,8221],[149,8226],[150,8211],[151,8212],[152,732],[153,8482],[154,353],[155,8250],[156,339],[158,382],[159,376]]);var State;function isAsciiDigit(e){return e>=unicode_js_1.CODE_POINTS.DIGIT_0&&e<=unicode_js_1.CODE_POINTS.DIGIT_9}function isAsciiUpper(e){return e>=unicode_js_1.CODE_POINTS.LATIN_CAPITAL_A&&e<=unicode_js_1.CODE_POINTS.LATIN_CAPITAL_Z}function isAsciiLower(e){return e>=unicode_js_1.CODE_POINTS.LATIN_SMALL_A&&e<=unicode_js_1.CODE_POINTS.LATIN_SMALL_Z}function isAsciiLetter(e){return isAsciiLower(e)||isAsciiUpper(e)}function isAsciiAlphaNumeric(e){return isAsciiLetter(e)||isAsciiDigit(e)}function isAsciiUpperHexDigit(e){return e>=unicode_js_1.CODE_POINTS.LATIN_CAPITAL_A&&e<=unicode_js_1.CODE_POINTS.LATIN_CAPITAL_F}function isAsciiLowerHexDigit(e){return e>=unicode_js_1.CODE_POINTS.LATIN_SMALL_A&&e<=unicode_js_1.CODE_POINTS.LATIN_SMALL_F}function isAsciiHexDigit(e){return isAsciiDigit(e)||isAsciiUpperHexDigit(e)||isAsciiLowerHexDigit(e)}function toAsciiLower(e){return e+32}function isWhitespace(e){return e===unicode_js_1.CODE_POINTS.SPACE||e===unicode_js_1.CODE_POINTS.LINE_FEED||e===unicode_js_1.CODE_POINTS.TABULATION||e===unicode_js_1.CODE_POINTS.FORM_FEED}function isEntityInAttributeInvalidEnd(e){return e===unicode_js_1.CODE_POINTS.EQUALS_SIGN||isAsciiAlphaNumeric(e)}function isScriptDataDoubleEscapeSequenceEnd(e){return isWhitespace(e)||e===unicode_js_1.CODE_POINTS.SOLIDUS||e===unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN}!function(e){e[e.DATA=0]="DATA",e[e.RCDATA=1]="RCDATA",e[e.RAWTEXT=2]="RAWTEXT",e[e.SCRIPT_DATA=3]="SCRIPT_DATA",e[e.PLAINTEXT=4]="PLAINTEXT",e[e.TAG_OPEN=5]="TAG_OPEN",e[e.END_TAG_OPEN=6]="END_TAG_OPEN",e[e.TAG_NAME=7]="TAG_NAME",e[e.RCDATA_LESS_THAN_SIGN=8]="RCDATA_LESS_THAN_SIGN",e[e.RCDATA_END_TAG_OPEN=9]="RCDATA_END_TAG_OPEN",e[e.RCDATA_END_TAG_NAME=10]="RCDATA_END_TAG_NAME",e[e.RAWTEXT_LESS_THAN_SIGN=11]="RAWTEXT_LESS_THAN_SIGN",e[e.RAWTEXT_END_TAG_OPEN=12]="RAWTEXT_END_TAG_OPEN",e[e.RAWTEXT_END_TAG_NAME=13]="RAWTEXT_END_TAG_NAME",e[e.SCRIPT_DATA_LESS_THAN_SIGN=14]="SCRIPT_DATA_LESS_THAN_SIGN",e[e.SCRIPT_DATA_END_TAG_OPEN=15]="SCRIPT_DATA_END_TAG_OPEN",e[e.SCRIPT_DATA_END_TAG_NAME=16]="SCRIPT_DATA_END_TAG_NAME",e[e.SCRIPT_DATA_ESCAPE_START=17]="SCRIPT_DATA_ESCAPE_START",e[e.SCRIPT_DATA_ESCAPE_START_DASH=18]="SCRIPT_DATA_ESCAPE_START_DASH",e[e.SCRIPT_DATA_ESCAPED=19]="SCRIPT_DATA_ESCAPED",e[e.SCRIPT_DATA_ESCAPED_DASH=20]="SCRIPT_DATA_ESCAPED_DASH",e[e.SCRIPT_DATA_ESCAPED_DASH_DASH=21]="SCRIPT_DATA_ESCAPED_DASH_DASH",e[e.SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN=22]="SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN",e[e.SCRIPT_DATA_ESCAPED_END_TAG_OPEN=23]="SCRIPT_DATA_ESCAPED_END_TAG_OPEN",e[e.SCRIPT_DATA_ESCAPED_END_TAG_NAME=24]="SCRIPT_DATA_ESCAPED_END_TAG_NAME",e[e.SCRIPT_DATA_DOUBLE_ESCAPE_START=25]="SCRIPT_DATA_DOUBLE_ESCAPE_START",e[e.SCRIPT_DATA_DOUBLE_ESCAPED=26]="SCRIPT_DATA_DOUBLE_ESCAPED",e[e.SCRIPT_DATA_DOUBLE_ESCAPED_DASH=27]="SCRIPT_DATA_DOUBLE_ESCAPED_DASH",e[e.SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH=28]="SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH",e[e.SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN=29]="SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN",e[e.SCRIPT_DATA_DOUBLE_ESCAPE_END=30]="SCRIPT_DATA_DOUBLE_ESCAPE_END",e[e.BEFORE_ATTRIBUTE_NAME=31]="BEFORE_ATTRIBUTE_NAME",e[e.ATTRIBUTE_NAME=32]="ATTRIBUTE_NAME",e[e.AFTER_ATTRIBUTE_NAME=33]="AFTER_ATTRIBUTE_NAME",e[e.BEFORE_ATTRIBUTE_VALUE=34]="BEFORE_ATTRIBUTE_VALUE",e[e.ATTRIBUTE_VALUE_DOUBLE_QUOTED=35]="ATTRIBUTE_VALUE_DOUBLE_QUOTED",e[e.ATTRIBUTE_VALUE_SINGLE_QUOTED=36]="ATTRIBUTE_VALUE_SINGLE_QUOTED",e[e.ATTRIBUTE_VALUE_UNQUOTED=37]="ATTRIBUTE_VALUE_UNQUOTED",e[e.AFTER_ATTRIBUTE_VALUE_QUOTED=38]="AFTER_ATTRIBUTE_VALUE_QUOTED",e[e.SELF_CLOSING_START_TAG=39]="SELF_CLOSING_START_TAG",e[e.BOGUS_COMMENT=40]="BOGUS_COMMENT",e[e.MARKUP_DECLARATION_OPEN=41]="MARKUP_DECLARATION_OPEN",e[e.COMMENT_START=42]="COMMENT_START",e[e.COMMENT_START_DASH=43]="COMMENT_START_DASH",e[e.COMMENT=44]="COMMENT",e[e.COMMENT_LESS_THAN_SIGN=45]="COMMENT_LESS_THAN_SIGN",e[e.COMMENT_LESS_THAN_SIGN_BANG=46]="COMMENT_LESS_THAN_SIGN_BANG",e[e.COMMENT_LESS_THAN_SIGN_BANG_DASH=47]="COMMENT_LESS_THAN_SIGN_BANG_DASH",e[e.COMMENT_LESS_THAN_SIGN_BANG_DASH_DASH=48]="COMMENT_LESS_THAN_SIGN_BANG_DASH_DASH",e[e.COMMENT_END_DASH=49]="COMMENT_END_DASH",e[e.COMMENT_END=50]="COMMENT_END",e[e.COMMENT_END_BANG=51]="COMMENT_END_BANG",e[e.DOCTYPE=52]="DOCTYPE",e[e.BEFORE_DOCTYPE_NAME=53]="BEFORE_DOCTYPE_NAME",e[e.DOCTYPE_NAME=54]="DOCTYPE_NAME",e[e.AFTER_DOCTYPE_NAME=55]="AFTER_DOCTYPE_NAME",e[e.AFTER_DOCTYPE_PUBLIC_KEYWORD=56]="AFTER_DOCTYPE_PUBLIC_KEYWORD",e[e.BEFORE_DOCTYPE_PUBLIC_IDENTIFIER=57]="BEFORE_DOCTYPE_PUBLIC_IDENTIFIER",e[e.DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED=58]="DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED",e[e.DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED=59]="DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED",e[e.AFTER_DOCTYPE_PUBLIC_IDENTIFIER=60]="AFTER_DOCTYPE_PUBLIC_IDENTIFIER",e[e.BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS=61]="BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS",e[e.AFTER_DOCTYPE_SYSTEM_KEYWORD=62]="AFTER_DOCTYPE_SYSTEM_KEYWORD",e[e.BEFORE_DOCTYPE_SYSTEM_IDENTIFIER=63]="BEFORE_DOCTYPE_SYSTEM_IDENTIFIER",e[e.DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED=64]="DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED",e[e.DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED=65]="DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED",e[e.AFTER_DOCTYPE_SYSTEM_IDENTIFIER=66]="AFTER_DOCTYPE_SYSTEM_IDENTIFIER",e[e.BOGUS_DOCTYPE=67]="BOGUS_DOCTYPE",e[e.CDATA_SECTION=68]="CDATA_SECTION",e[e.CDATA_SECTION_BRACKET=69]="CDATA_SECTION_BRACKET",e[e.CDATA_SECTION_END=70]="CDATA_SECTION_END",e[e.CHARACTER_REFERENCE=71]="CHARACTER_REFERENCE",e[e.NAMED_CHARACTER_REFERENCE=72]="NAMED_CHARACTER_REFERENCE",e[e.AMBIGUOUS_AMPERSAND=73]="AMBIGUOUS_AMPERSAND",e[e.NUMERIC_CHARACTER_REFERENCE=74]="NUMERIC_CHARACTER_REFERENCE",e[e.HEXADEMICAL_CHARACTER_REFERENCE_START=75]="HEXADEMICAL_CHARACTER_REFERENCE_START",e[e.HEXADEMICAL_CHARACTER_REFERENCE=76]="HEXADEMICAL_CHARACTER_REFERENCE",e[e.DECIMAL_CHARACTER_REFERENCE=77]="DECIMAL_CHARACTER_REFERENCE",e[e.NUMERIC_CHARACTER_REFERENCE_END=78]="NUMERIC_CHARACTER_REFERENCE_END"}(State=State||{}),exports.TokenizerMode={DATA:State.DATA,RCDATA:State.RCDATA,RAWTEXT:State.RAWTEXT,SCRIPT_DATA:State.SCRIPT_DATA,PLAINTEXT:State.PLAINTEXT,CDATA_SECTION:State.CDATA_SECTION};const componentValidator={isSupportedSelfClosing:()=>!1};class Tokenizer{constructor(e,t){this.options=e,this.handler=t,this.paused=!1,this.inLoop=!1,this.inForeignNode=!1,this.lastStartTagName="",this.active=!1,this.nodeInfo={tn:"",sc:!1,pos:""},this.validator=componentValidator,this.compileResult={jsonTemplate:{},deps:[],log:[]},this.state=State.DATA,this.returnState=State.DATA,this.charRefCode=-1,this.consumedAfterSnapshot=-1,this.currentCharacterToken=null,this.currentToken=null,this.currentAttr={name:"",value:""},this.preprocessor=new preprocessor_js_1.Preprocessor(t),this.currentLocation=this.getCurrentLocation(-1),e.componentValidator&&(this.validator=e.componentValidator),e.compileResult&&(this.compileResult=e.compileResult)}_err(e){var t,_;null!=(_=(t=this.handler).onParseError)&&_.call(t,this.preprocessor.getError(e))}getCurrentLocation(e){return this.options.sourceCodeLocationInfo?{startLine:this.preprocessor.line,startCol:this.preprocessor.col-e,startOffset:this.preprocessor.offset-e,endLine:-1,endCol:-1,endOffset:-1}:null}_runParsingLoop(){if(!this.inLoop){for(this.inLoop=!0;this.active&&!this.paused;){this.consumedAfterSnapshot=0;var e=this._consume();this._ensureHibernation()||this._callState(e)}this.inLoop=!1}}pause(){this.paused=!0}resume(e){if(!this.paused)throw new Error("Parser was already resumed");this.paused=!1,this.inLoop||(this._runParsingLoop(),this.paused)||null!=e&&e()}write(e,t,_){this.active=!0,this.preprocessor.write(e,t),this._runParsingLoop(),this.paused||null!=_&&_()}insertHtmlAtCurrentPos(e){this.active=!0,this.preprocessor.insertHtmlAtCurrentPos(e),this._runParsingLoop()}_ensureHibernation(){return!(!this.preprocessor.endOfChunkHit||(this._unconsume(this.consumedAfterSnapshot),this.active=!1))}_consume(){return this.consumedAfterSnapshot++,this.preprocessor.advance()}_unconsume(e){this.consumedAfterSnapshot-=e,this.preprocessor.retreat(e)}_reconsumeInState(e,t){this.state=e,this._callState(t)}_advanceBy(t){this.consumedAfterSnapshot+=t;for(let e=0;e<t;e++)this.preprocessor.advance()}_consumeSequenceIfMatch(e,t){return!!this.preprocessor.startsWith(e,t)&&(this._advanceBy(e.length-1),!0)}_createStartTagToken(){this.currentToken={type:token_js_1.TokenType.START_TAG,tagName:"",tagID:html_js_1.TAG_ID.UNKNOWN,selfClosing:!1,ackSelfClosing:!1,attrs:[],location:this.getCurrentLocation(1)}}_createEndTagToken(){this.currentToken={type:token_js_1.TokenType.END_TAG,tagName:"",tagID:html_js_1.TAG_ID.UNKNOWN,selfClosing:!1,ackSelfClosing:!1,attrs:[],location:this.getCurrentLocation(2)}}_createCommentToken(e){this.currentToken={type:token_js_1.TokenType.COMMENT,data:"",location:this.getCurrentLocation(e)}}_createDoctypeToken(e){this.currentToken={type:token_js_1.TokenType.DOCTYPE,name:e,forceQuirks:!1,publicId:null,systemId:null,location:this.currentLocation}}_createCharacterToken(e,t){this.currentCharacterToken={type:e,chars:t,location:this.currentLocation}}_createAttr(e){this.currentAttr={name:e,value:""},this.currentLocation=this.getCurrentLocation(0)}_leaveAttrName(){var e,t=this.currentToken;null===(0,token_js_1.getTokenAttr)(t,this.currentAttr.name)?(t.attrs.push(this.currentAttr),t.location&&this.currentLocation&&((null!=(e=(t=t.location).attrs)?e:t.attrs=Object.create(null))[this.currentAttr.name]=this.currentLocation,this._leaveAttrValue())):this._err(error_codes_js_1.ERR.duplicateAttribute)}_leaveAttrValue(){this.currentLocation&&(this.currentLocation.endLine=this.preprocessor.line,this.currentLocation.endCol=this.preprocessor.col,this.currentLocation.endOffset=this.preprocessor.offset)}prepareToken(e){this._emitCurrentCharacterToken(e.location),this.currentToken=null,e.location&&(e.location.endLine=this.preprocessor.line,e.location.endCol=this.preprocessor.col+1,e.location.endOffset=this.preprocessor.offset+1),this.currentLocation=this.getCurrentLocation(-1)}emitCurrentTagToken(){var e=this.currentToken;checkselfClosingNode(this,e),this.prepareToken(e),e.tagID=(0,html_js_1.getTagID)(e.tagName),e.type===token_js_1.TokenType.START_TAG?(this.lastStartTagName=e.tagName,this.handler.onStartTag(e)):(0<e.attrs.length&&this._err(error_codes_js_1.ERR.endTagWithAttributes),e.selfClosing&&this._err(error_codes_js_1.ERR.endTagWithTrailingSolidus),this.handler.onEndTag(e)),this.preprocessor.dropParsedChunk()}emitCurrentComment(e){this.prepareToken(e),this.handler.onComment(e),this.preprocessor.dropParsedChunk()}emitCurrentDoctype(e){this.prepareToken(e),this.handler.onDoctype(e),this.preprocessor.dropParsedChunk()}_emitCurrentCharacterToken(e){if(this.currentCharacterToken){switch(e&&this.currentCharacterToken.location&&(this.currentCharacterToken.location.endLine=e.startLine,this.currentCharacterToken.location.endCol=e.startCol,this.currentCharacterToken.location.endOffset=e.startOffset),this.currentCharacterToken.type){case token_js_1.TokenType.CHARACTER:this.handler.onCharacter(this.currentCharacterToken);break;case token_js_1.TokenType.NULL_CHARACTER:this.handler.onNullCharacter(this.currentCharacterToken);break;case token_js_1.TokenType.WHITESPACE_CHARACTER:this.handler.onWhitespaceCharacter(this.currentCharacterToken)}this.currentCharacterToken=null}}_emitEOFToken(){var e=this.getCurrentLocation(0);e&&(e.endLine=e.startLine,e.endCol=e.startCol,e.endOffset=e.startOffset),this._emitCurrentCharacterToken(e),this.handler.onEof({type:token_js_1.TokenType.EOF,location:e}),this.active=!1}_appendCharToCurrentCharacterToken(e,t){if(this.currentCharacterToken){if(this.currentCharacterToken.type===e)return void(this.currentCharacterToken.chars+=t);this.currentLocation=this.getCurrentLocation(0),this._emitCurrentCharacterToken(this.currentLocation),this.preprocessor.dropParsedChunk()}this._createCharacterToken(e,t)}_emitCodePoint(e){var t=isWhitespace(e)?token_js_1.TokenType.WHITESPACE_CHARACTER:e===unicode_js_1.CODE_POINTS.NULL?token_js_1.TokenType.NULL_CHARACTER:token_js_1.TokenType.CHARACTER;this._appendCharToCurrentCharacterToken(t,String.fromCodePoint(e))}_emitChars(e){this._appendCharToCurrentCharacterToken(token_js_1.TokenType.CHARACTER,e)}_matchNamedCharacterReference(_){let s=null,a=0,r=!1;for(let e=0,t=decode_js_1.htmlDecodeTree[0];0<=e&&!((e=(0,decode_js_1.determineBranch)(decode_js_1.htmlDecodeTree,t,e+1,_))<0);_=this._consume()){a+=1;var i=(t=decode_js_1.htmlDecodeTree[e])&decode_js_1.BinTrieFlags.VALUE_LENGTH;if(i){i=(i>>14)-1;if(_!==unicode_js_1.CODE_POINTS.SEMICOLON&&this._isCharacterReferenceInAttribute()&&isEntityInAttributeInvalidEnd(this.preprocessor.peek(1))?(s=[unicode_js_1.CODE_POINTS.AMPERSAND],e+=i):(s=0==i?[decode_js_1.htmlDecodeTree[e]&~decode_js_1.BinTrieFlags.VALUE_LENGTH]:1==i?[decode_js_1.htmlDecodeTree[++e]]:[decode_js_1.htmlDecodeTree[++e],decode_js_1.htmlDecodeTree[++e]],a=0,r=_!==unicode_js_1.CODE_POINTS.SEMICOLON),0==i){this._consume();break}}}return this._unconsume(a),r&&!this.preprocessor.endOfChunkHit&&this._err(error_codes_js_1.ERR.missingSemicolonAfterCharacterReference),this._unconsume(1),s}_isCharacterReferenceInAttribute(){return this.returnState===State.ATTRIBUTE_VALUE_DOUBLE_QUOTED||this.returnState===State.ATTRIBUTE_VALUE_SINGLE_QUOTED||this.returnState===State.ATTRIBUTE_VALUE_UNQUOTED}_flushCodePointConsumedAsCharacterReference(e){this._isCharacterReferenceInAttribute()?this.currentAttr.value+=String.fromCodePoint(e):this._emitCodePoint(e)}_callState(e){switch(this.state){case State.DATA:this._stateData(e);break;case State.RCDATA:this._stateRcdata(e);break;case State.RAWTEXT:this._stateRawtext(e);break;case State.SCRIPT_DATA:this._stateScriptData(e);break;case State.PLAINTEXT:this._statePlaintext(e);break;case State.TAG_OPEN:this._stateTagOpen(e);break;case State.END_TAG_OPEN:this._stateEndTagOpen(e);break;case State.TAG_NAME:this._stateTagName(e);break;case State.RCDATA_LESS_THAN_SIGN:this._stateRcdataLessThanSign(e);break;case State.RCDATA_END_TAG_OPEN:this._stateRcdataEndTagOpen(e);break;case State.RCDATA_END_TAG_NAME:this._stateRcdataEndTagName(e);break;case State.RAWTEXT_LESS_THAN_SIGN:this._stateRawtextLessThanSign(e);break;case State.RAWTEXT_END_TAG_OPEN:this._stateRawtextEndTagOpen(e);break;case State.RAWTEXT_END_TAG_NAME:this._stateRawtextEndTagName(e);break;case State.SCRIPT_DATA_LESS_THAN_SIGN:this._stateScriptDataLessThanSign(e);break;case State.SCRIPT_DATA_END_TAG_OPEN:this._stateScriptDataEndTagOpen(e);break;case State.SCRIPT_DATA_END_TAG_NAME:this._stateScriptDataEndTagName(e);break;case State.SCRIPT_DATA_ESCAPE_START:this._stateScriptDataEscapeStart(e);break;case State.SCRIPT_DATA_ESCAPE_START_DASH:this._stateScriptDataEscapeStartDash(e);break;case State.SCRIPT_DATA_ESCAPED:this._stateScriptDataEscaped(e);break;case State.SCRIPT_DATA_ESCAPED_DASH:this._stateScriptDataEscapedDash(e);break;case State.SCRIPT_DATA_ESCAPED_DASH_DASH:this._stateScriptDataEscapedDashDash(e);break;case State.SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN:this._stateScriptDataEscapedLessThanSign(e);break;case State.SCRIPT_DATA_ESCAPED_END_TAG_OPEN:this._stateScriptDataEscapedEndTagOpen(e);break;case State.SCRIPT_DATA_ESCAPED_END_TAG_NAME:this._stateScriptDataEscapedEndTagName(e);break;case State.SCRIPT_DATA_DOUBLE_ESCAPE_START:this._stateScriptDataDoubleEscapeStart(e);break;case State.SCRIPT_DATA_DOUBLE_ESCAPED:this._stateScriptDataDoubleEscaped(e);break;case State.SCRIPT_DATA_DOUBLE_ESCAPED_DASH:this._stateScriptDataDoubleEscapedDash(e);break;case State.SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH:this._stateScriptDataDoubleEscapedDashDash(e);break;case State.SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN:this._stateScriptDataDoubleEscapedLessThanSign(e);break;case State.SCRIPT_DATA_DOUBLE_ESCAPE_END:this._stateScriptDataDoubleEscapeEnd(e);break;case State.BEFORE_ATTRIBUTE_NAME:this._stateBeforeAttributeName(e);break;case State.ATTRIBUTE_NAME:this._stateAttributeName(e);break;case State.AFTER_ATTRIBUTE_NAME:this._stateAfterAttributeName(e);break;case State.BEFORE_ATTRIBUTE_VALUE:this._stateBeforeAttributeValue(e);break;case State.ATTRIBUTE_VALUE_DOUBLE_QUOTED:this._stateAttributeValueDoubleQuoted(e);break;case State.ATTRIBUTE_VALUE_SINGLE_QUOTED:this._stateAttributeValueSingleQuoted(e);break;case State.ATTRIBUTE_VALUE_UNQUOTED:this._stateAttributeValueUnquoted(e);break;case State.AFTER_ATTRIBUTE_VALUE_QUOTED:this._stateAfterAttributeValueQuoted(e);break;case State.SELF_CLOSING_START_TAG:this._stateSelfClosingStartTag(e);break;case State.BOGUS_COMMENT:this._stateBogusComment(e);break;case State.MARKUP_DECLARATION_OPEN:this._stateMarkupDeclarationOpen(e);break;case State.COMMENT_START:this._stateCommentStart(e);break;case State.COMMENT_START_DASH:this._stateCommentStartDash(e);break;case State.COMMENT:this._stateComment(e);break;case State.COMMENT_LESS_THAN_SIGN:this._stateCommentLessThanSign(e);break;case State.COMMENT_LESS_THAN_SIGN_BANG:this._stateCommentLessThanSignBang(e);break;case State.COMMENT_LESS_THAN_SIGN_BANG_DASH:this._stateCommentLessThanSignBangDash(e);break;case State.COMMENT_LESS_THAN_SIGN_BANG_DASH_DASH:this._stateCommentLessThanSignBangDashDash(e);break;case State.COMMENT_END_DASH:this._stateCommentEndDash(e);break;case State.COMMENT_END:this._stateCommentEnd(e);break;case State.COMMENT_END_BANG:this._stateCommentEndBang(e);break;case State.DOCTYPE:this._stateDoctype(e);break;case State.BEFORE_DOCTYPE_NAME:this._stateBeforeDoctypeName(e);break;case State.DOCTYPE_NAME:this._stateDoctypeName(e);break;case State.AFTER_DOCTYPE_NAME:this._stateAfterDoctypeName(e);break;case State.AFTER_DOCTYPE_PUBLIC_KEYWORD:this._stateAfterDoctypePublicKeyword(e);break;case State.BEFORE_DOCTYPE_PUBLIC_IDENTIFIER:this._stateBeforeDoctypePublicIdentifier(e);break;case State.DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED:this._stateDoctypePublicIdentifierDoubleQuoted(e);break;case State.DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED:this._stateDoctypePublicIdentifierSingleQuoted(e);break;case State.AFTER_DOCTYPE_PUBLIC_IDENTIFIER:this._stateAfterDoctypePublicIdentifier(e);break;case State.BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS:this._stateBetweenDoctypePublicAndSystemIdentifiers(e);break;case State.AFTER_DOCTYPE_SYSTEM_KEYWORD:this._stateAfterDoctypeSystemKeyword(e);break;case State.BEFORE_DOCTYPE_SYSTEM_IDENTIFIER:this._stateBeforeDoctypeSystemIdentifier(e);break;case State.DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED:this._stateDoctypeSystemIdentifierDoubleQuoted(e);break;case State.DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED:this._stateDoctypeSystemIdentifierSingleQuoted(e);break;case State.AFTER_DOCTYPE_SYSTEM_IDENTIFIER:this._stateAfterDoctypeSystemIdentifier(e);break;case State.BOGUS_DOCTYPE:this._stateBogusDoctype(e);break;case State.CDATA_SECTION:this._stateCdataSection(e);break;case State.CDATA_SECTION_BRACKET:this._stateCdataSectionBracket(e);break;case State.CDATA_SECTION_END:this._stateCdataSectionEnd(e);break;case State.CHARACTER_REFERENCE:this._stateCharacterReference(e);break;case State.NAMED_CHARACTER_REFERENCE:this._stateNamedCharacterReference(e);break;case State.AMBIGUOUS_AMPERSAND:this._stateAmbiguousAmpersand(e);break;case State.NUMERIC_CHARACTER_REFERENCE:this._stateNumericCharacterReference(e);break;case State.HEXADEMICAL_CHARACTER_REFERENCE_START:this._stateHexademicalCharacterReferenceStart(e);break;case State.HEXADEMICAL_CHARACTER_REFERENCE:this._stateHexademicalCharacterReference(e);break;case State.DECIMAL_CHARACTER_REFERENCE:this._stateDecimalCharacterReference(e);break;case State.NUMERIC_CHARACTER_REFERENCE_END:this._stateNumericCharacterReferenceEnd(e);break;default:throw new Error("Unknown state")}}_stateData(e){switch(e){case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:this.state=State.TAG_OPEN;break;case unicode_js_1.CODE_POINTS.AMPERSAND:this.returnState=State.DATA,this.state=State.CHARACTER_REFERENCE;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this._emitCodePoint(e);break;case unicode_js_1.CODE_POINTS.EOF:this._emitEOFToken();break;default:this._emitCodePoint(e)}}_stateRcdata(e){switch(e){case unicode_js_1.CODE_POINTS.AMPERSAND:this.returnState=State.RCDATA,this.state=State.CHARACTER_REFERENCE;break;case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:this.state=State.RCDATA_LESS_THAN_SIGN;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this._emitChars(unicode_js_1.REPLACEMENT_CHARACTER);break;case unicode_js_1.CODE_POINTS.EOF:this._emitEOFToken();break;default:this._emitCodePoint(e)}}_stateRawtext(e){switch(e){case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:this.state=State.RAWTEXT_LESS_THAN_SIGN;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this._emitChars(unicode_js_1.REPLACEMENT_CHARACTER);break;case unicode_js_1.CODE_POINTS.EOF:this._emitEOFToken();break;default:this._emitCodePoint(e)}}_stateScriptData(e){switch(e){case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:this.state=State.SCRIPT_DATA_LESS_THAN_SIGN;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this._emitChars(unicode_js_1.REPLACEMENT_CHARACTER);break;case unicode_js_1.CODE_POINTS.EOF:this._emitEOFToken();break;default:this._emitCodePoint(e)}}_statePlaintext(e){switch(e){case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this._emitChars(unicode_js_1.REPLACEMENT_CHARACTER);break;case unicode_js_1.CODE_POINTS.EOF:this._emitEOFToken();break;default:this._emitCodePoint(e)}}_stateTagOpen(e){if(isAsciiLetter(e))this._createStartTagToken(),this.state=State.TAG_NAME,this._stateTagName(e);else switch(e){case unicode_js_1.CODE_POINTS.EXCLAMATION_MARK:this.state=State.MARKUP_DECLARATION_OPEN;break;case unicode_js_1.CODE_POINTS.SOLIDUS:this.state=State.END_TAG_OPEN;break;case unicode_js_1.CODE_POINTS.QUESTION_MARK:this._err(error_codes_js_1.ERR.unexpectedQuestionMarkInsteadOfTagName),this._createCommentToken(1),this.state=State.BOGUS_COMMENT,this._stateBogusComment(e);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofBeforeTagName),this._emitChars("<"),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.invalidFirstCharacterOfTagName),this._emitChars("<"),this.state=State.DATA,this._stateData(e)}}_stateEndTagOpen(e){if(isAsciiLetter(e))this._createEndTagToken(),this.state=State.TAG_NAME,this._stateTagName(e);else switch(e){case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.missingEndTagName),this.state=State.DATA;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofBeforeTagName),this._emitChars("</"),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.invalidFirstCharacterOfTagName),this._createCommentToken(2),this.state=State.BOGUS_COMMENT,this._stateBogusComment(e)}}_stateTagName(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:this.state=State.BEFORE_ATTRIBUTE_NAME;break;case unicode_js_1.CODE_POINTS.SOLIDUS:this.state=State.SELF_CLOSING_START_TAG;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.state=State.DATA,this.emitCurrentTagToken();break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),t.tagName+=unicode_js_1.REPLACEMENT_CHARACTER;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInTag),this._emitEOFToken();break;default:t.tagName+=String.fromCodePoint(isAsciiUpper(e)?toAsciiLower(e):e)}}_stateRcdataLessThanSign(e){e===unicode_js_1.CODE_POINTS.SOLIDUS?this.state=State.RCDATA_END_TAG_OPEN:(this._emitChars("<"),this.state=State.RCDATA,this._stateRcdata(e))}_stateRcdataEndTagOpen(e){isAsciiLetter(e)?(this.state=State.RCDATA_END_TAG_NAME,this._stateRcdataEndTagName(e)):(this._emitChars("</"),this.state=State.RCDATA,this._stateRcdata(e))}handleSpecialEndTag(e){if(!this.preprocessor.startsWith(this.lastStartTagName,!1))return!this._ensureHibernation();this._createEndTagToken();this.currentToken.tagName=this.lastStartTagName;var t=this.preprocessor.peek(this.lastStartTagName.length);switch(t){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:return this._advanceBy(this.lastStartTagName.length),this.state=State.BEFORE_ATTRIBUTE_NAME,!1;case unicode_js_1.CODE_POINTS.SOLIDUS:return this._advanceBy(this.lastStartTagName.length),this.state=State.SELF_CLOSING_START_TAG,!1;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:return this._advanceBy(this.lastStartTagName.length),this.emitCurrentTagToken(),this.state=State.DATA,!1;default:return!this._ensureHibernation()}}_stateRcdataEndTagName(e){this.handleSpecialEndTag(e)&&(this._emitChars("</"),this.state=State.RCDATA,this._stateRcdata(e))}_stateRawtextLessThanSign(e){e===unicode_js_1.CODE_POINTS.SOLIDUS?this.state=State.RAWTEXT_END_TAG_OPEN:(this._emitChars("<"),this.state=State.RAWTEXT,this._stateRawtext(e))}_stateRawtextEndTagOpen(e){isAsciiLetter(e)?(this.state=State.RAWTEXT_END_TAG_NAME,this._stateRawtextEndTagName(e)):(this._emitChars("</"),this.state=State.RAWTEXT,this._stateRawtext(e))}_stateRawtextEndTagName(e){this.handleSpecialEndTag(e)&&(this._emitChars("</"),this.state=State.RAWTEXT,this._stateRawtext(e))}_stateScriptDataLessThanSign(e){switch(e){case unicode_js_1.CODE_POINTS.SOLIDUS:this.state=State.SCRIPT_DATA_END_TAG_OPEN;break;case unicode_js_1.CODE_POINTS.EXCLAMATION_MARK:this.state=State.SCRIPT_DATA_ESCAPE_START,this._emitChars("<!");break;default:this._emitChars("<"),this.state=State.SCRIPT_DATA,this._stateScriptData(e)}}_stateScriptDataEndTagOpen(e){isAsciiLetter(e)?(this.state=State.SCRIPT_DATA_END_TAG_NAME,this._stateScriptDataEndTagName(e)):(this._emitChars("</"),this.state=State.SCRIPT_DATA,this._stateScriptData(e))}_stateScriptDataEndTagName(e){this.handleSpecialEndTag(e)&&(this._emitChars("</"),this.state=State.SCRIPT_DATA,this._stateScriptData(e))}_stateScriptDataEscapeStart(e){e===unicode_js_1.CODE_POINTS.HYPHEN_MINUS?(this.state=State.SCRIPT_DATA_ESCAPE_START_DASH,this._emitChars("-")):(this.state=State.SCRIPT_DATA,this._stateScriptData(e))}_stateScriptDataEscapeStartDash(e){e===unicode_js_1.CODE_POINTS.HYPHEN_MINUS?(this.state=State.SCRIPT_DATA_ESCAPED_DASH_DASH,this._emitChars("-")):(this.state=State.SCRIPT_DATA,this._stateScriptData(e))}_stateScriptDataEscaped(e){switch(e){case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:this.state=State.SCRIPT_DATA_ESCAPED_DASH,this._emitChars("-");break;case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:this.state=State.SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this._emitChars(unicode_js_1.REPLACEMENT_CHARACTER);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInScriptHtmlCommentLikeText),this._emitEOFToken();break;default:this._emitCodePoint(e)}}_stateScriptDataEscapedDash(e){switch(e){case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:this.state=State.SCRIPT_DATA_ESCAPED_DASH_DASH,this._emitChars("-");break;case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:this.state=State.SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this.state=State.SCRIPT_DATA_ESCAPED,this._emitChars(unicode_js_1.REPLACEMENT_CHARACTER);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInScriptHtmlCommentLikeText),this._emitEOFToken();break;default:this.state=State.SCRIPT_DATA_ESCAPED,this._emitCodePoint(e)}}_stateScriptDataEscapedDashDash(e){switch(e){case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:this._emitChars("-");break;case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:this.state=State.SCRIPT_DATA_ESCAPED_LESS_THAN_SIGN;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.state=State.SCRIPT_DATA,this._emitChars(">");break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this.state=State.SCRIPT_DATA_ESCAPED,this._emitChars(unicode_js_1.REPLACEMENT_CHARACTER);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInScriptHtmlCommentLikeText),this._emitEOFToken();break;default:this.state=State.SCRIPT_DATA_ESCAPED,this._emitCodePoint(e)}}_stateScriptDataEscapedLessThanSign(e){e===unicode_js_1.CODE_POINTS.SOLIDUS?this.state=State.SCRIPT_DATA_ESCAPED_END_TAG_OPEN:isAsciiLetter(e)?(this._emitChars("<"),this.state=State.SCRIPT_DATA_DOUBLE_ESCAPE_START,this._stateScriptDataDoubleEscapeStart(e)):(this._emitChars("<"),this.state=State.SCRIPT_DATA_ESCAPED,this._stateScriptDataEscaped(e))}_stateScriptDataEscapedEndTagOpen(e){isAsciiLetter(e)?(this.state=State.SCRIPT_DATA_ESCAPED_END_TAG_NAME,this._stateScriptDataEscapedEndTagName(e)):(this._emitChars("</"),this.state=State.SCRIPT_DATA_ESCAPED,this._stateScriptDataEscaped(e))}_stateScriptDataEscapedEndTagName(e){this.handleSpecialEndTag(e)&&(this._emitChars("</"),this.state=State.SCRIPT_DATA_ESCAPED,this._stateScriptDataEscaped(e))}_stateScriptDataDoubleEscapeStart(e){if(this.preprocessor.startsWith(unicode_js_1.SEQUENCES.SCRIPT,!1)&&isScriptDataDoubleEscapeSequenceEnd(this.preprocessor.peek(unicode_js_1.SEQUENCES.SCRIPT.length))){this._emitCodePoint(e);for(let e=0;e<unicode_js_1.SEQUENCES.SCRIPT.length;e++)this._emitCodePoint(this._consume());this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED}else this._ensureHibernation()||(this.state=State.SCRIPT_DATA_ESCAPED,this._stateScriptDataEscaped(e))}_stateScriptDataDoubleEscaped(e){switch(e){case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED_DASH,this._emitChars("-");break;case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN,this._emitChars("<");break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this._emitChars(unicode_js_1.REPLACEMENT_CHARACTER);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInScriptHtmlCommentLikeText),this._emitEOFToken();break;default:this._emitCodePoint(e)}}_stateScriptDataDoubleEscapedDash(e){switch(e){case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED_DASH_DASH,this._emitChars("-");break;case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN,this._emitChars("<");break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED,this._emitChars(unicode_js_1.REPLACEMENT_CHARACTER);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInScriptHtmlCommentLikeText),this._emitEOFToken();break;default:this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED,this._emitCodePoint(e)}}_stateScriptDataDoubleEscapedDashDash(e){switch(e){case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:this._emitChars("-");break;case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED_LESS_THAN_SIGN,this._emitChars("<");break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.state=State.SCRIPT_DATA,this._emitChars(">");break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED,this._emitChars(unicode_js_1.REPLACEMENT_CHARACTER);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInScriptHtmlCommentLikeText),this._emitEOFToken();break;default:this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED,this._emitCodePoint(e)}}_stateScriptDataDoubleEscapedLessThanSign(e){e===unicode_js_1.CODE_POINTS.SOLIDUS?(this.state=State.SCRIPT_DATA_DOUBLE_ESCAPE_END,this._emitChars("/")):(this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED,this._stateScriptDataDoubleEscaped(e))}_stateScriptDataDoubleEscapeEnd(e){if(this.preprocessor.startsWith(unicode_js_1.SEQUENCES.SCRIPT,!1)&&isScriptDataDoubleEscapeSequenceEnd(this.preprocessor.peek(unicode_js_1.SEQUENCES.SCRIPT.length))){this._emitCodePoint(e);for(let e=0;e<unicode_js_1.SEQUENCES.SCRIPT.length;e++)this._emitCodePoint(this._consume());this.state=State.SCRIPT_DATA_ESCAPED}else this._ensureHibernation()||(this.state=State.SCRIPT_DATA_DOUBLE_ESCAPED,this._stateScriptDataDoubleEscaped(e))}_stateBeforeAttributeName(e){switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:break;case unicode_js_1.CODE_POINTS.SOLIDUS:case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:case unicode_js_1.CODE_POINTS.EOF:this.state=State.AFTER_ATTRIBUTE_NAME,this._stateAfterAttributeName(e);break;case unicode_js_1.CODE_POINTS.EQUALS_SIGN:this._err(error_codes_js_1.ERR.unexpectedEqualsSignBeforeAttributeName),this._createAttr("="),this.state=State.ATTRIBUTE_NAME;break;default:this._createAttr(""),this.state=State.ATTRIBUTE_NAME,this._stateAttributeName(e)}}_stateAttributeName(e){switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:case unicode_js_1.CODE_POINTS.SOLIDUS:case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:case unicode_js_1.CODE_POINTS.EOF:this._leaveAttrName(),this.state=State.AFTER_ATTRIBUTE_NAME,this._stateAfterAttributeName(e);break;case unicode_js_1.CODE_POINTS.EQUALS_SIGN:this._leaveAttrName(),this.state=State.BEFORE_ATTRIBUTE_VALUE;break;case unicode_js_1.CODE_POINTS.QUOTATION_MARK:case unicode_js_1.CODE_POINTS.APOSTROPHE:case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:this._err(error_codes_js_1.ERR.unexpectedCharacterInAttributeName),this.currentAttr.name+=String.fromCodePoint(e);break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this.currentAttr.name+=unicode_js_1.REPLACEMENT_CHARACTER;break;default:this.currentAttr.name+=String.fromCodePoint(isAsciiUpper(e)?toAsciiLower(e):e)}}_stateAfterAttributeName(e){switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:break;case unicode_js_1.CODE_POINTS.SOLIDUS:this.state=State.SELF_CLOSING_START_TAG;break;case unicode_js_1.CODE_POINTS.EQUALS_SIGN:this.state=State.BEFORE_ATTRIBUTE_VALUE;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.state=State.DATA,this.emitCurrentTagToken();break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInTag),this._emitEOFToken();break;default:this._createAttr(""),this.state=State.ATTRIBUTE_NAME,this._stateAttributeName(e)}}_stateBeforeAttributeValue(e){switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:break;case unicode_js_1.CODE_POINTS.QUOTATION_MARK:this.state=State.ATTRIBUTE_VALUE_DOUBLE_QUOTED;break;case unicode_js_1.CODE_POINTS.APOSTROPHE:this.state=State.ATTRIBUTE_VALUE_SINGLE_QUOTED;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.missingAttributeValue),this.state=State.DATA,this.emitCurrentTagToken();break;default:this.state=State.ATTRIBUTE_VALUE_UNQUOTED,this._stateAttributeValueUnquoted(e)}}_stateAttributeValueDoubleQuoted(e){switch(e){case unicode_js_1.CODE_POINTS.QUOTATION_MARK:this.state=State.AFTER_ATTRIBUTE_VALUE_QUOTED;break;case unicode_js_1.CODE_POINTS.AMPERSAND:this.returnState=State.ATTRIBUTE_VALUE_DOUBLE_QUOTED,this.state=State.CHARACTER_REFERENCE;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this.currentAttr.value+=unicode_js_1.REPLACEMENT_CHARACTER;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInTag),this._emitEOFToken();break;default:this.currentAttr.value+=String.fromCodePoint(e)}}_stateAttributeValueSingleQuoted(e){switch(e){case unicode_js_1.CODE_POINTS.APOSTROPHE:this.state=State.AFTER_ATTRIBUTE_VALUE_QUOTED;break;case unicode_js_1.CODE_POINTS.AMPERSAND:this.returnState=State.ATTRIBUTE_VALUE_SINGLE_QUOTED,this.state=State.CHARACTER_REFERENCE;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this.currentAttr.value+=unicode_js_1.REPLACEMENT_CHARACTER;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInTag),this._emitEOFToken();break;default:this.currentAttr.value+=String.fromCodePoint(e)}}_stateAttributeValueUnquoted(e){switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:this._leaveAttrValue(),this.state=State.BEFORE_ATTRIBUTE_NAME;break;case unicode_js_1.CODE_POINTS.AMPERSAND:this.returnState=State.ATTRIBUTE_VALUE_UNQUOTED,this.state=State.CHARACTER_REFERENCE;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._leaveAttrValue(),this.state=State.DATA,this.emitCurrentTagToken();break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this.currentAttr.value+=unicode_js_1.REPLACEMENT_CHARACTER;break;case unicode_js_1.CODE_POINTS.QUOTATION_MARK:case unicode_js_1.CODE_POINTS.APOSTROPHE:case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:case unicode_js_1.CODE_POINTS.EQUALS_SIGN:case unicode_js_1.CODE_POINTS.GRAVE_ACCENT:this._err(error_codes_js_1.ERR.unexpectedCharacterInUnquotedAttributeValue),this.currentAttr.value+=String.fromCodePoint(e);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInTag),this._emitEOFToken();break;default:this.currentAttr.value+=String.fromCodePoint(e)}}_stateAfterAttributeValueQuoted(e){switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:this._leaveAttrValue(),this.state=State.BEFORE_ATTRIBUTE_NAME;break;case unicode_js_1.CODE_POINTS.SOLIDUS:this._leaveAttrValue(),this.state=State.SELF_CLOSING_START_TAG;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._leaveAttrValue(),this.state=State.DATA,this.emitCurrentTagToken();break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInTag),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.missingWhitespaceBetweenAttributes),this.state=State.BEFORE_ATTRIBUTE_NAME,this._stateBeforeAttributeName(e)}}_stateSelfClosingStartTag(e){switch(e){case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.currentToken.selfClosing=!0,this.state=State.DATA,this.emitCurrentTagToken();break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInTag),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.unexpectedSolidusInTag),this.state=State.BEFORE_ATTRIBUTE_NAME,this._stateBeforeAttributeName(e)}}_stateBogusComment(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.state=State.DATA,this.emitCurrentComment(t);break;case unicode_js_1.CODE_POINTS.EOF:this.emitCurrentComment(t),this._emitEOFToken();break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),t.data+=unicode_js_1.REPLACEMENT_CHARACTER;break;default:t.data+=String.fromCodePoint(e)}}_stateMarkupDeclarationOpen(e){this._consumeSequenceIfMatch(unicode_js_1.SEQUENCES.DASH_DASH,!0)?(this._createCommentToken(unicode_js_1.SEQUENCES.DASH_DASH.length+1),this.state=State.COMMENT_START):this._consumeSequenceIfMatch(unicode_js_1.SEQUENCES.DOCTYPE,!1)?(this.currentLocation=this.getCurrentLocation(unicode_js_1.SEQUENCES.DOCTYPE.length+1),this.state=State.DOCTYPE):this._consumeSequenceIfMatch(unicode_js_1.SEQUENCES.CDATA_START,!0)?this.inForeignNode?this.state=State.CDATA_SECTION:(this._err(error_codes_js_1.ERR.cdataInHtmlContent),this._createCommentToken(unicode_js_1.SEQUENCES.CDATA_START.length+1),this.currentToken.data="[CDATA[",this.state=State.BOGUS_COMMENT):this._ensureHibernation()||(this._err(error_codes_js_1.ERR.incorrectlyOpenedComment),this._createCommentToken(2),this.state=State.BOGUS_COMMENT,this._stateBogusComment(e))}_stateCommentStart(e){switch(e){case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:this.state=State.COMMENT_START_DASH;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.abruptClosingOfEmptyComment),this.state=State.DATA;var t=this.currentToken;this.emitCurrentComment(t);break;default:this.state=State.COMMENT,this._stateComment(e)}}_stateCommentStartDash(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:this.state=State.COMMENT_END;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.abruptClosingOfEmptyComment),this.state=State.DATA,this.emitCurrentComment(t);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInComment),this.emitCurrentComment(t),this._emitEOFToken();break;default:t.data+="-",this.state=State.COMMENT,this._stateComment(e)}}_stateComment(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:this.state=State.COMMENT_END_DASH;break;case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:t.data+="<",this.state=State.COMMENT_LESS_THAN_SIGN;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),t.data+=unicode_js_1.REPLACEMENT_CHARACTER;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInComment),this.emitCurrentComment(t),this._emitEOFToken();break;default:t.data+=String.fromCodePoint(e)}}_stateCommentLessThanSign(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.EXCLAMATION_MARK:t.data+="!",this.state=State.COMMENT_LESS_THAN_SIGN_BANG;break;case unicode_js_1.CODE_POINTS.LESS_THAN_SIGN:t.data+="<";break;default:this.state=State.COMMENT,this._stateComment(e)}}_stateCommentLessThanSignBang(e){e===unicode_js_1.CODE_POINTS.HYPHEN_MINUS?this.state=State.COMMENT_LESS_THAN_SIGN_BANG_DASH:(this.state=State.COMMENT,this._stateComment(e))}_stateCommentLessThanSignBangDash(e){e===unicode_js_1.CODE_POINTS.HYPHEN_MINUS?this.state=State.COMMENT_LESS_THAN_SIGN_BANG_DASH_DASH:(this.state=State.COMMENT_END_DASH,this._stateCommentEndDash(e))}_stateCommentLessThanSignBangDashDash(e){e!==unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN&&e!==unicode_js_1.CODE_POINTS.EOF&&this._err(error_codes_js_1.ERR.nestedComment),this.state=State.COMMENT_END,this._stateCommentEnd(e)}_stateCommentEndDash(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:this.state=State.COMMENT_END;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInComment),this.emitCurrentComment(t),this._emitEOFToken();break;default:t.data+="-",this.state=State.COMMENT,this._stateComment(e)}}_stateCommentEnd(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.state=State.DATA,this.emitCurrentComment(t);break;case unicode_js_1.CODE_POINTS.EXCLAMATION_MARK:this.state=State.COMMENT_END_BANG;break;case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:t.data+="-";break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInComment),this.emitCurrentComment(t),this._emitEOFToken();break;default:t.data+="--",this.state=State.COMMENT,this._stateComment(e)}}_stateCommentEndBang(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.HYPHEN_MINUS:t.data+="--!",this.state=State.COMMENT_END_DASH;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.incorrectlyClosedComment),this.state=State.DATA,this.emitCurrentComment(t);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInComment),this.emitCurrentComment(t),this._emitEOFToken();break;default:t.data+="--!",this.state=State.COMMENT,this._stateComment(e)}}_stateDoctype(e){switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:this.state=State.BEFORE_DOCTYPE_NAME;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.state=State.BEFORE_DOCTYPE_NAME,this._stateBeforeDoctypeName(e);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),this._createDoctypeToken(null);var t=this.currentToken;t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.missingWhitespaceBeforeDoctypeName),this.state=State.BEFORE_DOCTYPE_NAME,this._stateBeforeDoctypeName(e)}}_stateBeforeDoctypeName(e){if(isAsciiUpper(e))this._createDoctypeToken(String.fromCharCode(toAsciiLower(e))),this.state=State.DOCTYPE_NAME;else switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),this._createDoctypeToken(unicode_js_1.REPLACEMENT_CHARACTER),this.state=State.DOCTYPE_NAME;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.missingDoctypeName),this._createDoctypeToken(null);var t=this.currentToken;t.forceQuirks=!0,this.emitCurrentDoctype(t),this.state=State.DATA;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),this._createDoctypeToken(null);t=this.currentToken;t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:this._createDoctypeToken(String.fromCodePoint(e)),this.state=State.DOCTYPE_NAME}}_stateDoctypeName(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:this.state=State.AFTER_DOCTYPE_NAME;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.state=State.DATA,this.emitCurrentDoctype(t);break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),t.name+=unicode_js_1.REPLACEMENT_CHARACTER;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:t.name+=String.fromCodePoint(isAsciiUpper(e)?toAsciiLower(e):e)}}_stateAfterDoctypeName(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.state=State.DATA,this.emitCurrentDoctype(t);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:this._consumeSequenceIfMatch(unicode_js_1.SEQUENCES.PUBLIC,!1)?this.state=State.AFTER_DOCTYPE_PUBLIC_KEYWORD:this._consumeSequenceIfMatch(unicode_js_1.SEQUENCES.SYSTEM,!1)?this.state=State.AFTER_DOCTYPE_SYSTEM_KEYWORD:this._ensureHibernation()||(this._err(error_codes_js_1.ERR.invalidCharacterSequenceAfterDoctypeName),t.forceQuirks=!0,this.state=State.BOGUS_DOCTYPE,this._stateBogusDoctype(e))}}_stateAfterDoctypePublicKeyword(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:this.state=State.BEFORE_DOCTYPE_PUBLIC_IDENTIFIER;break;case unicode_js_1.CODE_POINTS.QUOTATION_MARK:this._err(error_codes_js_1.ERR.missingWhitespaceAfterDoctypePublicKeyword),t.publicId="",this.state=State.DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED;break;case unicode_js_1.CODE_POINTS.APOSTROPHE:this._err(error_codes_js_1.ERR.missingWhitespaceAfterDoctypePublicKeyword),t.publicId="",this.state=State.DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.missingDoctypePublicIdentifier),t.forceQuirks=!0,this.state=State.DATA,this.emitCurrentDoctype(t);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.missingQuoteBeforeDoctypePublicIdentifier),t.forceQuirks=!0,this.state=State.BOGUS_DOCTYPE,this._stateBogusDoctype(e)}}_stateBeforeDoctypePublicIdentifier(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:break;case unicode_js_1.CODE_POINTS.QUOTATION_MARK:t.publicId="",this.state=State.DOCTYPE_PUBLIC_IDENTIFIER_DOUBLE_QUOTED;break;case unicode_js_1.CODE_POINTS.APOSTROPHE:t.publicId="",this.state=State.DOCTYPE_PUBLIC_IDENTIFIER_SINGLE_QUOTED;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.missingDoctypePublicIdentifier),t.forceQuirks=!0,this.state=State.DATA,this.emitCurrentDoctype(t);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.missingQuoteBeforeDoctypePublicIdentifier),t.forceQuirks=!0,this.state=State.BOGUS_DOCTYPE,this._stateBogusDoctype(e)}}_stateDoctypePublicIdentifierDoubleQuoted(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.QUOTATION_MARK:this.state=State.AFTER_DOCTYPE_PUBLIC_IDENTIFIER;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),t.publicId+=unicode_js_1.REPLACEMENT_CHARACTER;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.abruptDoctypePublicIdentifier),t.forceQuirks=!0,this.emitCurrentDoctype(t),this.state=State.DATA;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:t.publicId+=String.fromCodePoint(e)}}_stateDoctypePublicIdentifierSingleQuoted(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.APOSTROPHE:this.state=State.AFTER_DOCTYPE_PUBLIC_IDENTIFIER;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),t.publicId+=unicode_js_1.REPLACEMENT_CHARACTER;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.abruptDoctypePublicIdentifier),t.forceQuirks=!0,this.emitCurrentDoctype(t),this.state=State.DATA;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:t.publicId+=String.fromCodePoint(e)}}_stateAfterDoctypePublicIdentifier(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:this.state=State.BETWEEN_DOCTYPE_PUBLIC_AND_SYSTEM_IDENTIFIERS;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.state=State.DATA,this.emitCurrentDoctype(t);break;case unicode_js_1.CODE_POINTS.QUOTATION_MARK:this._err(error_codes_js_1.ERR.missingWhitespaceBetweenDoctypePublicAndSystemIdentifiers),t.systemId="",this.state=State.DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED;break;case unicode_js_1.CODE_POINTS.APOSTROPHE:this._err(error_codes_js_1.ERR.missingWhitespaceBetweenDoctypePublicAndSystemIdentifiers),t.systemId="",this.state=State.DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.missingQuoteBeforeDoctypeSystemIdentifier),t.forceQuirks=!0,this.state=State.BOGUS_DOCTYPE,this._stateBogusDoctype(e)}}_stateBetweenDoctypePublicAndSystemIdentifiers(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.emitCurrentDoctype(t),this.state=State.DATA;break;case unicode_js_1.CODE_POINTS.QUOTATION_MARK:t.systemId="",this.state=State.DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED;break;case unicode_js_1.CODE_POINTS.APOSTROPHE:t.systemId="",this.state=State.DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.missingQuoteBeforeDoctypeSystemIdentifier),t.forceQuirks=!0,this.state=State.BOGUS_DOCTYPE,this._stateBogusDoctype(e)}}_stateAfterDoctypeSystemKeyword(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:this.state=State.BEFORE_DOCTYPE_SYSTEM_IDENTIFIER;break;case unicode_js_1.CODE_POINTS.QUOTATION_MARK:this._err(error_codes_js_1.ERR.missingWhitespaceAfterDoctypeSystemKeyword),t.systemId="",this.state=State.DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED;break;case unicode_js_1.CODE_POINTS.APOSTROPHE:this._err(error_codes_js_1.ERR.missingWhitespaceAfterDoctypeSystemKeyword),t.systemId="",this.state=State.DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.missingDoctypeSystemIdentifier),t.forceQuirks=!0,this.state=State.DATA,this.emitCurrentDoctype(t);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.missingQuoteBeforeDoctypeSystemIdentifier),t.forceQuirks=!0,this.state=State.BOGUS_DOCTYPE,this._stateBogusDoctype(e)}}_stateBeforeDoctypeSystemIdentifier(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:break;case unicode_js_1.CODE_POINTS.QUOTATION_MARK:t.systemId="",this.state=State.DOCTYPE_SYSTEM_IDENTIFIER_DOUBLE_QUOTED;break;case unicode_js_1.CODE_POINTS.APOSTROPHE:t.systemId="",this.state=State.DOCTYPE_SYSTEM_IDENTIFIER_SINGLE_QUOTED;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.missingDoctypeSystemIdentifier),t.forceQuirks=!0,this.state=State.DATA,this.emitCurrentDoctype(t);break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.missingQuoteBeforeDoctypeSystemIdentifier),t.forceQuirks=!0,this.state=State.BOGUS_DOCTYPE,this._stateBogusDoctype(e)}}_stateDoctypeSystemIdentifierDoubleQuoted(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.QUOTATION_MARK:this.state=State.AFTER_DOCTYPE_SYSTEM_IDENTIFIER;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),t.systemId+=unicode_js_1.REPLACEMENT_CHARACTER;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.abruptDoctypeSystemIdentifier),t.forceQuirks=!0,this.emitCurrentDoctype(t),this.state=State.DATA;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:t.systemId+=String.fromCodePoint(e)}}_stateDoctypeSystemIdentifierSingleQuoted(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.APOSTROPHE:this.state=State.AFTER_DOCTYPE_SYSTEM_IDENTIFIER;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter),t.systemId+=unicode_js_1.REPLACEMENT_CHARACTER;break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this._err(error_codes_js_1.ERR.abruptDoctypeSystemIdentifier),t.forceQuirks=!0,this.emitCurrentDoctype(t),this.state=State.DATA;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:t.systemId+=String.fromCodePoint(e)}}_stateAfterDoctypeSystemIdentifier(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.SPACE:case unicode_js_1.CODE_POINTS.LINE_FEED:case unicode_js_1.CODE_POINTS.TABULATION:case unicode_js_1.CODE_POINTS.FORM_FEED:break;case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.emitCurrentDoctype(t),this.state=State.DATA;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInDoctype),t.forceQuirks=!0,this.emitCurrentDoctype(t),this._emitEOFToken();break;default:this._err(error_codes_js_1.ERR.unexpectedCharacterAfterDoctypeSystemIdentifier),this.state=State.BOGUS_DOCTYPE,this._stateBogusDoctype(e)}}_stateBogusDoctype(e){var t=this.currentToken;switch(e){case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.emitCurrentDoctype(t),this.state=State.DATA;break;case unicode_js_1.CODE_POINTS.NULL:this._err(error_codes_js_1.ERR.unexpectedNullCharacter);break;case unicode_js_1.CODE_POINTS.EOF:this.emitCurrentDoctype(t),this._emitEOFToken()}}_stateCdataSection(e){switch(e){case unicode_js_1.CODE_POINTS.RIGHT_SQUARE_BRACKET:this.state=State.CDATA_SECTION_BRACKET;break;case unicode_js_1.CODE_POINTS.EOF:this._err(error_codes_js_1.ERR.eofInCdata),this._emitEOFToken();break;default:this._emitCodePoint(e)}}_stateCdataSectionBracket(e){e===unicode_js_1.CODE_POINTS.RIGHT_SQUARE_BRACKET?this.state=State.CDATA_SECTION_END:(this._emitChars("]"),this.state=State.CDATA_SECTION,this._stateCdataSection(e))}_stateCdataSectionEnd(e){switch(e){case unicode_js_1.CODE_POINTS.GREATER_THAN_SIGN:this.state=State.DATA;break;case unicode_js_1.CODE_POINTS.RIGHT_SQUARE_BRACKET:this._emitChars("]");break;default:this._emitChars("]]"),this.state=State.CDATA_SECTION,this._stateCdataSection(e)}}_stateCharacterReference(e){e===unicode_js_1.CODE_POINTS.NUMBER_SIGN?this.state=State.NUMERIC_CHARACTER_REFERENCE:isAsciiAlphaNumeric(e)?(this.state=State.NAMED_CHARACTER_REFERENCE,this._stateNamedCharacterReference(e)):(this._flushCodePointConsumedAsCharacterReference(unicode_js_1.CODE_POINTS.AMPERSAND),this._reconsumeInState(this.returnState,e))}_stateNamedCharacterReference(e){var t=this._matchNamedCharacterReference(e);if(!this._ensureHibernation())if(t){for(let e=0;e<t.length;e++)this._flushCodePointConsumedAsCharacterReference(t[e]);this.state=this.returnState}else this._flushCodePointConsumedAsCharacterReference(unicode_js_1.CODE_POINTS.AMPERSAND),this.state=State.AMBIGUOUS_AMPERSAND}_stateAmbiguousAmpersand(e){isAsciiAlphaNumeric(e)?this._flushCodePointConsumedAsCharacterReference(e):(e===unicode_js_1.CODE_POINTS.SEMICOLON&&this._err(error_codes_js_1.ERR.unknownNamedCharacterReference),this._reconsumeInState(this.returnState,e))}_stateNumericCharacterReference(e){this.charRefCode=0,e===unicode_js_1.CODE_POINTS.LATIN_SMALL_X||e===unicode_js_1.CODE_POINTS.LATIN_CAPITAL_X?this.state=State.HEXADEMICAL_CHARACTER_REFERENCE_START:isAsciiDigit(e)?(this.state=State.DECIMAL_CHARACTER_REFERENCE,this._stateDecimalCharacterReference(e)):(this._err(error_codes_js_1.ERR.absenceOfDigitsInNumericCharacterReference),this._flushCodePointConsumedAsCharacterReference(unicode_js_1.CODE_POINTS.AMPERSAND),this._flushCodePointConsumedAsCharacterReference(unicode_js_1.CODE_POINTS.NUMBER_SIGN),this._reconsumeInState(this.returnState,e))}_stateHexademicalCharacterReferenceStart(e){isAsciiHexDigit(e)?(this.state=State.HEXADEMICAL_CHARACTER_REFERENCE,this._stateHexademicalCharacterReference(e)):(this._err(error_codes_js_1.ERR.absenceOfDigitsInNumericCharacterReference),this._flushCodePointConsumedAsCharacterReference(unicode_js_1.CODE_POINTS.AMPERSAND),this._flushCodePointConsumedAsCharacterReference(unicode_js_1.CODE_POINTS.NUMBER_SIGN),this._unconsume(2),this.state=this.returnState)}_stateHexademicalCharacterReference(e){isAsciiUpperHexDigit(e)?this.charRefCode=16*this.charRefCode+e-55:isAsciiLowerHexDigit(e)?this.charRefCode=16*this.charRefCode+e-87:isAsciiDigit(e)?this.charRefCode=16*this.charRefCode+e-48:e===unicode_js_1.CODE_POINTS.SEMICOLON?this.state=State.NUMERIC_CHARACTER_REFERENCE_END:(this._err(error_codes_js_1.ERR.missingSemicolonAfterCharacterReference),this.state=State.NUMERIC_CHARACTER_REFERENCE_END,this._stateNumericCharacterReferenceEnd(e))}_stateDecimalCharacterReference(e){isAsciiDigit(e)?this.charRefCode=10*this.charRefCode+e-48:e===unicode_js_1.CODE_POINTS.SEMICOLON?this.state=State.NUMERIC_CHARACTER_REFERENCE_END:(this._err(error_codes_js_1.ERR.missingSemicolonAfterCharacterReference),this.state=State.NUMERIC_CHARACTER_REFERENCE_END,this._stateNumericCharacterReferenceEnd(e))}_stateNumericCharacterReferenceEnd(e){var t;this.charRefCode===unicode_js_1.CODE_POINTS.NULL?(this._err(error_codes_js_1.ERR.nullCharacterReference),this.charRefCode=unicode_js_1.CODE_POINTS.REPLACEMENT_CHARACTER):1114111<this.charRefCode?(this._err(error_codes_js_1.ERR.characterReferenceOutsideUnicodeRange),this.charRefCode=unicode_js_1.CODE_POINTS.REPLACEMENT_CHARACTER):(0,unicode_js_1.isSurrogate)(this.charRefCode)?(this._err(error_codes_js_1.ERR.surrogateCharacterReference),this.charRefCode=unicode_js_1.CODE_POINTS.REPLACEMENT_CHARACTER):(0,unicode_js_1.isUndefinedCodePoint)(this.charRefCode)?this._err(error_codes_js_1.ERR.noncharacterCharacterReference):!(0,unicode_js_1.isControlCodePoint)(this.charRefCode)&&this.charRefCode!==unicode_js_1.CODE_POINTS.CARRIAGE_RETURN||(this._err(error_codes_js_1.ERR.controlCharacterReference),void 0===(t=C1_CONTROLS_REFERENCE_REPLACEMENTS.get(this.charRefCode)))||(this.charRefCode=t),this._flushCodePointConsumedAsCharacterReference(this.charRefCode),this._reconsumeInState(this.returnState,e)}}function checkselfClosingNode(e,t){var _,s=(t.tagName||"").toLowerCase(),a=t.selfClosing,r=e.validator.isSupportedSelfClosing(s);e.nodeInfo.tn&&s&&!e.nodeInfo.sc&&(_=String(null==(_=t.location)?void 0:_.startLine)+","+String(null==(_=t.location)?void 0:_.startCol),r&&(_===e.nodeInfo.pos||t.type!==token_js_1.TokenType.START_TAG)||(_=e.nodeInfo.pos.split(","),e.compileResult.log.push({line:Number(_[0])||1,column:Number(_[1])||1,reason:"ERROR: tag `"+e.nodeInfo.tn+"` must be closed, please follow norm"}),e.nodeInfo={tn:"",sc:!1,pos:""})),s&&r&&(t.type!==token_js_1.TokenType.START_TAG||a||(e.nodeInfo.tn=s,e.nodeInfo.sc=!1,e.nodeInfo.pos=String(null==(_=t.location)?void 0:_.startLine)+","+String(null==(_=t.location)?void 0:_.startCol)),t.type===token_js_1.TokenType.END_TAG)&&s===e.nodeInfo.tn&&(e.nodeInfo.sc=!0),!r&&a&&t.type===token_js_1.TokenType.START_TAG&&e.compileResult.log.push({line:(null==(_=t.location)?void 0:_.startLine)||1,column:(null==(r=t.location)?void 0:r.startCol)||1,reason:"ERROR: tag `"+s+"` can not use selfClosing"})}exports.Tokenizer=Tokenizer;