"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.Preprocessor=void 0;const unicode_js_1=require("../common/unicode.js"),error_codes_js_1=require("../common/error-codes.js"),DEFAULT_BUFFER_WATERLINE=65536;class Preprocessor{constructor(t){this.handler=t,this.html="",this.pos=-1,this.lastGapPos=-2,this.gapStack=[],this.skipNextNewLine=!1,this.lastChunkWritten=!1,this.endOfChunkHit=!1,this.bufferWaterline=DEFAULT_BUFFER_WATERLINE,this.isEol=!1,this.lineStartPos=0,this.droppedBufferSize=0,this.line=1,this.lastErrOffset=-1}get col(){return this.pos-this.lineStartPos+Number(this.lastGapPos!==this.pos)}get offset(){return this.droppedBufferSize+this.pos}getError(t){var{line:s,col:i,offset:e}=this;return{code:t,startLine:s,endLine:s,startCol:i,endCol:i,startOffset:e,endOffset:e}}_err(t){this.handler.onParseError&&this.lastErrOffset!==this.offset&&(this.lastErrOffset=this.offset,this.handler.onParseError(this.getError(t)))}_addGap(){this.gapStack.push(this.lastGapPos),this.lastGapPos=this.pos}_processSurrogate(t){if(this.pos!==this.html.length-1){var s=this.html.charCodeAt(this.pos+1);if((0,unicode_js_1.isSurrogatePair)(s))return this.pos++,this._addGap(),(0,unicode_js_1.getSurrogatePairCodePoint)(t,s)}else if(!this.lastChunkWritten)return this.endOfChunkHit=!0,unicode_js_1.CODE_POINTS.EOF;return this._err(error_codes_js_1.ERR.surrogateInInputStream),t}willDropParsedChunk(){return this.pos>this.bufferWaterline}dropParsedChunk(){this.willDropParsedChunk()&&(this.html=this.html.substring(this.pos),this.lineStartPos-=this.pos,this.droppedBufferSize+=this.pos,this.pos=0,this.lastGapPos=-2,this.gapStack.length=0)}write(t,s){0<this.html.length?this.html+=t:this.html=t,this.endOfChunkHit=!1,this.lastChunkWritten=s}insertHtmlAtCurrentPos(t){this.html=this.html.substring(0,this.pos+1)+t+this.html.substring(this.pos+1),this.endOfChunkHit=!1}startsWith(s,t){if(this.pos+s.length>this.html.length)return this.endOfChunkHit=!this.lastChunkWritten,!1;if(t)return this.html.startsWith(s,this.pos);for(let t=0;t<s.length;t++)if((32|this.html.charCodeAt(this.pos+t))!==s.charCodeAt(t))return!1;return!0}peek(t){var t=this.pos+t;return t>=this.html.length?(this.endOfChunkHit=!this.lastChunkWritten,unicode_js_1.CODE_POINTS.EOF):(t=this.html.charCodeAt(t))===unicode_js_1.CODE_POINTS.CARRIAGE_RETURN?unicode_js_1.CODE_POINTS.LINE_FEED:t}advance(){if(this.pos++,this.isEol&&(this.isEol=!1,this.line++,this.lineStartPos=this.pos),this.pos>=this.html.length)return this.endOfChunkHit=!this.lastChunkWritten,unicode_js_1.CODE_POINTS.EOF;let t=this.html.charCodeAt(this.pos);return t===unicode_js_1.CODE_POINTS.CARRIAGE_RETURN?(this.isEol=!0,this.skipNextNewLine=!0,unicode_js_1.CODE_POINTS.LINE_FEED):t===unicode_js_1.CODE_POINTS.LINE_FEED&&(this.isEol=!0,this.skipNextNewLine)?(this.line--,this.skipNextNewLine=!1,this._addGap(),this.advance()):((this.skipNextNewLine=!1,unicode_js_1.isSurrogate)(t)&&(t=this._processSurrogate(t)),null===this.handler.onParseError||31<t&&t<127||t===unicode_js_1.CODE_POINTS.LINE_FEED||t===unicode_js_1.CODE_POINTS.CARRIAGE_RETURN||159<t&&t<64976||this._checkForProblematicCharacters(t),t)}_checkForProblematicCharacters(t){(0,unicode_js_1.isControlCodePoint)(t)?this._err(error_codes_js_1.ERR.controlCharacterInInputStream):(0,unicode_js_1.isUndefinedCodePoint)(t)&&this._err(error_codes_js_1.ERR.noncharacterInInputStream)}retreat(t){for(this.pos-=t;this.pos<this.lastGapPos;)this.lastGapPos=this.gapStack.pop(),this.pos--;this.isEol=!1}}exports.Preprocessor=Preprocessor;