"use strict";var css=require("css"),util=require("./lib/util"),validateItem=require("./lib/validator").validate,fs=require("fs"),path=require("path"),lodash=require("lodash"),SELECTOR_MATCHER=/^[\.#]?[A-Za-z0-9_\-:]+$/,DESCENDANT_SELECTOR_MATCHER=/^([.#]?[A-Za-z0-9_-]+(\s+|\s*>\s*))+([.#]?[A-Za-z0-9_\-:]+)$/,IMPORT_MATCHER=/(['"]([^()]+?)['"])|(['"]([^()]+?)['"]\s+(only|not)?\s?(screen)?\s?((and|or|,|not|landscape)?\s?[(]([^()])+[)]\s*)+)/g,LENGTH_REGEXP=/^[-+]?\d*\.?\d+(\S*)$/;const CARD_SELECTOR=/^[\.#][A-Za-z0-9_\-]+$/,card="card"===process.env.DEVICE_LEVEL;var ALL_SELECTOR_MATCHER=/^\*$/,ATTRIBUTE_SELECTOR=/^\[+(?![0-9])\w{0,}(\s*=\s*)((?![0-9])\w{0,}|\"\w{0,}\")\]+$/,ELEMENT_AND_ELEMENT=/^[a-zA-Z][a-zA-Z-]{0,}\s{0,}(\+\s{0,}[a-zA-Z][a-zA-Z-]{0,})+$/,CONTENT_ID=/^[a-zA-Z][a-zA-Z-]{0,}([#][a-zA-Z][a-zA-Z0-9-]{0,})(.+?::(after|before))+$/;function expand(e,o,i){"border"===o?e.value.forEach(function(e){var t;"Width"===e.type||"Color"===e.type||"Style"===e.type?(t=[o+"Top"+e.type,o+"Right"+e.type,o+"Bottom"+e.type,o+"Left"+e.type],util.splitAttr(i,e.value,t)):i[o+e.type]=e.value}):["borderTop","borderRight","borderBottom","borderLeft"].includes(o)?e.value.forEach(function(e){i[o+e.type]=e.value}):"margin"===o||"padding"===o?util.splitAttr(i,e.value,[o+"Top",o+"Right",o+"Bottom",o+"Left"]):"borderWidth"===o?util.splitAttr(i,e.value,["borderTopWidth","borderRightWidth","borderBottomWidth","borderLeftWidth"]):"borderColor"===o?util.splitAttr(i,e.value,["borderTopColor","borderRightColor","borderBottomColor","borderLeftColor"]):"borderStyle"===o?util.splitAttr(i,e.value,["borderTopStyle","borderRightStyle","borderBottomStyle","borderLeftStyle"]):"borderRadius"===o?util.splitAttr(i,e.value,["borderBottomLeftRadius","borderBottomRightRadius","borderTopLeftRadius","borderTopRightRadius"]):"gridGap"===o?util.splitAttr(i,e.value,["gridRowsGap","gridColumnsGap"]):"boxShadow"===o?e.value.forEach(function(e){"H"!==e.type&&"V"!==e.type&&"Blur"!==e.type&&"Spread"!==e.type&&"Color"!==e.type||util.splitAttr(i,e.value,[o+e.type])}):"animation"===o&&Object.assign(i,e.value)}function flexExpand(t,o){for(let e=0;e<t.declarations.length;e++){var i,r=t.declarations[e];"flex"===r.property&&(i=r.value.split(/\s+/),t.declarations.splice(e,1),1===i.length?checkFlexOne(t,o,r,i,e):2===i.length?checkFlexTwo(t,o,r,i,e):3===i.length?checkFlexThree(t,o,r,i,e):o.push({line:r.position.start.line,column:r.position.start.column,reason:"ERROR: Value `"+r.value+"` of the `"+r.property+"` attribute is incorrect."}))}}function getUnit(e){e=(e=e.toString().trim()).match(LENGTH_REGEXP);if(e){e=e[1];if(!e)return"none";if("px"===e)return"px"}return null}function checkFlexOne(e,t,o,i,r){["none","auto","initial"].includes(i[0])?e.declarations.splice(r,0,{type:"declaration",property:"flex",value:i[0],position:o.position}):"px"===getUnit(i[0])?e.declarations.splice(r,0,{type:"declaration",property:"flex-basis",value:i[0],position:o.position}):"none"===getUnit(i[0])?e.declarations.splice(r,0,{type:"declaration",property:"flex-grow",value:i[0],position:o.position}):t.push({line:o.position.start.line,column:o.position.start.column,reason:"ERROR: Value `"+o.value+"` of the `"+o.property+"` attribute is incorrect.It must be a number, a number with unit `px`, none, auto, or initial."})}function checkFlexTwo(e,t,o,i,r){"none"===getUnit(i[0])?(e.declarations.splice(r,0,{type:"declaration",property:"flex-grow",value:i[0],position:o.position}),"px"===getUnit(i[1])?e.declarations.splice(r,0,{type:"declaration",property:"flex-basis",value:i[1],position:o.position}):"none"===getUnit(i[1])?e.declarations.splice(r,0,{type:"declaration",property:"flex-shrink",value:i[1],position:o.position}):t.push({line:o.position.start.line,column:o.position.start.column,reason:"ERROR: Value `"+o.value+"` of the `"+o.property+"` attribute is incorrect. Value `"+i[1]+"` must be a number or a number with unit `px`."})):t.push({line:o.position.start.line,column:o.position.start.column,reason:"ERROR: Value `"+o.value+"` of the `"+o.property+"` attribute is incorrect. Value `"+i[0]+"` must be a number."})}function checkFlexThree(e,t,o,i,r){"none"===getUnit(i[0])&&"none"===getUnit(i[1])&&"px"===getUnit(i[2])?(e.declarations.splice(r,0,{type:"declaration",property:"flex-grow",value:i[0],position:o.position}),e.declarations.splice(r,0,{type:"declaration",property:"flex-shrink",value:i[1],position:o.position}),e.declarations.splice(r,0,{type:"declaration",property:"flex-basis",value:i[2],position:o.position})):t.push({line:o.position.start.line,column:o.position.start.column,reason:"ERROR: Value `"+o.value+"` of the `"+o.property+"` attribute is incorrect. It must be in the format of (1, 1, 1px)."})}function parse(e,t,r){var o,l={},c=[],e=css.parse(e,{silent:!0,source:r});e.stylesheet.parsingErrors&&e.stylesheet.parsingErrors.length&&(o=e.stylesheet.parsingErrors).forEach(function(e){c.push({line:e.line,column:e.column,reason:e.toString().replace("Error","ERROR")})}),e&&"stylesheet"===e.type&&e.stylesheet&&e.stylesheet.rules&&e.stylesheet.rules.length&&e.stylesheet.rules.forEach(function(n){var a,o,e=n.type,s={},i=[];"rule"===e?n.declarations&&n.declarations.length&&(flexExpand(n,i),n.declarations.forEach(function(e){var t,o;"declaration"===e.type&&(o=e.property,t=e.value,o=util.hyphenedToCamelCase(o),(t=validateItem(o,t)).value&&-1!==Object.values(util.SPLECIAL_ATTR).indexOf(o)&&expand(t,o,s),"number"!=typeof t.value&&"string"!=typeof t.value||Object.values(util.SPLECIAL_ATTR).includes(o)||(s[o]=t.value),t.log)&&(t.log.line=e.position.start.line,t.log.column=e.position.start.column,i.push(t.log))}),card&&1<n.selectors.length?c.push({line:n.position.start.line,column:n.position.start.column,reason:"ERROR: The `"+n.selectors.join(", ")+"` selector is not supported."}):n.selectors.forEach(function(e){var t,o,i,r;(card?e.match(CARD_SELECTOR):e.match(SELECTOR_MATCHER)||e.match(DESCENDANT_SELECTOR_MATCHER)||e.match(ALL_SELECTOR_MATCHER)||e.match(ATTRIBUTE_SELECTOR)||e.match(ELEMENT_AND_ELEMENT)||e.match(CONTENT_ID))?(-1<(t=(i=e).indexOf(":"))&&(o=i.slice(t),i=i.slice(0,t),r={},Object.keys(s).forEach(function(e){r[e+o]=s[e]}),s=r),Object.keys(s).forEach(function(e){var t;0===e.indexOf("transition")&&"transition"!==e&&(t=(t=e.replace("transition",""))[0].toLowerCase()+t.slice(1),l["@TRANSITION"]=l["@TRANSITION"]||{},l["@TRANSITION"][i]=l["@TRANSITION"][i]||{},l["@TRANSITION"][i][t]=s[e]),l[i]=l[i]||{},l[i][e]=s[e]})):c.push({line:n.position.start.line,column:n.position.start.column,reason:"ERROR: The `"+e+"` selector is not supported."})}),c=c.concat(i)):"font-face"===e?n.declarations&&n.declarations.length&&(n.declarations.forEach(function(e){var t;"declaration"===e.type&&(t=util.hyphenedToCamelCase(e.property),e=e.value,"fontFamily"===t&&-1<"\"'".indexOf(e[0])&&(e=e.slice(1,e.length-1)),s[t]=e)}),l["@FONT-FACE"]||(l["@FONT-FACE"]=[]),l["@FONT-FACE"].push(s)):"import"===e?parseImport(r,n,l,c):"keyframes"!==e||card?"media"===e&&(l["@MEDIA"]||(l["@MEDIA"]=[]),e=n.media,(a={}).condition=e,n.rules&&n.rules.length&&n.rules.forEach(function(n){s={},"import"===n.type&&parseImport(r,n,a,c),n.declarations&&n.declarations.length&&(flexExpand(n,i),n.declarations.forEach(function(e){var t,o;"declaration"===e.type&&(o=e.property,t=e.value,o=util.hyphenedToCamelCase(o),(t=validateItem(o,t)).value&&-1!==Object.values(util.SPLECIAL_ATTR).indexOf(o)&&expand(t,o,s),"number"!=typeof t.value&&"string"!=typeof t.value||Object.values(util.SPLECIAL_ATTR).includes(o)||(s[o]=t.value),t.log)&&(t.log.line=e.position.start.line,t.log.column=e.position.start.column,i.push(t.log))}),n.selectors.forEach(function(e){var t,o,i,r;e.match(SELECTOR_MATCHER)||e.match(DESCENDANT_SELECTOR_MATCHER)?(-1<(t=(i=e).indexOf(":"))&&(o=i.slice(t),i=i.slice(0,t),r={},Object.keys(s).forEach(function(e){r[e+o]=s[e]}),s=r),Object.keys(s).forEach(function(e){var t;0===e.indexOf("transition")&&"transition"!==e&&(t=(t=e.replace("transition",""))[0].toLowerCase()+t.slice(1),a["@TRANSITION"]=a["@TRANSITION"]||{},a["@TRANSITION"][i]=a["@TRANSITION"][i]||{},a["@TRANSITION"][i][t]=s[e]),a[i]=a[i]||{},a[i][e]=s[e]})):c.push({line:n.position.start.line,column:n.position.start.column,reason:"ERROR: The `"+e+"` selector is not supported."})}),c=c.concat(i))}),l["@MEDIA"].push(a)):(l["@KEYFRAMES"]||(l["@KEYFRAMES"]={}),o=n.name,l["@KEYFRAMES"][o]=[],n.keyframes&&n.keyframes.length&&(card?c.push({line:n.position.start.line,column:n.position.start.column,reason:"ERROR: The keyframes is not supported!"}):(n.keyframes.forEach(function(e){var t;"keyframe"===e.type&&(e.declarations&&e.declarations.length&&e.declarations.forEach(function(e){var t,o;"declaration"===e.type&&(o=e.property,t=e.value,o=util.hyphenedToCamelCase(o),(t=validateItem(o,t)).value&&-1!==Object.values(util.SPLECIAL_ATTR).indexOf(o)&&expand(t,o,s),"number"!=typeof t.value&&"string"!=typeof t.value||Object.values(util.SPLECIAL_ATTR).includes(o)||(s[o]=t.value),t.log)&&(t.log.line=e.position.start.line,t.log.column=e.position.start.column,i.push(t.log))}),"from"===e.values[0]&&(t={},Object.keys(s).forEach(function(e){t[e]=s[e]}),t.time=0,l["@KEYFRAMES"][o].push(t)),"to"===e.values[0]&&(t={},Object.keys(s).forEach(function(e){t[e]=s[e]}),t.time=100,l["@KEYFRAMES"][o].push(t)),new RegExp(/^(100|[1-9]?\d)%$/).test(e.values[0]))&&(t={},Object.keys(s).forEach(function(e){t[e]=s[e]}),t.time=e.values[0].replace("%",""),l["@KEYFRAMES"][o].push(t))}),c=c.concat(i))))}),t(o,{jsonStyle:l,log:c})}function parseImport(i,r,n,a){if(i){var s=i,l=r.import;let e,t="",o="";if(l.match(IMPORT_MATCHER)&&(c=l.match(/['"]([^()]+?)['"]/),e=c[1],t=l.replace(e,"").replace(/['"]/g,"")),/^(\.)|(\.\.)\//.test(e)&&(i=i.substring(0,i.lastIndexOf(path.sep)+1),e=path.resolve(i,e)),!fs.existsSync(e)){var c=findFile(e);if(1!=c.result)return writeErrorOption(),void a.push({line:r.position.start.line,column:r.position.start.column,reason:"ERROR: no such file or directory, open "+e});e=c.filePath}o=fs.readFileSync(e).toString(),addPreviewCSS(e,s),parse(o=0!==t.length?"@media "+t+"{\n"+o+"\n}":o,(e,t)=>{if(e)throw e;n=Object.assign(n,t.jsonStyle)},e)}}function addPreviewCSS(e,t){var o;e=path.join(e),t=path.join(t),fs.existsSync(process.env.watchCSSFiles)&&((o=JSON.parse(fs.readFileSync(process.env.watchCSSFiles))).entry&&o.entry[t]?(o[e]=o[e]||[],o[e].push(t),o[e]=lodash.uniqWith(o[e],lodash.isEqual)):o[t]&&(o[e]=o[e]||[],o[e].push(...o[t]),o[e]=lodash.uniqWith(o[e],lodash.isEqual)),o.atime=o.atime||{},o.atime[e]=fs.statSync(e).atime.toString(),fs.writeFileSync(process.env.watchCSSFiles,JSON.stringify(o,null,2)))}function findFile(t){const o={result:!1};if(t&&process.env.resolveModules)try{JSON.parse(process.env.resolveModules).forEach(e=>{if(fs.existsSync(e)){if(fs.existsSync(path.join(e,t)))return o.result=!0,o.filePath=path.join(e,t),o}else{e=path.resolve(__dirname,e);if(fs.existsSync(e))return o.result=!0,o.filePath=path.join(e,t),o}})}catch(e){o.result=!1}return o}function writeErrorOption(){var e;fs.existsSync(process.env.watchCSSFiles)&&((e=JSON.parse(fs.readFileSync(process.env.watchCSSFiles))).clear=!0,fs.writeFileSync(process.env.watchCSSFiles,JSON.stringify(e,null,2)))}function validate(t,e){var o,i=[];try{t=JSON.parse(JSON.stringify(t))}catch(e){o=e,t={}}Object.keys(t).forEach(function(e){var o=t[e];Object.keys(o).forEach(function(e){var t=o[e],t=validateItem(e,t);"number"==typeof t.value||"string"==typeof t.value?o[e]=t.value:delete o[e],t.log&&i.push(t.log)})}),e(o,{jsonStyle:t,log:i})}module.exports={parse:parse,validate:validate,validateItem:validateItem,util:util,expand:expand,getUnit:getUnit};