const bind=require("./bind"),styler=require("../styler"),styleValidator=require("../styler/lib/validator"),OHOS_THEME_PROP_GROUPS=require("../theme/ohosStyles"),path=require("path"),projectPath=process.env.aceModuleRoot||process.cwd(),transContent=require("./content"),REG_TAG_DATA_ATTR=/^data-\w+/,REG_EVENT=/([^(]*)\((.+)\)/,REG_DATA_BINDING=/{{{(.+?)}}}|{{(.+?)}}/,{DEVICE_LEVEL,PLATFORM}=require("../../lib/lite/lite-enum"),{richCommonTag,richNativeTag}=require("./rich_component_map"),{liteCommonTag,liteNativeTag}=require("./lite_component_map"),{cardCommonTag,cardNativeTag}=require("./card_component_map"),card=process.env.DEVICE_LEVEL===DEVICE_LEVEL.CARD,nativeTag=process.env.DEVICE_LEVEL===DEVICE_LEVEL.LITE?liteNativeTag:card?cardNativeTag:richNativeTag,commonTag=process.env.DEVICE_LEVEL===DEVICE_LEVEL.LITE?liteCommonTag:card?cardCommonTag:richCommonTag,tagSelfClosing=[],tagWithoutRoot=[],tagWithoutChild=[],tagWithTextContent=[],tagWithAll=[],tagWithPath=[],aliasTagMap={},attrTagMap={},funcAttrTagMap={},defaultAttrTagMap={},requireAttrTagMap={},enumAttrTagMap={},rootAttrTagMap={},parentsTagMap={},childrenTagMap={},unSupportedChildren={},eventsTagMap={};let elementNames={};function validateTagName(e,t,a){var n=e.tagName,i=e.childNodes||[],o=e.sourceCodeLocation?{line:e.sourceCodeLocation.startLine,col:e.sourceCodeLocation.endLine}:{},l=t.deps,s=t.jsonTemplate,t=t.log,r=process.env.DEVICE_LEVEL===DEVICE_LEVEL.LITE?"ERROR":"WARNING",c=e.__location||e.sourceCodeLocation?{line:e.sourceCodeLocation.startLine,col:e.sourceCodeLocation.endLine}:{},u=elementNames[a]||[],u=(tagWithAll.includes(n)||"img"===n||u.includes(n)||t.push({line:o.line||1,column:o.col||1,reason:r+": The `"+n+"` tag is not supported."}),process.env.DEVICE_LEVEL===DEVICE_LEVEL.RICH&&["dialog","popup","badge","list-item"].includes(n)&&checkOneChild(n,i,c,t),l[n]||"string"!=typeof n||l.push(n),e.attrs||[]),p=[];for(const E of u)p.push(E.name.toLowerCase());setDebugLine(s,a,o.line),validateAliasTagMap(n,s,o,t),validateTagWithoutRoot(e,n,p,o,t),validateName(n,i,o,t),validateForAttr(n,u,p,o,t),validatorLite(n,u,p,t,o)}function validateName(e,t,a,n){validateAtomicTag(e,t,a,n),validateTagWithAll(e,t,a,n)}function validateForAttr(e,t,a,n,i){validateAttrTagMap(e,a,n,i),validateDefaultAttrTagMap(e,t,a,n,i),validateRequireAttrTagMap(e,a,n,i),validateEnumAttrTagMap(e,a,t,n,i),validateFuncAttrTagMap(e,a,t,n,i),validateEventsTagMap(e,a,n,i)}function checkOneChild(e,t,a,n){1<t.filter(e=>e&&"#text"!==e.nodeName&&"#comment"!==e.nodeName).length&&n.push({line:a.line||1,column:a.col||1,reason:"ERROR: The `"+e+"` tag can have only one child node."})}function validateTagWithoutRoot(e,t,a,n,i){e._isroot&&(-1!==tagWithoutRoot.indexOf(t)&&i.push({line:n.line||1,column:n.col||1,reason:"ERROR: component `"+t+"` can not as root component."}),rootAttrTagMap[t])&&rootAttrTagMap.forEach(function(e){a[e]&&i.push({line:n.line||1,column:n.col||1,reason:"ERROR: root node `"+t+"` can not use attr `"+e+"`"})})}function validateAliasTagMap(e,t,a,n){aliasTagMap[e]&&("img"!==e&&n.push({line:a.line||1,column:a.col||1,reason:"NOTE: tag name `"+e+"` is automatically changed to `"+aliasTagMap[e]+"`"}),e=aliasTagMap[e]),t.type=e}function validateAtomicTag(t,e,a,n){0<=tagWithoutChild.indexOf(t)&&0<e.length&&!isSupportedSelfClosing(t)&&(tagWithTextContent.indexOf(t)<0?e.every(function(e){return"#text"===e.nodeName||"#comment"===e.nodeName||n.push({line:a.Line||1,column:a.Col||1,reason:"ERROR: tag `"+t+"` should just have one text node only"})}):e.every(function(e){return"#text"===e.nodeName||"#comment"===e.nodeName||n.push({line:a.Line||1,column:a.Col||1,reason:"ERROR: tag `"+t+"` should not have children"})}))}function validateAttrTagMap(t,e,a,n){"img"===t&&(t="image"),attrTagMap[t]&&e.forEach(function(e){"stroke-width"===e?e="strokeWidth":"fill-opacity"===e?e="fillOpacity":"stroke-dasharray"===e?e="strokeDasharray":"stroke-dashoffset"===e?e="strokeDashoffset":"stroke-linecap"===e?e="strokeLinecap":"fill-rule"===e?e="fillRule":"stroke-linejoin"===e?e="strokeLinejoin":"stroke-miterlimit"===e?e="strokeMiterlimit":"font-size"===e?e="fontSize":"stroke-opacity"===e&&(e="strokeOpacity"),e.match(EVENT_START_REGEXP)||e in attrTagMap[t]||(e in commonTag.attrs?n.push({line:a.line||1,column:a.col||1,reason:"WARNING: tag `"+t+"` not support attr `"+e+"`"}):validateDataAttr(e)||n.push({line:a.line||1,column:a.col||1,reason:"WARNING: tag `"+t+"` use customize attr `"+e+"`"}))})}function validateDefaultAttrTagMap(a,n,i,o,l){defaultAttrTagMap[a]&&Object.keys(defaultAttrTagMap[a]).forEach(function(e){var t=i.indexOf(e);0<=t&&""===n[t].value&&(n[t].value=defaultAttrTagMap[a][e],"else"!==e)&&l.push({line:o.line||1,column:o.col||1,reason:"WARNING: tag `"+a+"` attr `"+e+"`is null"})})}function validateRequireAttrTagMap(t,a,n,i){requireAttrTagMap[t]&&requireAttrTagMap[t].forEach(function(e){a.indexOf(e)<0&&i.push({line:n.line||1,column:n.col||1,reason:"ERROR: tag `"+t+"` not define attr `"+e+"`"})})}function validateEnumAttrTagMap(i,o,l,s,r){enumAttrTagMap[i]&&Object.keys(enumAttrTagMap[i]).forEach(function(e){var t,a,n=o.indexOf(e);0<=n&&(t=l[n].value.trim(),REG_DATA_BINDING.test(t)||(a=enumAttrTagMap[i][e]).indexOf(t)<0&&(l[n].value=a[0],r.push({line:s.line||1,column:s.col||1,reason:"ERROR: tag `"+i+"` attr `"+e+"` value `"+t+"` is illegal"})))})}function validateFuncAttrTagMap(i,o,l,s,r){funcAttrTagMap[i]&&Object.keys(funcAttrTagMap[i]).forEach(function(e){var t,a,n=o.indexOf(e);0<=n&&(t=l[n].value,REG_DATA_BINDING.test(t)||(a=funcAttrTagMap[i][e],"function"==typeof(a=styleValidator.validateFuncMap[a])&&(a=a(t))&&a.reason&&(l[n].value=a.value,n=a.reason(e,t,a.value),r.push({line:s.line||1,column:s.col||1,reason:n}))))})}function validateEventsTagMap(t,e,a,n){if(eventsTagMap[t]){const i=eventsTagMap[t];e.forEach(function(e){e.match(EVENT_START_REGEXP)&&(e=(e=e.replace(EVENT_START_REGEXP,"")).match(TOUCH_CAPTURE_EVENT_REGEXP)&&process.env.DEVICE_LEVEL===DEVICE_LEVEL.RICH&&process.env.PLATFORM_VERSION===PLATFORM.VERSION6?e:e.replace(EVENT_END_REGEXP,""),i.indexOf(e.toLowerCase())<0)&&n.push({line:a.line||1,column:a.col||1,reason:"WARNING: tag `"+t+"` not support event `"+e+"`"})})}}function validateTagWithAll(i,e,o,l){if(0<=tagWithAll.indexOf(i)&&0<e.length){const s=childrenTagMap[i],r=unSupportedChildren[i],c="tabs"===i;let a=void 0,n=void 0;c&&(n=0,a=0),e.forEach(function(t){if(0<=tagWithAll.indexOf(t.nodeName)){var e=parentsTagMap[t.nodeNames];if((e&&e.indexOf(i)<0||s&&s.indexOf(t.nodeName)<0||r&&0<=r.indexOf(t.nodeName))&&(l.push({line:o.line||1,column:o.col||1,reason:"ERROR: tag `"+i+"` not support child tag `"+t.nodeName+"`"}),c)){let e=0;"tab-content"===t.nodeName&&(e=++a),1<(e="tab-bar"===t.nodeName?++n:e)&&l.push({line:o.line||1,column:o.col||1,reason:"ERROR: tag  `tabs` child tag `"+t.nodeName+"` support at most one"})}}})}}function validatorLite(e,t,a,n,i){process.env.DEVICE_LEVEL===DEVICE_LEVEL.LITE&&(inputLite(e,t,a,n,i),ismatchIfAndFor(a)&&n.push({line:i.line||1,column:i.col||1,reason:"ERROR: in tag `"+e+"` not support writing `if` and `for` in the same component"}),classLite(e,t,n,i))}function inputLite(e,t,a,n,i){let o;"input"===e&&(t.map(function(e){"type"===e.name&&(o=e.value)}),isMatchChange(o,a))&&n.push({line:i.line||1,column:i.col||1,reason:"ERROR: tag `"+e+"` not support event `change` when the type is not checkbox and radio"})}function isMatchChange(e,t){return!["checkbox","password","radio","text"].includes(e)&&(t.includes("onchange")||t.includes("@change"))}function ismatchIfAndFor(e){return e.includes("if")&&e.includes("for")}function classLite(t,e,a,n){e.map(function(e){"class"===e.name&&bind.containExp(e.value)&&a.push({line:n.line||1,column:n.col||1,reason:"ERROR: in tag `"+t+"` class selector does not support data binding."})})}function validateClass(classNames,out,nodeLoc,relativePath){classNames=classNames.trim(),setDebugLine(out.jsonTemplate,relativePath,nodeLoc.line,classNames),bind.containExp(classNames)?out.jsonTemplate.classList=eval(bind.transExpForList(classNames)):out.jsonTemplate.classList=classNames.split(/\s+/)}function preprocessSystemResourceReference(e,t){if(2===e.length){var a=e[0].trim().replace(/-([a-z])/g,function(e,t){return t.toUpperCase()}),e=e[1].trim(),n=/{{\s*\$r\s*\(\s*(['"]ohos\.(?<resName>\w+)['"])\s*\)\s*}}/.exec(e);if(n){var i=n.groups.resName;if(i&&OHOS_THEME_PROP_GROUPS[i])return t[a]="@ohos_id_"+OHOS_THEME_PROP_GROUPS[i],!0}if(n=/{{\s*\$r\s*\(\s*(['"]sys\.(?<resType>\w+)\.(?<resName>\w+)['"])\s*\)\s*}}/.exec(e)){var i=n.groups.resName,o=n.groups.resType;if(i&&o&&OHOS_THEME_PROP_GROUPS[i])return t[a]="@sys."+o+"."+OHOS_THEME_PROP_GROUPS[i],!0}if(n=/{{\s*\$r\s*\(\s*(['"]app\.(?<resType>\w+)\.(?<resName>\w+)['"])\s*\)\s*}}/.exec(e)){o=n.groups.resName,i=n.groups.resType;if(o&&i)return t[a]="@app."+i+"."+o,!0}}return!1}function validateItem(e,t,a,n){e=styler.validateItem(e,t);return e.log&&n.push({line:a.line||1,column:a.col||1,reason:e.log.reason}),e}function validateStyle(e,t,a,n){var i,o,l=t.log;e?(i={},o=e.split(";"),processCssArray(e,t,a,i,o,l),t.jsonTemplate.style=i,setDebugLine(t.jsonTemplate,n,a.line)):l.push({line:a.line||1,column:a.col||1,reason:"WARNING: style attr is null"})}function processCssArray(a,n,i,o,l,s){for(let t=0;t<l.length;t++){let e=l[t].trim().split(":");var r,c,u;preprocessSystemResourceReference(e,o)||(2===e.length&&(c=e[0].trim().replace(/-([a-z])/g,function(e,t){return t.toUpperCase()}),u=bind(e[1].trim(),void 0,!0,n,i),(r=e[1].trim().toString()).match(/^linear-gradient/)&&r.match(/\(.*\{\{.*\}\}.*\)/)&&s.push({line:i.line||1,column:i.col||1,reason:"ERROR: can not bind data for linear-gradient in inline style at "+a}),"flex"===c&&"string"==typeof u?expandFlex(c,u,o,i,s):(u=(r=validateItem(c,u,i,s)).value,["[object Number]","[object String]","[object Function]","[object Object]","[object Array]"].includes(Object.prototype.toString.call(u))&&expandStyle(c,u,r,o,n,i,s))),2<e.length&&(e[1]=e.slice(1).join(":"),e=e.slice(0,2),REG_DATA_BINDING.test(e[1])?(e[0]=e[0].trim().replace(/-([a-z])/g,function(e,t){return t.toUpperCase()}),o[e[0]]=bind(e[1],void 0,!0,n,i)):"backgroundImage"===(c=e[0].trim().replace(/-([a-z])/g,function(e,t){return t.toUpperCase()}))&&(u=validateItem(c,e[1].trim(),i,s),o[c]=u.value)))}}function expandFlex(e,t,a,n,i){var o=t.split(/\s+/);1===o.length?expandFlexOne(e,o,a,n,i):2===o.length?expandFlexTwo(e,t,o,a,n,i):3===o.length?expandFlexThree(e,t,o,a,n,i):i.push({line:n.line,column:n.column,reason:"ERROR: Value `"+t+"` of the `"+e+"` attribute is incorrect."})}function expandFlexOne(e,t,a,n,i){["none","auto","initial"].includes(t[0])?a.flex=t[0]:"px"===styler.getUnit(t[0])?a.flexBasis=t[0]:"none"===styler.getUnit(t[0])?a.flexGrow=t[0]:i.push({line:n.line,column:n.column,reason:"ERROR: Value `"+t[0]+"` of the `"+e+"` attribute is incorrect.It must be a number, a number with unit `px`, none, auto, or initial."})}function expandFlexTwo(e,t,a,n,i,o){"none"===styler.getUnit(a[0])?(n.flexGrow=a[0],"px"===styler.getUnit(a[1])?n.flexBasis=a[1]:"none"===styler.getUnit(a[1])?n.flexShrink=a[1]:o.push({line:i.line,column:i.column,reason:"ERROR: Value `"+t+"` of the `"+e+"` attribute is incorrect. Value `"+a[1]+"` must be a number or a number with unit `px`."})):o.push({line:i.line,column:i.column,reason:"ERROR: Value `"+t+"` of the `"+e+"` attribute is incorrect. Value `"+a[0]+"` must be a number."})}function expandFlexThree(e,t,a,n,i,o){"none"===styler.getUnit(a[0])&&"none"===styler.getUnit(a[1])&&"px"===styler.getUnit(a[2])?(n.flexGrow=a[0],n.flexShrink=a[1],n.flexBasis=a[2]):o.push({line:i.line,column:i.column,reason:"ERROR: Value `"+t+"` of the `"+e+"` attribute is incorrect. It must be in the format of (1, 1, 1px)."})}function expandStyle(e,t,a,n,i,o,l){Object.values(styler.util.SPLECIAL_ATTR).includes(e)&&"function"!=typeof t?styler.expand(a,e,n):process.env.DEVICE_LEVEL===DEVICE_LEVEL.LITE&&"border"===e&&"function"==typeof t?l.push({line:o.line||1,column:o.col||1,reason:"ERROR: "+e+" shorthand inline style does not support data binding."}):process.env.DEVICE_LEVEL===DEVICE_LEVEL.LITE&&"list"===i.jsonTemplate.type&&"flexDirection"==e&&"function"==typeof t?l.push({line:o.line||1,column:o.col||1,reason:"ERROR: `list` tag `flex-direction` inline style does not support data binding."}):n[e]=t}function validateIf(e,t,a,n,i){REG_DATA_BINDING.test(e)||("false"===e.trim()?e=!card&&"{{false}}":"true"===e.trim()?e=!!card||"{{true}}":t.log.push({line:n.line||1,column:n.col||1,reason:"ERROR: if value cannot be "+e+". The default value is true or false."})),a&&(o=e.replace("{{","").replace("}}",""),e=card?REG_DATA_BINDING.test(e)?"!{{"+o+"}}":"!"+o:"{{!("+o+")}}");var o=bind(e,void 0,!1,t,n),e=card&&a&&/\$f/.test(o)?o.substr(3,o.length-4):o;t.jsonTemplate.shown=e,setDebugLine(t.jsonTemplate,i,n.line)}function validateElif(e,t,a,n,i){(e=REG_DATA_BINDING.test(e)?e:card?e:"{{"+e+"}}")&&(a&&(a=e.indexOf("&&"),e=(card?REG_DATA_BINDING.test(e)?"!{{"+e.substr(2,a-2):"!"+e.substr(0,a):"{{!("+e.substr(2,a-2)+")")+e.substr(a,e.length)),a=bind(e,void 0,!1,t,n),t.jsonTemplate.shown=card&&/\$f/.test(a)?a.substr(3,a.length-4):a,setDebugLine(t.jsonTemplate,i,n.line))}function validateFor(t,a,n,i){var e=a.log;if(t){let e;var o,l=(t=t.startsWith("{{")&&t.endsWith("}}")?t.substr(2,t.length-4):t).match(/(?<=in\s)(.*)/),s=t.match(/(.*)(?=\s+in\s+)/);l&&s?(o=s[0].match(/\((.*),(.*)\)/),e={exp:bind("{{"+l[0].trim()+"}}",void 0,!1,a,n)},o?(e.key=o[1].trim(),e.value=o[2].trim()):e.value=s[0].trim()):e=bind("{{"+t+"}}",void 0,!1,a,n),a.jsonTemplate.repeat=e,setDebugLine(a.jsonTemplate,i,n.line)}else e.push({line:n.line||1,column:n.col||1,reason:"WARNING: for attr is null"})}function validateId(e,t,a,n){e&&(t.jsonTemplate.id=REG_DATA_BINDING.test(e)?bind(e,void 0,!0,t,a):e,setDebugLine(t.jsonTemplate,n,a.line),card||(t.jsonTemplate.attr=t.jsonTemplate.attr||{},t.jsonTemplate.attr[styler.util.hyphenedToCamelCase("id")]=bind(e,void 0,!0,t,a)))}function validateAppend(e,t,a,n){e&&(t.jsonTemplate.append=bind(e,void 0,!0,t,a),setDebugLine(t.jsonTemplate,n,a.line))}!function(){for(const l of Object.keys(nativeTag)){if(nativeTag[l].selfClosing&&tagSelfClosing.push(l),nativeTag[l].excludeRoot&&tagWithoutRoot.push(l),nativeTag[l].atomic&&tagWithoutChild.push(l),nativeTag[l].textContent&&tagWithTextContent.push(l),tagWithAll.push(l),nativeTag[l].alias&&nativeTag[l].alias.length)for(const s of nativeTag[l].alias)aliasTagMap[s]=l;var e={},t=(nativeTag[l].uattrs?Object.assign(e,nativeTag[l].uattrs,{}):Object.assign(e,nativeTag[l].attrs,commonTag.attrs),attrTagMap[l]=e,{}),a={},n=[],i={},o=[];for(const r of Object.keys(e))e[r].checkFunc&&(t[r]=e[r].checkFunc),e[r].def&&(a[r]=e[r].def),e[r].required&&n.push(r),e[r].enum&&0<e[r].enum.length&&(i[r]=e[r].enum,a[r]=e[r].enum[0]),e[r].excludeRoot&&o.push(r),e[r].checkPath&&tagWithPath.push(r);funcAttrTagMap[l]=t,defaultAttrTagMap[l]=a,requireAttrTagMap[l]=n,enumAttrTagMap[l]=i,rootAttrTagMap[l]=o,nativeTag[l].parents&&(parentsTagMap[l]=nativeTag[l].parents.concat(commonTag.parents)),nativeTag[l].children&&(childrenTagMap[l]=nativeTag[l].children.concat(commonTag.children)),nativeTag[l].unSupportedChildren&&(unSupportedChildren[l]=nativeTag[l].unSupportedChildren.concat(commonTag.unSupportedChildren)),nativeTag[l].uevents?eventsTagMap[l]=nativeTag[l].uevents.concat(nativeTag[l].events):eventsTagMap[l]=[].concat(commonTag.events).concat(nativeTag[l].events)}}();const EVENT_START_REGEXP=/^(on:|on|@|grab:)/,EVENT_END_REGEXP=/(\.bubble|\.capture)$/,START_CATCH_REGEXP=/^(grab:)/,END_CAPTURE_REGEXP=/(\.capture)$/,TOUCH_EVENT_REGEXP=/^(touch)/,CLICK_EVENT_REGEXP=/^(click)$/,TOUCH_CAPTURE_EVENT_REGEXP=/^(?!touch).*?(\.capture)$/;function validateEvent(eventName,val,out,pos,relativePath){const tempName=eventName.replace(EVENT_START_REGEXP,""),name=tempName.match(TOUCH_CAPTURE_EVENT_REGEXP)&&process.env.PLATFORM_VERSION===PLATFORM.VERSION6&&process.env.DEVICE_LEVEL===DEVICE_LEVEL.RICH?tempName:tempName.replace(EVENT_END_REGEXP,"");if(name&&val)if(card&&val.match(/(.*)\((.*)\)/))out.log.push({line:pos.line||1,column:pos.col||1,reason:"ERROR: The event `"+val+"` does not support."});else{REG_DATA_BINDING.test(val)&&(val=bind.removeAllExpFix(val.trim()));const empty=val.match(/(.*)\(\)$/);if(empty)val=empty[1];else{const content=val.match(REG_EVENT);if(content){const functionName=content[1];let paramList=content[2];paramList&&(paramList=transContent.parseExpression(paramList,!0),val=eval("(function (evt) {"+bind("{{"+functionName+"("+paramList+",evt)}}",!1,!0,out,pos)+"})"))}}distributeEvent(out,eventName,name,val),setDebugLine(out.jsonTemplate,relativePath,pos.line)}}function distributeEvent(e,t,a,n){process.env.DEVICE_LEVEL!==DEVICE_LEVEL.LITE&&!TOUCH_EVENT_REGEXP.test(a)||process.env.PLATFORM_VERSION===PLATFORM.VERSION3?process.env.DEVICE_LEVEL===DEVICE_LEVEL.RICH&&CLICK_EVENT_REGEXP.test(a)&&!t.match(END_CAPTURE_REGEXP)&&process.env.PLATFORM_VERSION===PLATFORM.VERSION6?t.match(START_CATCH_REGEXP)?(e.jsonTemplate.catchBubbleEvents=e.jsonTemplate.catchBubbleEvents||{},e.jsonTemplate.catchBubbleEvents[a]=n):(e.jsonTemplate.onBubbleEvents=e.jsonTemplate.onBubbleEvents||{},e.jsonTemplate.onBubbleEvents[a]=n):(e.jsonTemplate.events=e.jsonTemplate.events||{},e.jsonTemplate.events[a]=n):t.match(START_CATCH_REGEXP)?t.match(END_CAPTURE_REGEXP)?(e.jsonTemplate.catchCaptureEvents=e.jsonTemplate.catchCaptureEvents||{},e.jsonTemplate.catchCaptureEvents[a]=n):(e.jsonTemplate.catchBubbleEvents=e.jsonTemplate.catchBubbleEvents||{},e.jsonTemplate.catchBubbleEvents[a]=n):t.match(END_CAPTURE_REGEXP)?(e.jsonTemplate.onCaptureEvents=e.jsonTemplate.onCaptureEvents||{},e.jsonTemplate.onCaptureEvents[a]=n):(e.jsonTemplate.onBubbleEvents=e.jsonTemplate.onBubbleEvents||{},e.jsonTemplate.onBubbleEvents[a]=n)}const transArray=[/\\a/g,/\\b/g,/\\f/g,/\\n/g,/\\r/g,/\\t/g,/\\v/g,/\\\\/g,/\\'/g,/\\"/g,/\\0/g],transReplaceArray=["a","\b","\f","\n","\r","\t","\v","\\","'",'"',"\0"];function validateAttr(e,t,a,n,i,o,l){if(card&&"tid"===t&&bind.isExp(a)&&n.log.push({line:o.line,column:o.col,reason:"ERROR: The 'tid' does not support the expression."}),"value"===t&&transArray.forEach((e,t)=>{a=a.replace(e,transReplaceArray[t])}),t&&("string"==typeof a||"number"==typeof a)&&a){if("value"===t&&"text"===i&&n.log.push({line:o.line,column:o.col,reason:"WARNING: `value` content could be written between <text> and </text>"}),getAttrValue(/{{\s*\$r\s*\(\s*(['"]sys\.media\.(?<resName>\w+)['"])\s*\)\s*}}/.exec(a),a,!0),getAttrValue(/{{\s*\$r\s*\(\s*(['"]app\.media\.(?<resName>\w+)['"])\s*\)\s*}}/.exec(a),a,!1),0<=tagWithPath.indexOf(t)&&a.match(/^\.\.\/|^\.\//)){if(!e)return;0<=a.indexOf("./")&&(e=e.substring(0,e.lastIndexOf(path.sep)+1),a=path.resolve(e,a)),a=a.replace(projectPath,"").replace(/\\/g,"/")}n.jsonTemplate.attr=n.jsonTemplate.attr||{},n.jsonTemplate.attr[t.replace(/-([a-z])/g,function(e,t){return t.toUpperCase()})]=bind(a,void 0,!0,n,o),setDebugLine(n.jsonTemplate,l,o.line)}}function getAttrValue(e,t,a){var n;e&&a?(n=e.groups.resName)&&OHOS_THEME_PROP_GROUPS[n]&&OHOS_THEME_PROP_GROUPS[n]:e&&!a&&e.groups.resName}function validateAttrElif(t,a,e,n,i,o,l){if(t&&t.attrs)for(let e=0;e<t.attrs.length;e++){var s,r,c=t.attrs[e],u=a.replace("{{","").replace("}}","");"if"===c.name&&(s=c.value.replace("{{","").replace("}}",""),validateElif(a=card?REG_DATA_BINDING.test(a)?"{{"+u+"}}&&!{{"+s+"}}":u+" && !"+s:"{{"+u+"&&!("+s+")}}",i,!1,o,l)),"elif"===c.name&&(s=c.value.indexOf("&&"),r=c.value.substr(0,s).replace("{{",""),c=c.value.substr(s,c.value.length),validateElif(a=card?REG_DATA_BINDING.test(a)?"{{"+u+"}}&&!{{"+r+c:u+" && !"+r+c:"{{"+u+"&&!("+r+")"+c,i,!1,o,l))}e[n].value=a}function validateAttrElse(t,a,n,i){if(t&&t.attrs)for(let e=0;e<t.attrs.length;e++){var o=t.attrs[e];"if"===o.name&&validateIf(o.value,a,!0,n,i),"elif"===o.name&&validateElif(o.value,a,!0,n,i)}}function parseDataAttr(e,t,a){e=e.replace("data-","");a.jsonTemplate.attr=a.jsonTemplate.attr||{},a.jsonTemplate.attr.$data=a.jsonTemplate.attr.$data||{},a.jsonTemplate.attr.$data[e]=bind(t,void 0,!0,a)}function isSupportedSelfClosing(e){if(e&&"string"==typeof e){var t=aliasTagMap[e];if(t){if(nativeTag[t]&&-1!==tagSelfClosing.indexOf(t))return!0}else if(nativeTag[e]&&-1!==tagSelfClosing.indexOf(e))return!0}return!1}function validateDataAttr(e){return REG_TAG_DATA_ATTR.test(e)}function isReservedTag(e){return-1!==tagWithAll.indexOf(e)}function setDebugLine(e,t,a,n){e.attr=e.attr||{},process.env.DEVICE_LEVEL===DEVICE_LEVEL.RICH&&"debug"===process.env.buildMode&&(e.attr.debugLine=t+":"+a,n)&&(e.attr.className=n)}module.exports={validateTagName:validateTagName,validateId:validateId,validateClass:validateClass,validateStyle:validateStyle,validateIf:validateIf,validateElif:validateElif,validateFor:validateFor,validateAppend:validateAppend,validateEvent:validateEvent,validateAttr:validateAttr,validateAttrElse:validateAttrElse,validateAttrElif:validateAttrElif,parseDataAttr:parseDataAttr,isReservedTag:isReservedTag,isSupportedSelfClosing:isSupportedSelfClosing,elementNames:elementNames};